
This is a patch file against 0.2.11.

Change to directory gnupg-0.2.11 (or however you renamed it)
and give this command:

     zcat somepath/gnupg-0.2.12.diff.gz | patch -p1

It is a good idea to rename your current directory to gnupg-0.2.12 now.



Prereq: 0.2.11

diff -urN gnupg-0.2.11/VERSION gnupg-0.2.12/VERSION
--- gnupg-0.2.11/VERSION	Mon Mar  2 22:01:11 1998
+++ gnupg-0.2.12/VERSION	Sat Mar  7 12:39:58 1998
@@ -1 +1 @@
-0.2.11
+0.2.12

diff -urN gnupg-0.2.11/ChangeLog gnupg-0.2.12/ChangeLog
--- gnupg-0.2.11/ChangeLog	Fri Feb 27 13:14:41 1998
+++ gnupg-0.2.12/ChangeLog	Wed Mar  4 10:33:11 1998
@@ -1,3 +1,7 @@
+Wed Mar  4 10:32:40 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* configure.in (getrusage,gettimeofday): New tests.
+
 Fri Feb 27 13:14:17 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* configure.in (--disable-m-guard): New.
diff -urN gnupg-0.2.11/NEWS gnupg-0.2.12/NEWS
--- gnupg-0.2.11/NEWS	Mon Mar  2 22:09:04 1998
+++ gnupg-0.2.12/NEWS	Sat Mar  7 12:32:36 1998
@@ -1,3 +1,17 @@
+Noteworthy changes in version 0.2.12
+------------------------------------
+
+    * --delete-key checks that there is no secret key. The new
+      option --delete-secret-key maybe used to delete a secret key.
+
+    * "-kv" now works as expected. Options "--list-{keys,sigs]"
+      and "--check-sigs" are now working.
+
+    * New options "--verify" and "--decrypt" to better support integration
+      into MUAs (partly done for Mutt).
+
+    * New option "--with-colons" to make parsing of key lists easier.
+
 Noteworthy changes in version 0.2.11
 ------------------------------------
 
diff -urN gnupg-0.2.11/TODO gnupg-0.2.12/TODO
--- gnupg-0.2.11/TODO	Wed Feb 25 10:24:16 1998
+++ gnupg-0.2.12/TODO	Fri Mar  6 14:32:04 1998
@@ -13,9 +13,7 @@
     * complete cipher/cast.c
     * complete cipher/dsa.c
 
-    * add g10 stuff to Mutt's pgpinvoke.c
-
-    * Burn the buffers used by fopen().
+    * Burn the buffers used by fopen(), or use read(2).
 
     * bug: g10/trustdb.c#build_sigrecs called to often by do_list_path
       and remove the bad kludge. Maybe we should put all sigs into the trustdb
@@ -34,4 +32,11 @@
       them to your key and because the user id which is signed by others has
       also be signed by you, all user-ids are bound together.
 
+    * add an option to re-create a public key from a secret key
+
+    * should we have a simple menu for all the key management options?
+
+    * cleanup mainproc.c, much stuff is duplicated.
+
+    * remove key management stuff from sign.c.
 
diff -urN gnupg-0.2.11/cipher/ChangeLog gnupg-0.2.12/cipher/ChangeLog
--- gnupg-0.2.11/cipher/ChangeLog	Mon Mar  2 19:22:25 1998
+++ gnupg-0.2.12/cipher/ChangeLog	Wed Mar  4 10:53:52 1998
@@ -1,3 +1,14 @@
+Wed Mar  4 10:39:22 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* md.c (md_open): Add call to fast_random_poll.
+	blowfish.c (blowfish_setkey): Ditto.
+
+Tue Mar  3 13:32:54 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* rmd160.c (rmd160_mixblock): New.
+	* random.c: Restructured to start with a new RNG implementation.
+	* random.h: New.
+
 Mon Mar  2 19:21:46 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* gost.c, gost.h: Removed because they did only conatin trash.
diff -urN gnupg-0.2.11/cipher/Makefile.am gnupg-0.2.12/cipher/Makefile.am
--- gnupg-0.2.11/cipher/Makefile.am	Mon Mar  2 19:07:43 1998
+++ gnupg-0.2.12/cipher/Makefile.am	Tue Mar  3 15:16:34 1998
@@ -13,6 +13,7 @@
 		 md5.c		\
 		 md5.h		\
 		 primegen.c	\
+		 random.h	\
 		 random.c	\
 		 rmd.h		\
 		 rmd160.c	\
diff -urN gnupg-0.2.11/cipher/Makefile.in gnupg-0.2.12/cipher/Makefile.in
--- gnupg-0.2.11/cipher/Makefile.in	Mon Mar  2 22:47:50 1998
+++ gnupg-0.2.12/cipher/Makefile.in	Sat Mar  7 12:57:53 1998
@@ -104,6 +104,7 @@
 		 md5.c		\
 		 md5.h		\
 		 primegen.c	\
+		 random.h	\
 		 random.c	\
 		 rmd.h		\
 		 rmd160.c	\
@@ -225,6 +226,60 @@
 	  || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
 	  || cp -p $$d/$$file $(distdir)/$$file; \
 	done
+blowfish.o: blowfish.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h blowfish.h random.h
+dsa.o: dsa.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h dsa.h
+elgamal.o: elgamal.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h elgamal.h
+md.o: md.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h
+md5.o: md5.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h md5.h
+misc.o: misc.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h
+primegen.o: primegen.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h
+random.o: random.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h random.h rmd.h ../include/ttyio.h \
+	../include/i18n.h
+rmd160.o: rmd160.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h rmd.h
+sha1.o: sha1.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h sha1.h
+smallprime.o: smallprime.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h
 
 info:
 dvi:
diff -urN gnupg-0.2.11/cipher/blowfish.c gnupg-0.2.12/cipher/blowfish.c
--- gnupg-0.2.11/cipher/blowfish.c	Mon Feb 23 13:12:56 1998
+++ gnupg-0.2.12/cipher/blowfish.c	Wed Mar  4 10:53:21 1998
@@ -37,6 +37,7 @@
 #include "util.h"
 #include "types.h"
 #include "blowfish.h"
+#include "random.h"
 
 /* precomputed S boxes */
 static const u32 ks0[256] = {
@@ -420,6 +421,8 @@
 	initialized = 1;
 	selftest();
     }
+
+    fast_random_poll();
 
     for(i=0; i < BLOWFISH_ROUNDS+2; i++ )
 	c->p[i] = ps[i];
diff -urN gnupg-0.2.11/cipher/md.c gnupg-0.2.12/cipher/md.c
--- gnupg-0.2.11/cipher/md.c	Fri Feb 27 16:40:16 1998
+++ gnupg-0.2.12/cipher/md.c	Wed Mar  4 10:53:42 1998
@@ -42,6 +42,7 @@
     hd->secure = secure;
     if( algo )
 	md_enable( hd, algo );
+    fast_random_poll();
     return hd;
 }
 
diff -urN gnupg-0.2.11/cipher/random.c gnupg-0.2.12/cipher/random.c
--- gnupg-0.2.11/cipher/random.c	Sun Mar  1 16:42:28 1998
+++ gnupg-0.2.12/cipher/random.c	Wed Mar  4 11:17:29 1998
@@ -18,6 +18,17 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
  */
 
+
+/****************
+ * How it works:
+ *
+ * See Peter Gutmann's Paper: "Software Generation of Practically
+ * Strong Random Numbers"
+ *
+ * fixme!
+ */
+
+
 #include <config.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -26,27 +37,88 @@
 #include <sys/time.h>
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef HAVE_GETTIMEOFTIME
+  #include <sys/times.h>
+#endif
+#ifdef HAVE_GETRUSAGE
+  #include <sys/resource.h>
+#endif
 #include <string.h>
 #include <unistd.h>
 #include <fcntl.h>
 #include "util.h"
-#include "cipher.h"
+#include "random.h"
+#include "rmd.h"
 #include "ttyio.h"
 #include "i18n.h"
 
+
+#define BLOCKLEN  64   /* hash this amount of bytes */
+#define DIGESTLEN 20   /* into a digest of this length (rmd160) */
+/* poolblocks is the number of digests which make up the pool
+ * and poolsize must be a multiple of the digest length
+ * to make the AND operations faster, the size should also be
+ * a multiple of ulong
+ */
+#define POOLBLOCKS 30
+#define POOLSIZE (POOLBLOCKS*DIGESTLEN)
+#if (POOLSIZE % SIZEOF_UNSIGNED_LONG)
+  #error Please make sure that poolsize is a multiple of ulong
+#endif
+#define POOLWORDS (POOLSIZE / SIZEOF_UNSIGNED_LONG)
+#if SIZEOF_UNSIGNED_LONG == 8
+  #define ADD_VALUE 0xa5a5a5a5a5a5a5a5
+#elif SIZEOF_UNSIGNED_LONG == 4
+  #define ADD_VALUE 0xa5a5a5a5
+#else
+  #error weird size for an unsigned long
+#endif
+
 struct cache {
     int len;
-    byte buffer[100]; /* fixme: should be allocated with m_alloc_secure()*/
+    int size;
+    byte *buffer;
 };
 
+
+static int is_initialized;
 static struct cache cache[3];
 #define MASK_LEVEL(a) do {if( a > 2 ) a = 2; else if( a < 0 ) a = 0; } while(0)
+static char *rndpool;	/* allocated size is POOLSIZE+BLOCKLEN */
+static char *keypool;	/* allocated size is POOLSIZE+BLOCKLEN */
+static size_t pool_readpos;
+static size_t pool_writepos;
+static int pool_filled;
+static int just_mixed;
 
-
-static void fill_buffer( byte *buffer, size_t length, int level );
+static int secure_alloc;
 static int quick_test;
 
 
+
+static void read_pool( byte *buffer, size_t length, int level );
+static void read_dev_random( byte *buffer, size_t length, int level );
+
+
+static void
+initialize()
+{
+    /* The data buffer is allocated somewhat larger, so that
+     * we can use this extra space (which is allocated in secure memory)
+     * as a temporary hash buffer */
+    rndpool = secure_alloc ? m_alloc_secure_clear(POOLSIZE+BLOCKLEN)
+			   : m_alloc_clear(POOLSIZE+BLOCKLEN);
+    keypool = secure_alloc ? m_alloc_secure_clear(POOLSIZE+BLOCKLEN)
+			   : m_alloc_clear(POOLSIZE+BLOCKLEN);
+    is_initialized = 1;
+}
+
+void
+secure_random_alloc()
+{
+    secure_alloc = 1;
+}
+
 int
 quick_random_gen( int onoff )
 {
@@ -78,14 +150,174 @@
 {
     MASK_LEVEL(level);
     if( !cache[level].len ) {
-	fill_buffer(cache[level].buffer, DIM(cache[level].buffer), level );
-	cache[level].len = DIM(cache[level].buffer);
+	if( !is_initialized )
+	    initialize();
+	if( !cache[level].buffer ) {
+	    cache[level].size = 100;
+	    cache[level].buffer = level && secure_alloc?
+					 m_alloc_secure( cache[level].size )
+				       : m_alloc( cache[level].size );
+	}
+	read_pool(cache[level].buffer, cache[level].size, level );
+	cache[level].len = cache[level].size;
     }
 
     return cache[level].buffer[--cache[level].len];
 }
 
 
+/****************
+ * Mix the pool
+ */
+static void
+mix_pool(byte *pool)
+{
+    char *hashbuf = pool + POOLSIZE;
+    char *p, *pend;
+    int i, n;
+    RMD160_CONTEXT md;
+
+    rmd160_init( &md );
+ #if DIGESTLEN != 20
+    #error must have a digest length of 20 for ripe-md-160
+ #endif
+    /* loop over the pool */
+    pend = pool + POOLSIZE;
+    memcpy(hashbuf, pend - DIGESTLEN, DIGESTLEN );
+    memcpy(hashbuf+DIGESTLEN, pool, BLOCKLEN-DIGESTLEN);
+    rmd160_mixblock( &md, hashbuf);
+    memcpy(pool, hashbuf, 20 );
+
+    p = pool;
+    for( n=1; n < POOLBLOCKS; n++ ) {
+	memcpy(hashbuf, p, DIGESTLEN );
+
+	p += DIGESTLEN;
+	if( p+DIGESTLEN+BLOCKLEN < pend )
+	    memcpy(hashbuf+DIGESTLEN, p+DIGESTLEN, BLOCKLEN-DIGESTLEN);
+	else {
+	    char *pp = p+DIGESTLEN;
+	    for(i=DIGESTLEN; i < BLOCKLEN; i++ ) {
+		if( pp >= pend )
+		    pp = pool;
+		hashbuf[i] = *pp++;
+	    }
+	}
+
+	rmd160_mixblock( &md, hashbuf);
+	memcpy(p, hashbuf, 20 );
+    }
+}
+
+
+static void
+read_pool( byte *buffer, size_t length, int level )
+{
+    int i;
+    ulong *sp, *dp;
+
+    if( length >= POOLSIZE )
+	BUG(); /* not allowed */
+    if( !level ) { /* read simple random bytes */
+	read_dev_random( buffer, length, level );
+	return;
+    }
+
+    /* always do a random poll if we need strong numbers */
+    if( pool_filled && level == 2 )
+	random_poll();
+    /* make sure the pool is filled */
+    while( !pool_filled )
+	random_poll();
+    /* do always a fast random poll */
+    fast_random_poll();
+
+    /* mix the pool (if add_randomness() didn't it) */
+    if( !just_mixed )
+	mix_pool(rndpool);
+
+    /* create a new pool */
+    for(i=0,dp=(ulong*)keypool, sp=(ulong*)rndpool;
+				i < POOLWORDS; i++, dp++, sp++ )
+	*dp = *sp + ADD_VALUE;
+    /* and mix both pools */
+    mix_pool(rndpool);
+    mix_pool(keypool);
+    /* read the required data
+     * we use a readpoiter to read from a different postion each
+     * time */
+    while( length-- ) {
+	*buffer++ = keypool[pool_readpos++];
+	if( pool_readpos >= POOLSIZE )
+	    pool_readpos = 0;
+    }
+    /* and clear the keypool */
+    memset( keypool, 0, POOLSIZE );
+}
+
+
+/****************
+ * Add LENGTH bytes of randomness from buffer to the pool.
+ * source may be used to specify the randomeness source.
+ */
+void
+add_randomness( const void *buffer, size_t length, int source )
+{
+    if( !is_initialized )
+	initialize();
+    while( length-- ) {
+	rndpool[pool_writepos++] = *((byte*)buffer)++;
+	if( pool_writepos >= POOLSIZE ) {
+	    pool_filled = 1;
+	    pool_writepos = 0;
+	    mix_pool(rndpool);
+	    just_mixed = !length;
+	}
+    }
+}
+
+
+
+/********************
+ *  FIXME: move these functions to rand_unix.c
+ */
+
+void
+random_poll()
+{
+    char buf[POOLSIZE/5];
+    read_dev_random( buf, POOLSIZE/5, 1 ); /* read /dev/urandom */
+    add_randomness( buf, POOLSIZE/5, 2);
+    memset( buf, 0, POOLSIZE/5);
+}
+
+
+void
+fast_random_poll()
+{
+  #ifdef HAVE_GETTIMEOFTIME
+    {	struct timeval tv;
+	if( gettimeofday( &tv, NULL ) )
+	    BUG();
+	add_randomness( &tv.tv_sec, sizeof(tv.tv_sec), 1 );
+	add_randomness( &tv.tv_usec, sizeof(tv.tv_usec), 1 );
+    }
+  #else /* use times */
+    {	struct tms buf;
+	times( &buf );
+	add_randomness( &buf, sizeof buf, 1 );
+    }
+  #endif
+  #ifdef HAVE_GETRUSAGE
+    {	struct rusage buf;
+	if( getrusage( RUSAGE_SELF, &buf ) )
+	    BUG();
+	add_randomness( &buf, sizeof buf, 1 );
+	memset( &buf, 0, sizeof buf );
+    }
+  #endif
+}
+
 
 #ifdef HAVE_DEV_RANDOM
 
@@ -111,7 +343,7 @@
 
 
 static void
-fill_buffer( byte *buffer, size_t length, int level )
+read_dev_random( byte *buffer, size_t length, int level )
 {
     static int fd_urandom = -1;
     static int fd_random = -1;
@@ -125,6 +357,9 @@
 	fd = fd_random;
     }
     else {
+	/* fixme: we should use a simpler one for level 0,
+	 * because reading from /dev/urandom removes entropy
+	 * and the next read on /dev/random may have to wait */
 	if( fd_urandom == -1 )
 	    fd_urandom = open_device( "/dev/urandom", 9 );
 	fd = fd_urandom;
@@ -154,7 +389,7 @@
 	    continue;
 	}
 
-	assert( length < 200 );
+	assert( length < 500 );
 	do {
 	    n = read(fd, buffer, length );
 	    if( n >= 0 && n > length ) {
@@ -178,7 +413,7 @@
 #endif
 
 static void
-fill_buffer( byte *buffer, size_t length, int level )
+read_dev_random( byte *buffer, size_t length, int level )
 {
     static int initialized=0;
 
diff -urN gnupg-0.2.11/cipher/random.h gnupg-0.2.12/cipher/random.h
--- gnupg-0.2.11/cipher/random.h	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.12/cipher/random.h	Wed Mar  4 10:47:52 1998
@@ -0,0 +1,39 @@
+/* random.h - random functions
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+#ifndef G10_RANDOM_H
+#define G10_RANDOM_H
+
+#include "types.h"
+
+/*-- random.c --*/
+void secure_random_alloc(void);
+int  quick_random_gen( int onoff );
+void randomize_buffer( byte *buffer, size_t length, int level );
+byte get_random_byte( int level );
+void add_randomness( const void *buffer, size_t length, int source );
+
+
+/*-- the next two functions are implemented by all the system
+     specific source files rand_xxxx.s --*/
+void random_poll(void);
+void fast_random_poll(void);
+
+
+#endif /*G10_RANDOM_H*/
diff -urN gnupg-0.2.11/cipher/rmd.h gnupg-0.2.12/cipher/rmd.h
--- gnupg-0.2.11/cipher/rmd.h	Mon Feb 23 13:12:57 1998
+++ gnupg-0.2.12/cipher/rmd.h	Tue Mar  3 13:31:38 1998
@@ -33,6 +33,7 @@
 void rmd160_init( RMD160_CONTEXT *c );
 void rmd160_write( RMD160_CONTEXT *hd, byte *inbuf, size_t inlen);
 void rmd160_final(RMD160_CONTEXT *hd);
+void rmd160_mixblock( RMD160_CONTEXT *hd, char *buffer );
 #define rmd160_read(h) ( (h)->buf )
 
 #endif /*G10_RMD_H*/
diff -urN gnupg-0.2.11/cipher/rmd160.c gnupg-0.2.12/cipher/rmd160.c
--- gnupg-0.2.11/cipher/rmd160.c	Mon Feb 23 13:12:57 1998
+++ gnupg-0.2.12/cipher/rmd160.c	Tue Mar  3 13:51:10 1998
@@ -300,6 +300,27 @@
 }
 
 
+/****************
+ * Apply the rmd160 transform function on the buffer which must have
+ * a length 64 bytes. Do not use this function together with the
+ * other functions, use rmd160_init to initialize intzernal variables.
+ * Returns: 16 bytes in buffer with the mixed contentes of buffer.
+ */
+void
+rmd160_mixblock( RMD160_CONTEXT *hd, char *buffer )
+{
+    char *p = buffer;
+    transform( hd, buffer );
+  #define X(a) do { *(u32*)p = hd->h##a ; p += 4; } while(0)
+    X(0);
+    X(1);
+    X(2);
+    X(3);
+    X(4);
+  #undef X
+}
+
+
 /* The routine terminates the computation
  */
 
diff -urN gnupg-0.2.11/config.h.in gnupg-0.2.12/config.h.in
--- gnupg-0.2.11/config.h.in	Fri Feb 27 10:42:25 1998
+++ gnupg-0.2.12/config.h.in	Wed Mar  4 10:33:23 1998
@@ -142,6 +142,12 @@
 /* Define if you have the getpagesize function.  */
 #undef HAVE_GETPAGESIZE
 
+/* Define if you have the getrusage function.  */
+#undef HAVE_GETRUSAGE
+
+/* Define if you have the gettimeofday function.  */
+#undef HAVE_GETTIMEOFDAY
+
 /* Define if you have the mlock function.  */
 #undef HAVE_MLOCK
 
diff -urN gnupg-0.2.11/configure gnupg-0.2.12/configure
--- gnupg-0.2.11/configure	Fri Feb 27 15:27:14 1998
+++ gnupg-0.2.12/configure	Sat Mar  7 12:54:33 1998
@@ -2250,12 +2250,67 @@
 fi
 done
 
+for ac_func in gettimeofday getrusage
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:2257: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2262 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:2285: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=no"
+fi
+rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
+EOF
+ 
+else
+  echo "$ac_t""no" 1>&6
+fi
+done
+
 
 
 
 
 echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:2259: checking for random device" >&5
+echo "configure:2314: checking for random device" >&5
 if eval "test \"`echo '$''{'ac_cv_have_dev_random'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2273,7 +2328,7 @@
 
 
 echo $ac_n "checking for mpi assembler functions""... $ac_c" 1>&6
-echo "configure:2277: checking for mpi assembler functions" >&5
+echo "configure:2332: checking for mpi assembler functions" >&5
 if test -f $srcdir/mpi/config.links ; then
     . $srcdir/mpi/config.links
      if test "x$wk_link_files_src" = "x"; then
@@ -2336,17 +2391,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2340: checking for $ac_hdr" >&5
+echo "configure:2395: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2345 "configure"
+#line 2400 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2350: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2405: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2419,7 +2474,7 @@
 CIPHER_EXTRA_OBJS=""
 CIPHER_EXTRA_DIST=""
 echo $ac_n "checking for extra cipher modules""... $ac_c" 1>&6
-echo "configure:2423: checking for extra cipher modules" >&5
+echo "configure:2478: checking for extra cipher modules" >&5
 if eval "test \"`echo '$''{'ac_cv_have_rsa_cipher'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2440,12 +2495,12 @@
 
 
 echo $ac_n "checking for off_t""... $ac_c" 1>&6
-echo "configure:2444: checking for off_t" >&5
+echo "configure:2499: checking for off_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_off_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2449 "configure"
+#line 2504 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -2475,19 +2530,19 @@
 # The Ultrix 4.2 mips builtin alloca declared by alloca.h only works
 # for constant arguments.  Useless!
 echo $ac_n "checking for working alloca.h""... $ac_c" 1>&6
-echo "configure:2479: checking for working alloca.h" >&5
+echo "configure:2534: checking for working alloca.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_alloca_h'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2484 "configure"
+#line 2539 "configure"
 #include "confdefs.h"
 #include <alloca.h>
 int main() {
 char *p = alloca(2 * sizeof(int));
 ; return 0; }
 EOF
-if { (eval echo configure:2491: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2546: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_header_alloca_h=yes
 else
@@ -2508,12 +2563,12 @@
 fi
 
 echo $ac_n "checking for alloca""... $ac_c" 1>&6
-echo "configure:2512: checking for alloca" >&5
+echo "configure:2567: checking for alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_func_alloca_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2517 "configure"
+#line 2572 "configure"
 #include "confdefs.h"
 
 #ifdef __GNUC__
@@ -2536,7 +2591,7 @@
 char *p = (char *) alloca(1);
 ; return 0; }
 EOF
-if { (eval echo configure:2540: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2595: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_func_alloca_works=yes
 else
@@ -2568,12 +2623,12 @@
 
 
 echo $ac_n "checking whether alloca needs Cray hooks""... $ac_c" 1>&6
-echo "configure:2572: checking whether alloca needs Cray hooks" >&5
+echo "configure:2627: checking whether alloca needs Cray hooks" >&5
 if eval "test \"`echo '$''{'ac_cv_os_cray'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2577 "configure"
+#line 2632 "configure"
 #include "confdefs.h"
 #if defined(CRAY) && ! defined(CRAY2)
 webecray
@@ -2598,12 +2653,12 @@
 if test $ac_cv_os_cray = yes; then
 for ac_func in _getb67 GETB67 getb67; do
   echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2602: checking for $ac_func" >&5
+echo "configure:2657: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2607 "configure"
+#line 2662 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2626,7 +2681,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2630: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2685: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2653,7 +2708,7 @@
 fi
 
 echo $ac_n "checking stack direction for C alloca""... $ac_c" 1>&6
-echo "configure:2657: checking stack direction for C alloca" >&5
+echo "configure:2712: checking stack direction for C alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_c_stack_direction'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2661,7 +2716,7 @@
   ac_cv_c_stack_direction=0
 else
   cat > conftest.$ac_ext <<EOF
-#line 2665 "configure"
+#line 2720 "configure"
 #include "confdefs.h"
 find_stack_direction ()
 {
@@ -2680,7 +2735,7 @@
   exit (find_stack_direction() < 0);
 }
 EOF
-if { (eval echo configure:2684: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2739: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_c_stack_direction=1
 else
@@ -2705,17 +2760,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2709: checking for $ac_hdr" >&5
+echo "configure:2764: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2714 "configure"
+#line 2769 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2719: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2774: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2744,12 +2799,12 @@
 for ac_func in getpagesize
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2748: checking for $ac_func" >&5
+echo "configure:2803: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2753 "configure"
+#line 2808 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2772,7 +2827,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2776: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2831: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2797,7 +2852,7 @@
 done
 
 echo $ac_n "checking for working mmap""... $ac_c" 1>&6
-echo "configure:2801: checking for working mmap" >&5
+echo "configure:2856: checking for working mmap" >&5
 if eval "test \"`echo '$''{'ac_cv_func_mmap_fixed_mapped'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2805,7 +2860,7 @@
   ac_cv_func_mmap_fixed_mapped=no
 else
   cat > conftest.$ac_ext <<EOF
-#line 2809 "configure"
+#line 2864 "configure"
 #include "confdefs.h"
 
 /* Thanks to Mike Haertel and Jim Avera for this test.
@@ -2945,7 +3000,7 @@
 }
 
 EOF
-if { (eval echo configure:2949: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:3004: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_func_mmap_fixed_mapped=yes
 else
@@ -2973,17 +3028,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2977: checking for $ac_hdr" >&5
+echo "configure:3032: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2982 "configure"
+#line 3037 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2987: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3042: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3013,12 +3068,12 @@
 __argz_count __argz_stringify __argz_next
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3017: checking for $ac_func" >&5
+echo "configure:3072: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3022 "configure"
+#line 3077 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3041,7 +3096,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3045: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3100: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3070,12 +3125,12 @@
      for ac_func in stpcpy
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3074: checking for $ac_func" >&5
+echo "configure:3129: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3079 "configure"
+#line 3134 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3098,7 +3153,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3102: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3157: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3132,19 +3187,19 @@
 
    if test $ac_cv_header_locale_h = yes; then
     echo $ac_n "checking for LC_MESSAGES""... $ac_c" 1>&6
-echo "configure:3136: checking for LC_MESSAGES" >&5
+echo "configure:3191: checking for LC_MESSAGES" >&5
 if eval "test \"`echo '$''{'am_cv_val_LC_MESSAGES'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3141 "configure"
+#line 3196 "configure"
 #include "confdefs.h"
 #include <locale.h>
 int main() {
 return LC_MESSAGES
 ; return 0; }
 EOF
-if { (eval echo configure:3148: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3203: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   am_cv_val_LC_MESSAGES=yes
 else
@@ -3165,7 +3220,7 @@
     fi
   fi
    echo $ac_n "checking whether NLS is requested""... $ac_c" 1>&6
-echo "configure:3169: checking whether NLS is requested" >&5
+echo "configure:3224: checking whether NLS is requested" >&5
         # Check whether --enable-nls or --disable-nls was given.
 if test "${enable_nls+set}" = set; then
   enableval="$enable_nls"
@@ -3185,7 +3240,7 @@
 EOF
 
       echo $ac_n "checking whether included gettext is requested""... $ac_c" 1>&6
-echo "configure:3189: checking whether included gettext is requested" >&5
+echo "configure:3244: checking whether included gettext is requested" >&5
       # Check whether --with-included-gettext or --without-included-gettext was given.
 if test "${with_included_gettext+set}" = set; then
   withval="$with_included_gettext"
@@ -3204,17 +3259,17 @@
 
         ac_safe=`echo "libintl.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for libintl.h""... $ac_c" 1>&6
-echo "configure:3208: checking for libintl.h" >&5
+echo "configure:3263: checking for libintl.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3213 "configure"
+#line 3268 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3218: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3273: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3231,19 +3286,19 @@
 if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libc""... $ac_c" 1>&6
-echo "configure:3235: checking for gettext in libc" >&5
+echo "configure:3290: checking for gettext in libc" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3240 "configure"
+#line 3295 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3247: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3302: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libc=yes
 else
@@ -3259,7 +3314,7 @@
 
            if test "$gt_cv_func_gettext_libc" != "yes"; then
              echo $ac_n "checking for bindtextdomain in -lintl""... $ac_c" 1>&6
-echo "configure:3263: checking for bindtextdomain in -lintl" >&5
+echo "configure:3318: checking for bindtextdomain in -lintl" >&5
 ac_lib_var=`echo intl'_'bindtextdomain | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3267,7 +3322,7 @@
   ac_save_LIBS="$LIBS"
 LIBS="-lintl  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3271 "configure"
+#line 3326 "configure"
 #include "confdefs.h"
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
@@ -3278,7 +3333,7 @@
 bindtextdomain()
 ; return 0; }
 EOF
-if { (eval echo configure:3282: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3337: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3294,19 +3349,19 @@
 if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libintl""... $ac_c" 1>&6
-echo "configure:3298: checking for gettext in libintl" >&5
+echo "configure:3353: checking for gettext in libintl" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libintl'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3303 "configure"
+#line 3358 "configure"
 #include "confdefs.h"
 
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3310: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3365: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libintl=yes
 else
@@ -3334,7 +3389,7 @@
               # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3338: checking for $ac_word" >&5
+echo "configure:3393: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3368,12 +3423,12 @@
                 for ac_func in dcgettext
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3372: checking for $ac_func" >&5
+echo "configure:3427: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3377 "configure"
+#line 3432 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3396,7 +3451,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3400: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3455: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3423,7 +3478,7 @@
                 # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3427: checking for $ac_word" >&5
+echo "configure:3482: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3455,7 +3510,7 @@
                 # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3459: checking for $ac_word" >&5
+echo "configure:3514: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3487,7 +3542,7 @@
 fi
 
                 cat > conftest.$ac_ext <<EOF
-#line 3491 "configure"
+#line 3546 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -3495,7 +3550,7 @@
                                return _nl_msg_cat_cntr
 ; return 0; }
 EOF
-if { (eval echo configure:3499: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3554: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   CATOBJEXT=.gmo
                    DATADIRNAME=share
@@ -3518,7 +3573,7 @@
 
         if test "$CATOBJEXT" = "NONE"; then
           echo $ac_n "checking whether catgets can be used""... $ac_c" 1>&6
-echo "configure:3522: checking whether catgets can be used" >&5
+echo "configure:3577: checking whether catgets can be used" >&5
           # Check whether --with-catgets or --without-catgets was given.
 if test "${with_catgets+set}" = set; then
   withval="$with_catgets"
@@ -3531,7 +3586,7 @@
 
           if test "$nls_cv_use_catgets" = "yes"; then
                         echo $ac_n "checking for main in -li""... $ac_c" 1>&6
-echo "configure:3535: checking for main in -li" >&5
+echo "configure:3590: checking for main in -li" >&5
 ac_lib_var=`echo i'_'main | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3539,14 +3594,14 @@
   ac_save_LIBS="$LIBS"
 LIBS="-li  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3543 "configure"
+#line 3598 "configure"
 #include "confdefs.h"
 
 int main() {
 main()
 ; return 0; }
 EOF
-if { (eval echo configure:3550: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3605: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3574,12 +3629,12 @@
 fi
 
             echo $ac_n "checking for catgets""... $ac_c" 1>&6
-echo "configure:3578: checking for catgets" >&5
+echo "configure:3633: checking for catgets" >&5
 if eval "test \"`echo '$''{'ac_cv_func_catgets'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3583 "configure"
+#line 3638 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char catgets(); below.  */
@@ -3602,7 +3657,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3606: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3661: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_catgets=yes"
 else
@@ -3624,7 +3679,7 @@
                # Extract the first word of "gencat", so it can be a program name with args.
 set dummy gencat; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3628: checking for $ac_word" >&5
+echo "configure:3683: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GENCAT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3656,7 +3711,7 @@
                  # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3660: checking for $ac_word" >&5
+echo "configure:3715: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3689,7 +3744,7 @@
                    # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3693: checking for $ac_word" >&5
+echo "configure:3748: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3724,7 +3779,7 @@
                  # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3728: checking for $ac_word" >&5
+echo "configure:3783: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3782,7 +3837,7 @@
         # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3786: checking for $ac_word" >&5
+echo "configure:3841: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3816,7 +3871,7 @@
         # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3820: checking for $ac_word" >&5
+echo "configure:3875: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3848,7 +3903,7 @@
         # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3852: checking for $ac_word" >&5
+echo "configure:3907: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3938,7 +3993,7 @@
        LINGUAS=
      else
        echo $ac_n "checking for catalogs to be installed""... $ac_c" 1>&6
-echo "configure:3942: checking for catalogs to be installed" >&5
+echo "configure:3997: checking for catalogs to be installed" >&5
        NEW_LINGUAS=
        for lang in ${LINGUAS=$ALL_LINGUAS}; do
          case "$ALL_LINGUAS" in
@@ -3966,17 +4021,17 @@
    if test "$CATOBJEXT" = ".cat"; then
      ac_safe=`echo "linux/version.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for linux/version.h""... $ac_c" 1>&6
-echo "configure:3970: checking for linux/version.h" >&5
+echo "configure:4025: checking for linux/version.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3975 "configure"
+#line 4030 "configure"
 #include "confdefs.h"
 #include <linux/version.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3980: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:4035: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
diff -urN gnupg-0.2.11/configure.in gnupg-0.2.12/configure.in
--- gnupg-0.2.11/configure.in	Fri Feb 27 13:40:41 1998
+++ gnupg-0.2.12/configure.in	Wed Mar  4 10:36:40 1998
@@ -133,6 +133,7 @@
 dnl Checks for library functions.
 AC_FUNC_VPRINTF
 AC_CHECK_FUNCS(strerror stpcpy strlwr tcgetattr rand strtoul mlock mmap)
+AC_CHECK_FUNCS(gettimeofday getrusage)
 
 
 
diff -urN gnupg-0.2.11/doc/gpg.1 gnupg-0.2.12/doc/gpg.1
--- gnupg-0.2.11/doc/gpg.1	Fri Feb 27 15:28:43 1998
+++ gnupg-0.2.12/doc/gpg.1	Sat Mar  7 12:49:29 1998
@@ -73,7 +73,7 @@
 .nr % 0
 .rr F
 .\}
-.TH gpg gpg.1 "27 Feb 1998" " " "GNU Tools"
+.TH gpg gpg.1 "07 Mar 1998" " " "GNU Tools"
 .IX Title "gpg gpg.1"
 .UC
 .IX Name "gpg - GNU Privacy Guard"
@@ -200,13 +200,30 @@
     This command asks for a passphrase.
 .PP
 \fB--store\fR
-    store only (make a RFC1991 packet).
+    store only (make a simple RFC1991 packet).
 .PP
-\fB\-d\fR, \fB--decrypt\fR
-    Decrypt data. This is the default operation for data
-    files.
+\fB--decrypt\fR [\fIfile\fR]
+    Decrypt file (or stdin if no file is specified) and
+    write it to stdout (or the file specified with
+    \fB--output\fR). If the decrypted file is signed, the
+    signature is also verified. This command differs
+    from the default operation, as it never write to the
+    filename which is included in the file and that it
+    rejects files which don't begin with an encrypted
+    message.
+.PP
+\fB--verify\fR [[\fIsigfile\fR] {\fIsigned-files\fR}]
+    Assume that \fIfilename\fR is a signature and verify it
+    without generating any output.  With no arguments,
+    the signature packet is read from stdin (it may be a
+    detached signature when not used in batch mode). If
+    only a sigfile is given, is maybe a complete signature
+    or a detached signature in which case the signed stuff
+    is expected from stdin. With more than 1 argument, the
+    first should be a detached signature and the remaining
+    files are the signed stuff.
 .PP
-\fB\-k\fR [\fIkeyring\fR]
+\fB\-k\fR [\fIusername\fR] [\fIkeyring\fR]
     Kludge to be somewhat compatibe to PGP.
     Without arguments, all public key-rings are listed,
     with one argument, only \fIkeyring\fR is listed.
@@ -218,15 +235,21 @@
     \fB\-kvc\fR   List fingerprints
     \fB\-kvvc\fR  List fingerprints and signatures
 .PP
-\fB--list-keys\fR
-    List all keys in all public key-rings and check the
-    signatures.
-.PP
-\fB--check-keys\fR
-    Check signatures on a key in the keyring
-.PP
-\fB--fingerprint\fR
-    Show the fingerprints
+\fB--list-keys\fR	[\fInames\fR]
+    List all keys from the default public keyring or just the ones
+    given on the commandline.
+.PP
+\fB--list-sigs\fR	[\fInames\fR]
+    Same as \fB--list-keys\fR, but the signatures are listed too.
+.PP
+\fB--check-sigs\fR [\fInames\fR]
+    Same as \fB--list-sigs\fR, but the signatures are verified.
+.PP
+\fB--fingerprint\fR [\fInames\fR]
+    List all keys with their fingerprints. This is the
+    same output as \fBlist-keys\fR but with the additonal output
+    of a line with the fingerprint. May also be combined
+    with \fB--list-sigs\fR or \fB--check-sigs\fR.
 .PP
 \fB--list-packets\fR
     List only the sequence of packets. This is mainly
@@ -251,7 +274,10 @@
 \fB--delete-key\fR
     Remove key from the public keyring
 .PP
-\fB--edit-sig\fR
+\fB--delete-secret-key\fR
+    Remove key from the secret and public keyring
+.PP
+\fB--edit-key\fR
     Edit/remove a key signature.
 .PP
 \fB--change-passphrase\fR
@@ -288,9 +314,13 @@
 .PP
 \fB\-u\fR \fIname\fR, \fB--local-user\fR \fIname\fR
     Use \fIname\fR as the user-id to sign.
+    This option is silently ignored for the list commands,
+    so that it can be used in an options file.
 .PP
 \fB\-r\fR  \fIname\fR, \fB--remote-user\fR  \fIname\fR
-    Use  \fIname\fR as the user-id for encryption.
+    Use \fIname\fR as the user-id for encryption.
+    This option is silently ignored for the list commands,
+    so that it can be used in an options file.
 .PP
 \fB\-v\fR, \fB--verbose\fR
     Give more informations during processing. If used
@@ -344,7 +374,7 @@
     (see \fB--homedir\fR). This option is ignored when used
     in an options file.
 .PP
-\fBno-options\fR
+\fB--no-options\fR
     Shortcut for \fB--options\fR \fI/dev/null\fR.  This option is
     detected before an attempt to open an option file.
 .PP
@@ -390,23 +420,26 @@
     can only be used if only one passphrase is supplied.
     \fBDon't use this option if you can avoid it\fR
 .PP
-\fBno-verbose\fR
+\fB--no-verbose\fR
     Reset verbose level to 0.
 .PP
-\fBno-greeting\fR
+\fB--no-greeting\fR
     Suppress the initial copyright message but do not
     enter batch mode.
 .PP
-\fBno-armor\fR
+\fB--no-armor\fR
     Assume the input data is not in ASCCI armored format.
 .PP
-\fBno-default-keyring\fR
+\fB--no-default-keyring\fR
     Do not add the default key-rings to the list of
     key-rings.
 .PP
 \fB--version\fR
     Print version information along with a list
     of supported algorithms.
+.PP
+\fB--with-colons\fR
+    Print key listings delimited by colons.
 .PP
 \fB--warranty\fR
     Print warranty information.
diff -urN gnupg-0.2.11/doc/gpg.1pod gnupg-0.2.12/doc/gpg.1pod
--- gnupg-0.2.11/doc/gpg.1pod	Fri Feb 27 15:26:42 1998
+++ gnupg-0.2.12/doc/gpg.1pod	Sat Mar  7 12:49:24 1998
@@ -32,13 +32,30 @@
     This command asks for a passphrase.
 
 B<--store>
-    store only (make a RFC1991 packet).
+    store only (make a simple RFC1991 packet).
 
-B<-d>, B<--decrypt>
-    Decrypt data. This is the default operation for data
-    files.
+B<--decrypt> [I<file>]
+    Decrypt file (or stdin if no file is specified) and
+    write it to stdout (or the file specified with
+    B<--output>). If the decrypted file is signed, the
+    signature is also verified. This command differs
+    from the default operation, as it never write to the
+    filename which is included in the file and that it
+    rejects files which don't begin with an encrypted
+    message.
+
+B<--verify> [[I<sigfile>] {I<signed-files>}]
+    Assume that I<filename> is a signature and verify it
+    without generating any output.  With no arguments,
+    the signature packet is read from stdin (it may be a
+    detached signature when not used in batch mode). If
+    only a sigfile is given, is maybe a complete signature
+    or a detached signature in which case the signed stuff
+    is expected from stdin. With more than 1 argument, the
+    first should be a detached signature and the remaining
+    files are the signed stuff.
 
-B<-k> [I<keyring>]
+B<-k> [I<username>] [I<keyring>]
     Kludge to be somewhat compatibe to PGP.
     Without arguments, all public key-rings are listed,
     with one argument, only I<keyring> is listed.
@@ -50,15 +67,21 @@
     B<-kvc>   List fingerprints
     B<-kvvc>  List fingerprints and signatures
 
-B<--list-keys>
-    List all keys in all public key-rings and check the
-    signatures.
-
-B<--check-keys>
-    Check signatures on a key in the keyring
-
-B<--fingerprint>
-    Show the fingerprints
+B<--list-keys>	[I<names>]
+    List all keys from the default public keyring or just the ones
+    given on the commandline.
+
+B<--list-sigs>	[I<names>]
+    Same as B<--list-keys>, but the signatures are listed too.
+
+B<--check-sigs> [I<names>]
+    Same as B<--list-sigs>, but the signatures are verified.
+
+B<--fingerprint> [I<names>]
+    List all keys with their fingerprints. This is the
+    same output as B<list-keys> but with the additonal output
+    of a line with the fingerprint. May also be combined
+    with B<--list-sigs> or B<--check-sigs>.
 
 B<--list-packets>
     List only the sequence of packets. This is mainly
@@ -84,7 +107,10 @@
 B<--delete-key>
     Remove key from the public keyring
 
-B<--edit-sig>
+B<--delete-secret-key>
+    Remove key from the secret and public keyring
+
+B<--edit-key>
     Edit/remove a key signature.
 
 B<--change-passphrase>
@@ -124,9 +150,13 @@
 
 B<-u> I<name>, B<--local-user> I<name>
     Use I<name> as the user-id to sign.
+    This option is silently ignored for the list commands,
+    so that it can be used in an options file.
 
 B<-r>  I<name>, B<--remote-user>  I<name>
-    Use  I<name> as the user-id for encryption.
+    Use I<name> as the user-id for encryption.
+    This option is silently ignored for the list commands,
+    so that it can be used in an options file.
 
 B<-v>, B<--verbose>
     Give more informations during processing. If used
@@ -181,7 +211,7 @@
     (see B<--homedir>). This option is ignored when used
     in an options file.
 
-B<no-options>
+B<--no-options>
     Shortcut for B<--options> I</dev/null>.  This option is
     detected before an attempt to open an option file.
 
@@ -227,23 +257,26 @@
     can only be used if only one passphrase is supplied.
     B<Don't use this option if you can avoid it>
 
-B<no-verbose>
+B<--no-verbose>
     Reset verbose level to 0.
 
-B<no-greeting>
+B<--no-greeting>
     Suppress the initial copyright message but do not
     enter batch mode.
 
-B<no-armor>
+B<--no-armor>
     Assume the input data is not in ASCCI armored format.
 
-B<no-default-keyring>
+B<--no-default-keyring>
     Do not add the default key-rings to the list of
     key-rings.
 
 B<--version>
     Print version information along with a list
     of supported algorithms.
+
+B<--with-colons>
+    Print key listings delimited by colons.
 
 B<--warranty>
     Print warranty information.
diff -urN gnupg-0.2.11/g10/ChangeLog gnupg-0.2.12/g10/ChangeLog
--- gnupg-0.2.11/g10/ChangeLog	Mon Mar  2 21:24:13 1998
+++ gnupg-0.2.12/g10/ChangeLog	Fri Mar  6 16:12:32 1998
@@ -1,3 +1,64 @@
+Fri Mar  6 16:10:54 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* kbnode.c (clone_kbnode): Fixed private_flag.
+
+	* mainproc.c (list_node): Output of string "Revoked" as user-id.
+
+Fri Mar  6 14:26:39 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c (main): Add userids to "-kv" and cleaned up this stuff.
+
+Fri Mar  6 12:45:58 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c (main): Changed semantics of the list-... commands
+	and added a new one. Removed option "-d"
+
+	* decrypt.c: New.
+
+	* trustdb.c (init_trustdb): Autocreate directory only if it ends
+	in "/.gnupg".
+
+Thu Mar  5 12:12:11 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* mainproc.c (do_proc_packets): New. Common part of proc_packet.
+	(proc_signature_packets): special version to handle signature data.
+	* verify.c: New.
+	* g10.c (aVerify): New.
+	* plaintext.c (hash_datafiles): New.
+	* compress.c (handle_compressed): Add callback arg, changed caller.
+
+Thu Mar  5 10:20:06 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c: Is nom the common source for gpg and gpgm
+	* g10maint.c: Removed
+	* Makefile.am: Add rule to build g10maint.c
+
+Thu Mar  5 08:43:59 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c (main): Changed the way clear text sigs are faked.
+
+Wed Mar  4 19:47:37 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10maint.c (aMuttKeyList): New
+	* keylist.c: New.
+
+Wed Mar  4 17:20:33 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* getkey.c (get_pubkey_byname): Kludge to allow 0x prefix.
+
+Tue Mar  3 13:46:55 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10maint.c (main): New option --gen-random.
+
+Tue Mar  3 09:50:08 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c (aDeleteSecretKey): New.
+	(aEditSig): Add option "--edit-key" as synonym for "--edit-sig".
+	(aDeleteSecretKey): New.
+	* getkey.c (seckey_available): New.
+	* sign.c (delete_key): Enhanced to delete secret keys, changed all
+	callers.
+
 Mon Mar  2 21:23:48 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* pkc_list.c (build_pkc_list): Add interactive input of user ID.
diff -urN gnupg-0.2.11/g10/Makefile.am gnupg-0.2.12/g10/Makefile.am
--- gnupg-0.2.11/g10/Makefile.am	Mon Feb 23 13:00:55 1998
+++ gnupg-0.2.12/g10/Makefile.am	Fri Mar  6 15:09:37 1998
@@ -3,6 +3,7 @@
 INCLUDES = -I$(top_srcdir)/include
 EXTRA_DIST = OPTIONS  pubring.asc
 OMIT_DEPENDENCIES = zlib.h zconf.h
+BUILT_SOURCES = g10maint.c
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
 
 bin_PROGRAMS = gpg gpgm
@@ -47,19 +48,24 @@
 	      encr-data.c	\
 	      encode.c		\
 	      revoke.c		\
+	      keylist.c 	\
 	      sig-check.c
 
 gpg_SOURCES  = g10.c		\
 	      $(common_source)	\
+	      verify.c		\
+	      decrypt.c 	\
 	      keygen.c
 
 
 gpgm_SOURCES = g10maint.c   \
-	      dearmor.c 	\
+	      dearmor.c     \
 	      $(common_source)
 
 LDADD = @INTLLIBS@ $(needed_libs) @ZLIBS@
 
+g10maint.c : g10.c
+	    $(CPP) $(DEFS) $(INCLUDES) -DIS_G10MAINT  $<  > $@ || rm $@
 
 $(PROGRAMS): $(needed_libs)
 
diff -urN gnupg-0.2.11/g10/Makefile.in gnupg-0.2.12/g10/Makefile.in
--- gnupg-0.2.11/g10/Makefile.in	Mon Mar  2 22:47:56 1998
+++ gnupg-0.2.12/g10/Makefile.in	Sat Mar  7 12:58:00 1998
@@ -95,6 +95,7 @@
 INCLUDES = -I$(top_srcdir)/include
 EXTRA_DIST = OPTIONS  pubring.asc
 OMIT_DEPENDENCIES = zlib.h zconf.h
+BUILT_SOURCES = g10maint.c
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
 
 bin_PROGRAMS = gpg gpgm
@@ -139,14 +140,17 @@
 	      encr-data.c	\
 	      encode.c		\
 	      revoke.c		\
+	      keylist.c 	\
 	      sig-check.c
 
 gpg_SOURCES  = g10.c		\
 	      $(common_source)	\
+	      verify.c		\
+	      decrypt.c 	\
 	      keygen.c
 
 gpgm_SOURCES = g10maint.c   \
-	      dearmor.c 	\
+	      dearmor.c     \
 	      $(common_source)
 
 LDADD = @INTLLIBS@ $(needed_libs) @ZLIBS@
@@ -165,7 +169,7 @@
 textfilter.o cipher.o elg.o rsa.o openfile.o keyid.o trustdb.o \
 parse-packet.o passphrase.o pubkey-enc.o seckey-cert.o seskey.o \
 import.o export.o comment.o status.o sign.o plaintext.o encr-data.o \
-encode.o revoke.o sig-check.o keygen.o
+encode.o revoke.o keylist.o sig-check.o verify.o decrypt.o keygen.o
 gpg_LDADD = $(LDADD)
 gpg_DEPENDENCIES =  ../cipher/libcipher.a ../mpi/libmpi.a \
 ../util/libutil.a
@@ -175,7 +179,7 @@
 mainproc.o armor.o mdfilter.o textfilter.o cipher.o elg.o rsa.o \
 openfile.o keyid.o trustdb.o parse-packet.o passphrase.o pubkey-enc.o \
 seckey-cert.o seskey.o import.o export.o comment.o status.o sign.o \
-plaintext.o encr-data.o encode.o revoke.o sig-check.o
+plaintext.o encr-data.o encode.o revoke.o keylist.o sig-check.o
 gpgm_LDADD = $(LDADD)
 gpgm_DEPENDENCIES =  ../cipher/libcipher.a ../mpi/libmpi.a \
 ../util/libutil.a
@@ -293,6 +297,294 @@
 	  || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
 	  || cp -p $$d/$$file $(distdir)/$$file; \
 	done
+armor.o: armor.c ../config.h ../include/errors.h ../include/iobuf.h \
+	../include/types.h ../include/memory.h ../include/util.h \
+	../include/mpi.h filter.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h packet.h options.h main.h keydb.h \
+	status.h
+build-packet.o: build-packet.c ../config.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h ../include/util.h options.h
+cipher.o: cipher.c ../config.h ../include/errors.h ../include/iobuf.h \
+	../include/types.h ../include/memory.h ../include/util.h \
+	../include/mpi.h filter.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h packet.h options.h
+comment.o: comment.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h ../include/util.h main.h keydb.h
+compress.o: compress.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h packet.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h filter.h options.h
+dearmor.o: dearmor.c ../config.h ../include/errors.h ../include/iobuf.h \
+	../include/types.h ../include/memory.h ../include/util.h \
+	../include/mpi.h filter.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h packet.h options.h main.h keydb.h
+decrypt.o: decrypt.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h \
+	../include/i18n.h
+elg.o: elg.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h
+encode.o: encode.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h
+encr-data.o: encr-data.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h
+export.o: export.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h
+free-packet.o: free-packet.c ../config.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/util.h ../include/errors.h
+g10.o: g10.c ../config.h packet.h ../include/types.h ../include/iobuf.h \
+	../include/mpi.h ../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h filter.h ../include/util.h \
+	../include/errors.h main.h keydb.h options.h trustdb.h \
+	../include/ttyio.h ../include/i18n.h status.h
+g10maint.o: g10maint.c
+getkey.o: getkey.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h packet.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h filter.h keydb.h options.h
+import.o: import.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h \
+	trustdb.h main.h
+kbnode.o: kbnode.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h packet.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h filter.h keydb.h
+keygen.o: keygen.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h main.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h keydb.h packet.h filter.h \
+	../include/ttyio.h options.h ../include/i18n.h
+keyid.o: keyid.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h main.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h keydb.h packet.h filter.h \
+	options.h
+keylist.o: keylist.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h \
+	trustdb.h main.h ../include/i18n.h
+mainproc.o: mainproc.c ../config.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h options.h ../include/util.h ../include/errors.h \
+	keydb.h main.h status.h
+mdfilter.o: mdfilter.c ../config.h ../include/errors.h \
+	../include/iobuf.h ../include/types.h ../include/memory.h \
+	../include/util.h ../include/mpi.h filter.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h
+openfile.o: openfile.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/ttyio.h options.h main.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	keydb.h packet.h filter.h
+parse-packet.o: parse-packet.c ../config.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/util.h ../include/errors.h options.h
+passphrase.o: passphrase.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h options.h \
+	../include/ttyio.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h keydb.h packet.h filter.h
+pkclist.o: pkclist.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h \
+	trustdb.h ../include/ttyio.h ../include/i18n.h
+plaintext.o: plaintext.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h options.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/ttyio.h main.h keydb.h ../include/i18n.h
+pubkey-enc.o: pubkey-enc.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h keydb.h
+revoke.o: revoke.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h \
+	../include/ttyio.h
+ringedit.o: ringedit.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h packet.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h filter.h keydb.h
+rsa.o: rsa.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h
+seckey-cert.o: seckey-cert.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h keydb.h
+seskey.o: seskey.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h main.h keydb.h packet.h filter.h
+sig-check.o: sig-check.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h keydb.h main.h
+sign.o: sign.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h \
+	../include/ttyio.h ../include/i18n.h
+skclist.o: skclist.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h
+status.o: status.c ../config.h status.h
+textfilter.o: textfilter.c ../config.h ../include/errors.h \
+	../include/iobuf.h ../include/types.h ../include/memory.h \
+	../include/util.h ../include/mpi.h filter.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h
+trustdb.o: trustdb.c ../config.h ../include/errors.h ../include/iobuf.h \
+	../include/types.h keydb.h packet.h ../include/mpi.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h filter.h ../include/util.h \
+	trustdb.h options.h main.h
+verify.o: verify.c ../config.h options.h packet.h ../include/types.h \
+	../include/iobuf.h ../include/mpi.h ../include/memory.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/blowfish.h \
+	../include/../cipher/elgamal.h ../include/../cipher/random.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h \
+	../include/ttyio.h ../include/i18n.h
 
 info:
 dvi:
@@ -357,6 +649,9 @@
 mostlyclean-generic distclean-generic clean-generic \
 maintainer-clean-generic clean mostlyclean distclean maintainer-clean
 
+
+g10maint.c : g10.c
+	    $(CPP) $(DEFS) $(INCLUDES) -DIS_G10MAINT  $<  > $@ || rm $@
 
 $(PROGRAMS): $(needed_libs)
 
diff -urN gnupg-0.2.11/g10/armor.c gnupg-0.2.12/g10/armor.c
--- gnupg-0.2.11/g10/armor.c	Fri Feb 27 18:12:54 1998
+++ gnupg-0.2.12/g10/armor.c	Sat Mar  7 11:56:22 1998
@@ -322,7 +322,7 @@
 			    buf[--n] = 0;
 			if( opt.verbose ) {
 			    log_info("armor header: ");
-			    print_string( stderr, buf, n );
+			    print_string( stderr, buf, n, 0 );
 			    putc('\n', stderr);
 			}
 			if( clearsig && !parse_hash_header( buf ) ) {
@@ -348,7 +348,7 @@
 		}
 		else {
 		    log_error("invalid armor header: ");
-		    print_string( stderr, buf, n );
+		    print_string( stderr, buf, n, 0 );
 		    putc('\n', stderr);
 		    state = fhdrERROR;
 		}
@@ -357,7 +357,7 @@
 		if( strchr( buf, ':') ) { /* buffer to short, but this is okay*/
 		    if( opt.verbose ) {
 			log_info("armor header: ");
-			print_string( stderr, buf, n );
+			print_string( stderr, buf, n, 0 );
 			fputs("[...]\n", stderr);  /* indicate it is truncated */
 		    }
 		    state = fhdrSKIPHeader;  /* skip rest of line */
@@ -462,7 +462,7 @@
 	    }
 	    else {
 		log_error("invalid dash escaped line: ");
-		print_string( stderr, buf, n );
+		print_string( stderr, buf, n, 0 );
 		putc('\n', stderr);
 		state = fhdrERROR;
 	    }
@@ -531,7 +531,7 @@
 
 	  case fhdrERRORShow:
 	    log_error("invalid clear text header: ");
-	    print_string( stderr, buf, n );
+	    print_string( stderr, buf, n, 0 );
 	    putc('\n', stderr);
 	    state = fhdrERROR;
 	    break;
diff -urN gnupg-0.2.11/g10/compress.c gnupg-0.2.12/g10/compress.c
--- gnupg-0.2.11/g10/compress.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.12/g10/compress.c	Thu Mar  5 13:38:19 1998
@@ -230,9 +230,11 @@
  * Handle a compressed packet
  */
 int
-handle_compressed( PKT_compressed *cd )
+handle_compressed( PKT_compressed *cd,
+		   int (*callback)(IOBUF, void *), void *passthru )
 {
     compress_filter_context_t cfx;
+    int rc;
 
     memset( &cfx, 0, sizeof cfx );
     if( cd->algorithm == 1 )
@@ -241,7 +243,10 @@
 	return G10ERR_COMPR_ALGO;
 
     iobuf_push_filter( cd->buf, compress_filter, &cfx );
-    proc_packets(cd->buf);
+    if( callback )
+	rc = callback(cd->buf, passthru );
+    else
+	rc = proc_packets(cd->buf);
     iobuf_pop_filter( cd->buf, compress_filter, &cfx );
   #if 0
     if( cd->len )
@@ -250,6 +255,6 @@
 	iobuf_clear_eof( cd->buf );
   #endif
     cd->buf = NULL;
-    return 0;
+    return rc;
 }
 
diff -urN gnupg-0.2.11/g10/decrypt.c gnupg-0.2.12/g10/decrypt.c
--- gnupg-0.2.11/g10/decrypt.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.12/g10/decrypt.c	Fri Mar  6 11:41:44 1998
@@ -0,0 +1,82 @@
+/* verify.c - verify signed data
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <assert.h>
+
+#include "options.h"
+#include "packet.h"
+#include "errors.h"
+#include "iobuf.h"
+#include "keydb.h"
+#include "memory.h"
+#include "util.h"
+#include "main.h"
+#include "i18n.h"
+
+
+
+/****************
+ * Assume that the input is an encrypted message and decrypt
+ * (and if signed, verify the signature) it.
+ * This command differs from the default operation, as it never
+ * write to the filename which is included in the file and that it
+ * rejects files which don't begin with an encrypted message.
+ */
+
+int
+decrypt_message( const char *filename )
+{
+    IOBUF fp;
+    armor_filter_context_t afx;
+    int rc;
+    int no_out=0;
+
+    /* open the message file */
+    fp = iobuf_open(filename);
+    if( !fp ) {
+	log_error(_("can't open '%s'\n"), print_fname_stdin(filename));
+	return G10ERR_OPEN_FILE;
+    }
+
+    if( !opt.no_armor ) {
+	if( use_armor_filter( fp ) ) {
+	    memset( &afx, 0, sizeof afx);
+	    iobuf_push_filter( fp, armor_filter, &afx );
+	}
+    }
+
+    if( !opt.outfile ) {
+	no_out = 1;
+	opt.outfile = "-";
+    }
+    rc = proc_encryption_packets( fp );
+    if( no_out )
+       opt.outfile = NULL;
+    iobuf_close(fp);
+    return rc;
+}
+
+
+
diff -urN gnupg-0.2.11/g10/g10.c gnupg-0.2.12/g10/g10.c
--- gnupg-0.2.11/g10/g10.c	Mon Mar  2 14:24:14 1998
+++ gnupg-0.2.12/g10/g10.c	Sat Mar  7 11:59:24 1998
@@ -18,6 +18,12 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
  */
 
+/****************
+ * We use cpp to generate the source g10maint.c (IS_G10MAINT) from this
+ * source; the main difference is, that g10maint can only work with public
+ * keys and does not need to lock memory or run suid.
+ */
+
 #include <config.h>
 #include <errno.h>
 #include <stdio.h>
@@ -40,11 +46,16 @@
 #include "i18n.h"
 #include "status.h"
 
+#ifndef IS_G10MAINT
+  #define IS_G10 1
+#endif
+
 
 static ARGPARSE_OPTS opts[] = {
 
     { 300, NULL, 0, N_("\vCommands:\n ") },
 
+  #ifdef IS_G10
     { 's', "sign",      0, N_("make a signature")},
     { 539, "clearsign", 0, N_("make a clear text signature") },
     { 'b', "detach-sign", 0, N_("make a detached signature")},
@@ -52,28 +63,42 @@
     { 'c', "symmetric", 0, N_("encryption only with symmetric cipher")},
     { 507, "store",     0, N_("store only")},
     { 'd', "decrypt",   0, N_("decrypt data (default)")},
-    { 'k', "list-keys", 0, N_("list keys")},
-    { 508, "check-keys",0, N_("check signatures on a key in the keyring")},
-    { 515, "fingerprint", 0, N_("show the fingerprints")},
-    { 521, "list-packets",0,N_("list only the sequence of packets")},
+    { 550, "verify"   , 0, N_("verify a signature")},
+  #endif
+    { 551, "list-keys", 0, N_("list keys")},
+    { 552, "list-sigs", 0, N_("list keys and signatures")},
+    { 508, "check-sigs",0, N_("check key signatures")},
+    { 515, "fingerprint", 0, N_("list keys and fingerprints")},
+  #ifdef IS_G10
     { 503, "gen-key",   0, N_("generate a new key pair")},
     { 506, "sign-key"  ,0, N_("make a signature on a key in the keyring")},
     { 505, "delete-key",0, N_("remove key from the public keyring")},
-    { 524, "edit-sig"  ,0, N_("edit a key signature")},
+    { 524, "edit-key"  ,0, N_("edit a key signature")},
     { 525, "change-passphrase", 0, N_("change the passphrase of your secret keyring")},
     { 542, "gen-revoke",0, N_("generate a revocation certificate")},
+  #endif
     { 537, "export"          , 0, N_("export keys") },
     { 530, "import",      0     , N_("import/merge keys")},
+    { 521, "list-packets",0,N_("list only the sequence of packets")},
+  #ifdef IS_G10MAINT
+    { 546, "dearmor", 0, N_("De-Armor a file or stdin") },
+    { 547, "enarmor", 0, N_("En-Armor a file or stdin") },
+    { 516, "print-mds" , 0, N_("print all message digests")},
+    { 513, "gen-prime" , 0, "\r" },
+    { 548, "gen-random" , 0, "\r" },
+  #endif
 
     { 301, NULL, 0, N_("\v\nOptions:\n ") },
 
+  #ifdef IS_G10
     { 'a', "armor",     0, N_("create ascii armored output")},
-    { 'o', "output",    2, N_("use as output file")},
     { 'u', "local-user",2, N_("use this user-id to sign or decrypt")},
     { 'r', "remote-user", 2, N_("use this user-id for encryption")},
-    { 'v', "verbose",   0, N_("verbose") },
     { 'z', NULL,        1, N_("set compress level (0 disables)") },
     { 't', "textmode",  0, N_("use canonical text mode")},
+  #endif
+    { 'o', "output",    2, N_("use as output file")},
+    { 'v', "verbose",   0, N_("verbose") },
     { 'n', "dry-run",   0, N_("don't make any changes") },
     { 500, "batch",     0, N_("batch mode: never ask")},
     { 501, "yes",       0, N_("assume yes on most questions")},
@@ -88,18 +113,33 @@
     { 534, "no-comment", 0,   N_("do not write comment packets")},
     { 535, "completes-needed", 1, N_("(default is 1)")},
     { 536, "marginals-needed", 1, N_("(default is 3)")},
+  #ifdef IS_G10
     { 527, "cipher-algo", 2 , N_("select default cipher algorithm")},
     { 528, "pubkey-algo", 2 , N_("select default puplic key algorithm")},
     { 529, "digest-algo", 2 , N_("select default message digest algorithm")},
+  #endif
 
+  #ifdef IS_G10
     { 302, NULL, 0, N_("\v\nExamples:\n\n"
     " -se -r Bob [file]          sign and encrypt for user Bob\n"
     " -sat [file]                make a clear text signature\n"
     " -sb  [file]                make a detached signature\n"
     " -k   [userid]              show keys\n"
     " -kc  [userid]              show fingerprint\n"  ) },
+  #endif
 
   /* hidden options */
+  #ifdef IS_G10MAINT
+    { 514, "test"      , 0, "\r" },
+    { 531, "list-trustdb",0 , "\r"},
+    { 533, "list-trust-path",0, "\r"},
+  #endif
+  #ifdef IS_G10
+    { 'k', NULL,        0, "\r"},
+    { 504, "delete-secret-key",0, "\r" },
+    { 524, "edit-sig"  ,0, "\r"}, /* alias for edit-key */
+    { 523, "passphrase-fd",1, "\r" },
+  #endif
     { 532, "quick-random", 0, "\r"},
     { 526, "no-verbose", 0, "\r"},
     { 538, "trustdb-name", 2, "\r" },
@@ -107,11 +147,15 @@
     { 519, "no-armor",   0, "\r"},
     { 520, "no-default-keyring", 0, "\r" },
     { 522, "no-greeting", 0, "\r" },
-    { 523, "passphrase-fd",1, "\r" },
     { 541, "no-operation", 0, "\r" },      /* used by regression tests */
     { 543, "no-options", 0, "\r" }, /* shortcut for --options /dev/null */
     { 544, "homedir", 2, "\r" },   /* defaults to "~/.gnupg" */
     { 545, "no-batch", 0, "\r" },
+    { 549, "with-colons", 0, "\r"},
+    { 551, "list-key", 0, "\r" }, /* alias */
+    { 552, "list-sig", 0, "\r" }, /* alias */
+    { 508, "check-sig",0, "\r" }, /* alias */
+
 
 {0} };
 
@@ -120,9 +164,11 @@
 
 enum cmd_values { aNull = 0,
     aSym, aStore, aEncr, aKeygen, aSign, aSignEncr,
-    aSignKey, aClearsign, aListPackets, aEditSig, aDeleteKey,
-    aKMode, aKModeC, aChangePass, aImport,
-    aExport, aCheckKeys, aGenRevoke,
+    aSignKey, aClearsign, aListPackets, aEditSig, aDeleteKey, aDeleteSecretKey,
+    aKMode, aKModeC, aChangePass, aImport, aVerify, aDecrypt, aListKeys,
+    aListSigs,
+    aExport, aCheckKeys, aGenRevoke, aPrimegen, aPrintMDs,
+    aListTrustDB, aListTrustPath, aDeArmor, aEnArmor, aGenRandom, aTest,
 aNOP };
 
 
@@ -130,6 +176,11 @@
 			 const char *(*mapf)(int), int (*chkf)(int) );
 static void set_cmd( enum cmd_values *ret_cmd,
 			enum cmd_values new_cmd );
+#ifdef IS_G10MAINT
+static void print_hex( byte *p, size_t n );
+static void print_mds( const char *fname );
+static void do_test(int);
+#endif
 
 const char *
 strusage( int level )
@@ -137,21 +188,36 @@
   static char *digests, *pubkeys, *ciphers;
     const char *p;
     switch( level ) {
-      case 11: p = "gpg (GNUPG)"; break;
+      case 11: p =
+	  #ifdef IS_G10MAINT
+	    "gpgm (GNUPG)";
+	  #else
+	    "gpg (GNUPG)";
+	  #endif
+	break;
       case 13: p = VERSION; break;
       case 17: p = PRINTABLE_OS_NAME; break;
-      case 19: p = _(
-"Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"
-	); break;
+      case 19: p =
+	    _("Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n");
+	break;
       case 1:
-      case 40:	p = _(
-"Usage: gpg [options] [files] (-h for help)"
-	); break;
-      case 41:	p = _(
-"Syntax: gpg [options] [files]\n"
-"sign, check, encrypt or decrypt\n"
-"default operation depends on the input data\n"
-	); break;
+      case 40:	p =
+	  #ifdef IS_G10MAINT
+	    _("Usage: gpgm [options] [files] (-h for help)");
+	  #else
+	    _("Usage: gpg [options] [files] (-h for help)");
+	  #endif
+	break;
+      case 41:	p =
+	  #ifdef IS_G10MAINT
+	    _("Syntax: gpgm [options] [files]\n"
+	      "GNUPG maintenance utility\n");
+	  #else
+	    _("Syntax: gpg [options] [files]\n"
+	      "sign, check, encrypt or decrypt\n"
+	      "default operation depends on the input data\n");
+	  #endif
+	break;
 
       case 31: p = "\n"; break;
       case 32:
@@ -223,7 +289,11 @@
 static void
 wrong_args( const char *text)
 {
+  #ifdef IS_G10MAINT
+    fputs(_("usage: gpgm [options] "),stderr);
+  #else
     fputs(_("usage: gpg [options] "),stderr);
+  #endif
     fputs(text,stderr);
     putc('\n',stderr);
     g10_exit(2);
@@ -297,7 +367,7 @@
     int rc=0;
     int orig_argc;
     char **orig_argv;
-    const char *fname, *fname_print;
+    const char *fname;
     STRLIST sl, remusr= NULL, locusr=NULL;
     int nrings=0, sec_nrings=0;
     armor_filter_context_t afx;
@@ -313,12 +383,17 @@
     enum cmd_values cmd = 0;
     const char *trustdb_name = NULL;
 
+  #ifdef IS_G10MAINT
+    secmem_init( 0 );	   /* disable use of secmem */
+    log_set_name("gpgm");
+  #else
     /* Please note that we may running SUID(ROOT), so be very CAREFUL
      * when adding any stuff between here and the call to
      * secmem_init()  somewhere after the option parsing
      */
-
     log_set_name("gpg");
+    secure_random_alloc(); /* put random number into secure memory */
+  #endif
     i18n_init();
     opt.compress = -1; /* defaults to standard compress level */
     opt.def_cipher_algo = CIPHER_ALGO_BLOWFISH;
@@ -389,38 +464,71 @@
     while( optfile_parse( configfp, configname, &configlineno,
 						&pargs, opts) ) {
 	switch( pargs.r_opt ) {
-	  case 'v': opt.verbose++; opt.list_sigs=1; break;
-	  case 'z': opt.compress = pargs.r.ret_int; break;
+
+	#ifdef IS_G10
 	  case 'a': opt.armor = 1; opt.no_armor=0; break;
-	  case 'd': break; /* it is default */
-	  case 'c': set_cmd( &cmd , aSym); break;
-	  case 'o': opt.outfile = pargs.r.ret_str; break;
+	  case 'b': detached_sig = 1; set_cmd( &cmd, aSign ); break;
+	  case 'c': set_cmd( &cmd, aSym); break;
+	  case 'd': set_cmd( &cmd, aDecrypt); break;
 	  case 'e': set_cmd( &cmd, aEncr); break;
-	  case 'b': detached_sig = 1; /* fall trough */
+	  case 'r': /* store the remote users */
+	    sl = m_alloc( sizeof *sl + strlen(pargs.r.ret_str));
+	    strcpy(sl->d, pargs.r.ret_str);
+	    sl->next = remusr;
+	    remusr = sl;
+	    break;
 	  case 's': set_cmd( &cmd, aSign );  break;
-	  case 't': set_cmd( &cmd , aClearsign);  break;
+	  case 't': opt.textmode=1;  break;
 	  case 'u': /* store the local users */
 	    sl = m_alloc( sizeof *sl + strlen(pargs.r.ret_str));
 	    strcpy(sl->d, pargs.r.ret_str);
 	    sl->next = locusr;
 	    locusr = sl;
 	    break;
-	  case 'r': /* store the remote users */
-	    sl = m_alloc( sizeof *sl + strlen(pargs.r.ret_str));
-	    strcpy(sl->d, pargs.r.ret_str);
-	    sl->next = remusr;
-	    remusr = sl;
+	  case 'z': opt.compress = pargs.r.ret_int; break;
+	  case 503: set_cmd( &cmd, aKeygen); break;
+	  case 504: set_cmd( &cmd, aDeleteSecretKey); break;
+	  case 505: set_cmd( &cmd, aDeleteKey); break;
+	  case 506: set_cmd( &cmd, aSignKey); break;
+	  case 507: set_cmd( &cmd, aStore); break;
+	  case 523: set_passphrase_fd( pargs.r.ret_int ); break;
+	  case 524: set_cmd( &cmd, aEditSig); break;
+	  case 525: set_cmd( &cmd, aChangePass); break;
+	  case 527:
+	    opt.def_cipher_algo = string_to_cipher_algo(pargs.r.ret_str);
+	    break;
+	  case 528:
+	    opt.def_pubkey_algo = string_to_pubkey_algo(pargs.r.ret_str);
+	    break;
+	  case 529:
+	    opt.def_digest_algo = string_to_digest_algo(pargs.r.ret_str);
 	    break;
+	  case 539: set_cmd( &cmd, aClearsign); break;
+	  case 540: secmem_set_flags( secmem_get_flags() | 1 ); break;
+	  case 542: set_cmd( &cmd, aGenRevoke); break;
+	  case 550: set_cmd( &cmd, aVerify); break;
+	#endif /* IS_G10 */
+
+	#ifdef IS_G10MAINT
+	  case 513: set_cmd( &cmd, aPrimegen); break;
+	  case 514: set_cmd( &cmd, aTest); break;
+	  case 516: set_cmd( &cmd, aPrintMDs); break;
+	  case 531: set_cmd( &cmd, aListTrustDB); break;
+	  case 533: set_cmd( &cmd, aListTrustPath); break;
+	  case 540: break; /* dummy */
+	  case 546: set_cmd( &cmd, aDeArmor); break;
+	  case 547: set_cmd( &cmd, aEnArmor); break;
+	  case 548: set_cmd( &cmd, aGenRandom); break;
+	#endif /* IS_G10MAINT */
+
+	  case 'o': opt.outfile = pargs.r.ret_str; break;
+	  case 'v': opt.verbose++; opt.list_sigs=1; break;
 	  case 'k': set_cmd( &cmd, aKMode ); break;
+
 	  case 500: opt.batch = 1; greeting = 0; break;
 	  case 501: opt.answer_yes = 1; break;
 	  case 502: opt.answer_no = 1; break;
-	  case 503: set_cmd( &cmd, aKeygen); break;
-	  case 505: set_cmd( &cmd, aDeleteKey); break;
-	  case 506: set_cmd( &cmd, aSignKey); break;
-	  case 507: set_cmd( &cmd, aStore); break;
-	  case 508: set_cmd( &cmd, aCheckKeys);
-		    opt.check_sigs = 1; opt.list_sigs = 1; break;
+	  case 508: set_cmd( &cmd, aCheckKeys); break;
 	  case 509: add_keyring(pargs.r.ret_str); nrings++; break;
 	  case 510: opt.debug |= pargs.r.ret_ulong; break;
 	  case 511: opt.debug = ~0; break;
@@ -439,19 +547,7 @@
 	  case 520: default_keyring = 0; break;
 	  case 521: set_cmd( &cmd, aListPackets); break;
 	  case 522: greeting = 0; break;
-	  case 523: set_passphrase_fd( pargs.r.ret_int ); break;
-	  case 524: set_cmd( &cmd, aEditSig); break;
-	  case 525: set_cmd( &cmd, aChangePass); break;
 	  case 526: opt.verbose = 0; opt.list_sigs=0; break;
-	  case 527:
-	    opt.def_cipher_algo = string_to_cipher_algo(pargs.r.ret_str);
-	    break;
-	  case 528:
-	    opt.def_pubkey_algo = string_to_pubkey_algo(pargs.r.ret_str);
-	    break;
-	  case 529:
-	    opt.def_digest_algo = string_to_digest_algo(pargs.r.ret_str);
-	    break;
 	  case 530: set_cmd( &cmd, aImport); break;
 	  case 532: quick_random_gen(1); break;
 	  case 534: opt.no_comment=1; break;
@@ -459,13 +555,13 @@
 	  case 536: opt.marginals_needed = pargs.r.ret_int; break;
 	  case 537: set_cmd( &cmd, aExport); break;
 	  case 538: trustdb_name = pargs.r.ret_str; break;
-	  case 539: set_cmd( &cmd, aClearsign); break;
-	  case 540: secmem_set_flags( secmem_get_flags() | 1 ); break;
 	  case 541: set_cmd( &cmd, aNOP); break;
-	  case 542: set_cmd( &cmd, aGenRevoke); break;
 	  case 543: break; /* no-options */
 	  case 544: opt.homedir = pargs.r.ret_str; break;
 	  case 545: opt.batch = 0; break;
+	  case 549: opt.with_colons=':'; break;
+	  case 551: set_cmd( &cmd, aListKeys); break;
+	  case 552: set_cmd( &cmd, aListSigs); break;
 	  default : errors++; pargs.err = configfp? 1:2; break;
 	}
     }
@@ -485,13 +581,18 @@
 	tty_printf("%s\n", strusage(15) );
     }
 
+  #ifdef IS_G10
     /* initialize the secure memory. */
     secmem_init( 16384 );
     /* Okay, we are now working under our real uid */
+  #endif
 
-    write_status( STATUS_ENTER );
+    /*write_status( STATUS_ENTER );*/
 
     set_debug();
+    if( !cmd && opt.fingerprint )
+	set_cmd( &cmd, aListKeys);
+
     if( cmd == aKMode || cmd == aKModeC ) { /* kludge to be compatible to pgp */
 	if( cmd == aKModeC ) {
 	    opt.fingerprint = 1;
@@ -505,30 +606,52 @@
 
 	opt.verbose = opt.verbose > 1;
     }
+
+
+    /* kludge to let -sat generate a clear text signature */
+    if( opt.textmode && !detached_sig && opt.armor && cmd == aSign )
+	cmd = aClearsign;
+
     if( opt.verbose > 1 )
 	set_packet_list_mode(1);
 
-    if( !sec_nrings || default_keyring )  /* add default secret rings */
-	add_secret_keyring("secring.gpg");
-    if( !nrings || default_keyring )  /* add default ring */
-	add_keyring("pubring.gpg");
-
-    if( argc ) {
-	fname_print = fname = *argv;
+    /* add the keyrings, but not for some special commands and
+     * not in case of "-kvv userid keyring" */
+    if( cmd != aDeArmor && cmd != aEnArmor
+	&& !(cmd == aKMode && argc == 2 ) ) {
+	if( !sec_nrings || default_keyring )  /* add default secret rings */
+	    add_secret_keyring("secring.gpg");
+	if( !nrings || default_keyring )  /* add default ring */
+	    add_keyring("pubring.gpg");
     }
+
+    if( argc )
+	fname = *argv;
     else {
-	fname_print = "[stdin]";
 	fname = NULL;
 	if( get_passphrase_fd() == 0 ) {
 	    /* reading data and passphrase form stdin:
 	     * we assume the first line is the passphrase, so
-	     * we read it now
+	     * we better should read it now.
 	     */
 	    /* FIXME: doit */
 	}
     }
 
-    rc = init_trustdb(1, trustdb_name );
+    switch( cmd ) {
+      case aPrimegen:
+      case aPrintMDs:
+      case aGenRandom:
+      case aDeArmor:
+      case aEnArmor:
+	break;
+      case aKMode:
+      case aListKeys:
+      case aCheckKeys:
+	break;
+      case aListTrustDB: rc = init_trustdb( argc? 1:0, trustdb_name ); break;
+      default: rc = init_trustdb(1, trustdb_name ); break;
+    }
     if( rc )
 	log_error(_("failed to initialize the TrustDB: %s\n"), g10_errstr(rc));
 
@@ -539,21 +662,22 @@
 	    wrong_args(_("--store [filename]"));
 	if( (rc = encode_store(fname)) )
 	    log_error("%s: store failed: %s\n",
-				    fname_print, g10_errstr(rc) );
+				 print_fname_stdin(fname), g10_errstr(rc) );
 	break;
-
+    #ifdef IS_G10
       case aSym: /* encrypt the given file only with the symmetric cipher */
 	if( argc > 1 )
 	    wrong_args(_("--symmetric [filename]"));
 	if( (rc = encode_symmetric(fname)) )
-	    log_error("%s: symmetric encryption failed: %s\n", fname_print, g10_errstr(rc) );
+	    log_error("%s: symmetric encryption failed: %s\n",
+			    print_fname_stdin(fname), g10_errstr(rc) );
 	break;
 
       case aEncr: /* encrypt the given file */
 	if( argc > 1 )
 	    wrong_args(_("--encrypt [filename]"));
 	if( (rc = encode_crypt(fname,remusr)) )
-	    log_error("%s: encryption failed: %s\n", fname_print, g10_errstr(rc) );
+	    log_error("%s: encryption failed: %s\n", print_fname_stdin(fname), g10_errstr(rc) );
 	break;
 
       case aSign: /* sign the given file */
@@ -585,7 +709,7 @@
 	else
 	    sl = NULL;
 	if( (rc = sign_file(sl, detached_sig, locusr, 1, remusr, NULL)) )
-	    log_error("%s: sign+encrypt failed: %s\n", fname_print, g10_errstr(rc) );
+	    log_error("%s: sign+encrypt failed: %s\n", print_fname_stdin(fname), g10_errstr(rc) );
 	free_strlist(sl);
 	break;
 
@@ -593,7 +717,19 @@
 	if( argc > 1 )
 	    wrong_args(_("--clearsign [filename]"));
 	if( (rc = clearsign_file(fname, locusr, NULL)) )
-	    log_error("%s: clearsign failed: %s\n", fname_print, g10_errstr(rc) );
+	    log_error("%s: clearsign failed: %s\n", print_fname_stdin(fname), g10_errstr(rc) );
+	break;
+
+      case aVerify:
+	if( (rc = verify_signatures( argc, argv ) ))
+	    log_error("verify signatures failed: %s\n", g10_errstr(rc) );
+	break;
+
+      case aDecrypt:
+	if( argc > 1 )
+	    wrong_args(_("--decrypt [filename]"));
+	if( (rc = decrypt_message( fname ) ))
+	    log_error("decrypt_message failed: %s\n", g10_errstr(rc) );
 	break;
 
 
@@ -602,7 +738,7 @@
 	    wrong_args(_("--sign-key username"));
 	/* note: fname is the user id! */
 	if( (rc = sign_key(fname, locusr)) )
-	    log_error("%s: sign key failed: %s\n", fname_print, g10_errstr(rc) );
+	    log_error("%s: sign key failed: %s\n", print_fname_stdin(fname), g10_errstr(rc) );
 	break;
 
       case aEditSig: /* Edit a key signature */
@@ -610,73 +746,64 @@
 	    wrong_args(_("--edit-sig username"));
 	/* note: fname is the user id! */
 	if( (rc = edit_keysigs(fname)) )
-	    log_error("%s: edit signature failed: %s\n", fname_print, g10_errstr(rc) );
+	    log_error("%s: edit signature failed: %s\n", print_fname_stdin(fname), g10_errstr(rc) );
 	break;
 
+      case aDeleteSecretKey:
+	if( argc != 1 )
+	    wrong_args(_("--delete-secret-key username"));
       case aDeleteKey:
 	if( argc != 1 )
 	    wrong_args(_("--delete-key username"));
 	/* note: fname is the user id! */
-	if( (rc = delete_key(fname)) )
-	    log_error("%s: delete key failed: %s\n", fname_print, g10_errstr(rc) );
+	if( (rc = delete_key(fname, cmd==aDeleteSecretKey)) )
+	    log_error("%s: delete key failed: %s\n", print_fname_stdin(fname), g10_errstr(rc) );
 	break;
 
-      case aChangePass: /* Chnage the passphrase */
+      case aChangePass: /* Change the passphrase */
 	if( argc > 1 ) /* no arg: use default, 1 arg use this one */
 	    wrong_args(_("--change-passphrase [username]"));
 	/* note: fname is the user id! */
 	if( (rc = change_passphrase(fname)) )
-	    log_error("%s: change passphrase failed: %s\n", fname_print,
+	    log_error("%s: change passphrase failed: %s\n", print_fname_stdin(fname),
 						       g10_errstr(rc) );
 	break;
+      #endif /* IS_G10 */
 
       case aCheckKeys:
-      case aKMode: /* list keyring */
-	if( !argc ) { /* list the default public keyrings */
-	    int i, seq=0;
-	    const char *s;
-
-	    while( (s=get_keyring(seq++)) ) {
-		if( !(a = iobuf_open(s)) ) {
-		    log_error(_("can't open '%s'\n"), s);
-		    continue;
-		}
-		if( seq > 1 )
-		    putchar('\n');
-		printf("%s\n", s );
-		for(i=strlen(s); i; i-- )
-		    putchar('-');
-		putchar('\n');
+	opt.check_sigs = 1;
+      case aListSigs:
+	opt.list_sigs = 1;
+      case aListKeys:
+	std_key_list( argc, argv );
+	break;
 
-		proc_packets( a );
-		iobuf_close(a);
+      case aKMode: /* list keyring */
+	if( argc < 2 )	/* -kv [userid] */
+	    std_key_list( (argc && **argv)? 1:0, argv );
+	else if( argc == 2 ) { /* -kv userid keyring */
+	    if( access( argv[1], R_OK ) ) {
+		log_error(_("can't open %s: %s\n"),
+			       print_fname_stdin(argv[1]), strerror(errno));
 	    }
-
-	}
-	else if( cmd == aCheckKeys ) {
-	    log_error("will be soon: --check-keys user-ids\n");
-	}
-	else if( argc == 1) { /* list the given keyring */
-	    if( !(a = iobuf_open(fname)) )
-		log_error(_("can't open '%s'\n"), fname_print);
 	    else {
-		if( !opt.no_armor ) {
-		    memset( &afx, 0, sizeof afx);
-		    iobuf_push_filter( a, armor_filter, &afx );
-		}
-		proc_packets( a );
-		iobuf_close(a);
+		/* add keyring (default keyrings are not registered in this
+		 * special case */
+		add_keyring( argv[1] );
+		std_key_list( **argv?1:0, argv );
 	    }
 	}
 	else
-	    wrong_args(_("-k[v][v][v][c] [keyring]") );
+	    wrong_args(_("-k[v][v][v][c] [userid] [keyring]") );
 	break;
 
+    #ifdef IS_G10
       case aKeygen: /* generate a key (interactive) */
 	if( argc )
 	    wrong_args(_("--gen-key"));
 	generate_keypair();
 	break;
+    #endif
 
       case aImport:
 	if( !argc  ) {
@@ -700,11 +827,100 @@
 	free_strlist(sl);
 	break;
 
+    #ifdef IS_G10
       case aGenRevoke:
 	if( argc != 1 )
 	    wrong_args("--gen-revoke user-id");
 	gen_revoke( *argv );
 	break;
+    #endif
+
+    #ifdef IS_G10MAINT
+      case aDeArmor:
+	if( argc > 1 )
+	    wrong_args("--dearmor [file]");
+	rc = dearmor_file( argc? *argv: NULL );
+	if( rc )
+	    log_error(_("dearmoring failed: %s\n"), g10_errstr(rc));
+	break;
+
+      case aEnArmor:
+	if( argc > 1 )
+	    wrong_args("--enarmor [file]");
+	rc = enarmor_file( argc? *argv: NULL );
+	if( rc )
+	    log_error(_("enarmoring failed: %s\n"), g10_errstr(rc));
+	break;
+
+
+      case aPrimegen:
+	if( argc == 1 ) {
+	    mpi_print( stdout, generate_public_prime( atoi(argv[0]) ), 1);
+	    putchar('\n');
+	}
+	else if( argc == 2 ) {
+	    mpi_print( stdout, generate_elg_prime( atoi(argv[0]),
+						   atoi(argv[1]), NULL,NULL ), 1);
+	    putchar('\n');
+	}
+	else if( argc == 3 ) {
+	    MPI g = mpi_alloc(1);
+	    mpi_print( stdout, generate_elg_prime( atoi(argv[0]),
+						   atoi(argv[1]), g, NULL ), 1);
+	    printf("\nGenerator: ");
+	    mpi_print( stdout, g, 1 );
+	    putchar('\n');
+	    mpi_free(g);
+	}
+	else
+	    usage(1);
+	break;
+
+      case aGenRandom:
+	if( argc < 1 || argc > 2 )
+	    wrong_args("--gen-random level [hex]");
+	{
+	    int level = atoi(*argv);
+	    for(;;) {
+		int c = get_random_byte(level);
+		if( argc == 1 ) {
+		    printf("%02x", c );
+		    fflush(stdout);
+		}
+		else
+		    putchar(c&0xff);
+	    }
+	}
+	break;
+
+      case aPrintMDs:
+	if( !argc )
+	    print_mds(NULL);
+	else {
+	    for(; argc; argc--, argv++ )
+		print_mds(*argv);
+	}
+	break;
+
+      case aTest: do_test( argc? atoi(*argv): 1 ); break;
+
+      case aListTrustDB:
+	if( !argc )
+	    list_trustdb(NULL);
+	else {
+	    for( ; argc; argc--, argv++ )
+		list_trustdb( *argv );
+	}
+	break;
+
+      case aListTrustPath:
+	if( argc != 2 )
+	    wrong_args("--list-trust-path [-- -]<maxdepth> <username>");
+	list_trust_path( atoi(*argv), argv[1] );
+	break;
+
+     #endif /* IS_G10MAINT */
+
 
       case aNOP:
 	break;
@@ -712,10 +928,11 @@
       case aListPackets:
 	opt.list_packets=1;
       default:
+	/* fixme: g10maint should to regular maintenace tasks here */
 	if( argc > 1 )
 	    wrong_args(_("[filename]"));
 	if( !(a = iobuf_open(fname)) )
-	    log_error(_("can't open '%s'\n"), fname_print);
+	    log_error(_("can't open '%s'\n"), print_fname_stdin(fname));
 	else {
 	    if( !opt.no_armor ) {
 		if( use_armor_filter( a ) ) {
@@ -747,8 +964,115 @@
 	secmem_dump_stats();
     secmem_term();
     rc = rc? rc : log_get_errorcount(0)? 2:0;
-    write_status( STATUS_LEAVE );
+    /*write_status( STATUS_LEAVE );*/
     exit(rc );
 }
 
+#ifdef IS_G10MAINT
+static void
+print_hex( byte *p, size_t n )
+{
+    int i;
+
+    if( n == 20 ) {
+	for(i=0; i < n ; i++, i++, p += 2 ) {
+	    if( i == 10 )
+		putchar(' ');
+	    printf(" %02X%02X", *p, p[1] );
+	}
+    }
+    else {
+	for(i=0; i < n ; i++, p++ ) {
+	    if( i && !(i%8) )
+		putchar(' ');
+	    printf(" %02X", *p );
+	}
+    }
+}
+
+static void
+print_mds( const char *fname )
+{
+    FILE *fp;
+    char buf[1024];
+    size_t n;
+    MD_HANDLE md;
+
+    if( !fname ) {
+	fp = stdin;
+	fname = "[stdin]";
+    }
+    else
+	fp = fopen( fname, "rb" );
+    if( !fp ) {
+	log_error("%s: %s\n", fname, strerror(errno) );
+	return;
+    }
+
+    md = md_open( DIGEST_ALGO_MD5, 0 );
+    md_enable( md, DIGEST_ALGO_RMD160 );
+    md_enable( md, DIGEST_ALGO_SHA1 );
+
+    while( (n=fread( buf, 1, DIM(buf), fp )) )
+	md_write( md, buf, n );
+    if( ferror(fp) )
+	log_error("%s: %s\n", fname, strerror(errno) );
+    else {
+	md_final(md);
+	printf(  "%s:    MD5 =", fname ); print_hex(md_read(md, DIGEST_ALGO_MD5), 16 );
+	printf("\n%s: RMD160 =", fname ); print_hex(md_read(md, DIGEST_ALGO_RMD160), 20 );
+	printf("\n%s:   SHA1 =", fname ); print_hex(md_read(md, DIGEST_ALGO_SHA1), 20 );
+	putchar('\n');
+    }
+
+
+    md_close(md);
+
+    if( fp != stdin )
+	fclose(fp);
+}
+
+
+
+static void
+do_test(int times)
+{
+    MPI base[4];
+    MPI exp[4];
+    MPI t1 = mpi_alloc(50);
+    MPI t2 = mpi_alloc(50);
+    MPI t3 = mpi_alloc(50);
+    MPI tmp= mpi_alloc(50);
+    MPI m =   mpi_alloc(50);
+    MPI res = mpi_alloc(50);
+
+    mpi_fromstr( m, "0x10000000000000000000000000" );
+    base[0] = mpi_alloc_set_ui( 3 );
+    mpi_fromstr( base[0], "0x145984358945989898495ffdd13" );
+    base[1] = mpi_alloc_set_ui( 5 );
+    mpi_fromstr( base[1], "0x000effff9999000000001100001" );
+    base[2] = mpi_alloc_set_ui( 2 );
+    mpi_fromstr( base[2], "0x499eeeaaaaa0444444545466672" );
+    base[3] = NULL;
+    exp[0]  = mpi_alloc_set_ui( 30 );
+    exp[1]  = mpi_alloc_set_ui( 10 );
+    mpi_fromstr( exp[1], "0x3457878888888888aabbbccccc1" );
+    exp[2]  = mpi_alloc_set_ui( 24 );
+    exp[3] = NULL;
+
+    mpi_powm( t1, base[0], exp[0], m );
+    mpi_powm( t2, base[1], exp[1], m );
+    mpi_powm( t3, base[2], exp[2], m );
+    mpi_mulm( tmp, t1, t2, m );
+    mpi_mulm( t1, tmp, t3, m );
+    log_mpidump("X=", t1 );
+
+
+    mpi_mulpowm( res, base, exp, m );
+    log_mpidump("X=", res );
+
+
+    m_check(NULL);
+}
+#endif /* IS_G10MAINT */
 
diff -urN gnupg-0.2.11/g10/g10maint.c gnupg-0.2.12/g10/g10maint.c
--- gnupg-0.2.11/g10/g10maint.c	Fri Feb 27 15:35:04 1998
+++ gnupg-0.2.12/g10/g10maint.c	Sat Mar  7 12:14:05 1998
@@ -1,56 +1,5964 @@
-/* g10maint.c - The GNUPG maintenance utility
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-
-#include <config.h>
-#include <errno.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <unistd.h>
-
-#include "packet.h"
-#include "iobuf.h"
-#include "memory.h"
-#include "util.h"
-#include "main.h"
-#include "options.h"
-#include "keydb.h"
-#include "mpi.h"
-#include "cipher.h"
-#include "filter.h"
-#include "trustdb.h"
-#include "ttyio.h"
-#include "i18n.h"
-#include "status.h"
+# 1 "g10.c"
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+# 1 "../config.h" 1
+ 
+ 
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+ 
+ 
+
+ 
+ 
+
+ 
+
+ 
+
+ 
+
+
+ 
+
+
+ 
+ 
+
+ 
+
+
+ 
+
+
+ 
+ 
+
+ 
+ 
+
+ 
+ 
+
+ 
+ 
+
+ 
+
+
+
+
+
+
+ 
+
+ 
+
+
+ 
+
+
+
+
+
+
+ 
+
+
+ 
+
+
+ 
+ 
+
+ 
+ 
+
+
+
+ 
+
+
+ 
+
+
+ 
+ 
+
+ 
+
+
+ 
+
+
+
+ 
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+ 
+
+ 
+
+
+ 
+ 
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+ 
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+ 
+ 
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 27 "g10.c" 2
+
+# 1 "/usr/include/errno.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+# 1 "/usr/include/features.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+ 
+
+
+
+ 
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+# 1 "/usr/include/sys/cdefs.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "/usr/include/features.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 136 "/usr/include/features.h" 3
+
+# 24 "/usr/include/sys/cdefs.h" 2 3
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+ 
+
+
+# 50 "/usr/include/sys/cdefs.h" 3
+
+   
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 100 "/usr/include/sys/cdefs.h" 3
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+ 
+
+typedef long double __long_double_t;
+
+# 128 "/usr/include/sys/cdefs.h" 3
+
+
+ 
+
+
+
+
+ 
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 134 "/usr/include/features.h" 2 3
+
+
+
+# 26 "/usr/include/errno.h" 2 3
+
+# 1 "/usr/include/linux/errno.h" 1 3
+
+
+
+# 1 "/usr/include/asm/errno.h" 1 3
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 4 "/usr/include/linux/errno.h" 2 3
+
+
+# 14 "/usr/include/linux/errno.h" 3
+
+
+
+# 27 "/usr/include/errno.h" 2 3
+
+
+
+extern int sys_nerr;
+extern char *sys_errlist[];
+
+
+extern int _sys_nerr;
+extern char *_sys_errlist[];
+
+
+ 
+
+extern void	perror  (__const char* __s)  ;
+extern char*	strerror  (int __errno)  ;
+
+
+
+
+
+extern int errno;
+
+
+
+
+
+
+ 
+
+
+# 28 "g10.c" 2
+
+# 1 "/usr/include/stdio.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "/usr/include/libio.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+# 1 "/usr/include/_G_config.h" 1 3
+  
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef long _G_clock_t;
+typedef unsigned short _G_dev_t;
+typedef long int _G_fpos_t;
+typedef unsigned short _G_gid_t;
+typedef unsigned long _G_ino_t;
+typedef unsigned short _G_mode_t;
+typedef unsigned short _G_nlink_t;
+typedef long _G_off_t;
+typedef int _G_pid_t;
+
+
+
+typedef int _G_ptrdiff_t;
+typedef unsigned long _G_sigset_t;
+
+
+
+typedef unsigned int _G_size_t;
+typedef long _G_time_t;
+typedef unsigned short _G_uid_t;
+typedef long int _G_wchar_t;
+typedef int _G_ssize_t;
+typedef int   _G_wint_t;
+typedef void * _G_va_list;
+
+
+
+
+typedef          int   _G_int8_t __attribute__((__mode__(__QI__)));
+typedef unsigned int  _G_uint8_t __attribute__((__mode__(__QI__)));
+typedef          int  _G_int16_t __attribute__((__mode__(__HI__)));
+typedef unsigned int _G_uint16_t __attribute__((__mode__(__HI__)));
+typedef          int  _G_int32_t __attribute__((__mode__(__SI__)));
+typedef unsigned int _G_uint32_t __attribute__((__mode__(__SI__)));
+typedef          int  _G_int64_t __attribute__((__mode__(__DI__)));
+typedef unsigned int _G_uint64_t __attribute__((__mode__(__DI__)));
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 30 "/usr/include/libio.h" 2 3
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 51 "/usr/include/libio.h" 3
+
+
+# 63 "/usr/include/libio.h" 3
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+struct _IO_lock_t {
+  void *ptr;
+  short int field1;
+  short int field2;
+};
+
+ 
+
+struct _IO_jump_t;  struct _IO_FILE;
+
+struct _IO_marker {
+  struct _IO_marker *_next;
+  struct _IO_FILE *_sbuf;
+   
+
+   
+  int _pos;
+# 176 "/usr/include/libio.h" 3
+
+};
+
+
+
+struct _IO_FILE {
+
+
+
+
+
+
+
+
+  int _flags;		 
+   
+   
+  char* _IO_read_ptr;	 
+  char* _IO_read_end;	 
+  char* _IO_read_base;	 
+
+  char* _IO_write_base;	 
+  char* _IO_write_ptr;	 
+  char* _IO_write_end;	 
+  char* _IO_buf_base;	 
+  char* _IO_buf_end;	 
+   
+  char *_IO_save_base;  
+  char *_IO_backup_base;   
+  char *_IO_save_end;  
+
+  struct _IO_marker *_markers;
+  
+  struct _IO_FILE *_chain;
+  
+  int _fileno;
+  int _blksize;
+  _G_off_t  _offset;
+  
+
+   
+  unsigned short _cur_column;
+  char _unused;
+  char _shortbuf[1];
+  
+   
+
+  struct _IO_lock_t _IO_lock;
+};
+
+
+typedef struct _IO_FILE _IO_FILE;
+
+
+struct _IO_FILE_plus;
+extern struct _IO_FILE_plus _IO_stdin_, _IO_stdout_, _IO_stderr_;
+
+
+
+
+
+
+
+
+extern int __underflow  (_IO_FILE*)  ;
+extern int __uflow  (_IO_FILE*)  ;
+extern int __overflow  (_IO_FILE*, int)  ;
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+extern int _IO_vfscanf  (_IO_FILE*, const char*, _G_va_list , int*)  ;
+extern int _IO_vfprintf  (_IO_FILE*, const char*, _G_va_list )  ;
+extern _G_ssize_t  _IO_padn  (_IO_FILE *, int, _G_ssize_t )  ;
+extern _G_size_t  _IO_sgetn  (_IO_FILE *, void*, _G_size_t )  ;
+
+extern _G_fpos_t  _IO_seekoff  (_IO_FILE*, _G_off_t , int, int)  ;
+extern _G_fpos_t  _IO_seekpos  (_IO_FILE*, _G_fpos_t , int)  ;
+
+extern void _IO_free_backup_area  (_IO_FILE*)  ;
+
+
+
+
+
+
+# 34 "/usr/include/stdio.h" 2 3
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+  
+
+
+
+
+
+
+
+
+
+
+
+typedef _G_size_t  size_t;
+
+
+
+
+typedef struct _IO_FILE FILE;
+typedef _G_fpos_t  fpos_t;
+
+
+
+
+ 
+
+
+
+
+
+
+ 
+
+extern FILE *stdin, *stdout, *stderr;
+
+# 102 "/usr/include/stdio.h" 3
+
+
+
+
+
+
+
+
+ 
+
+extern void clearerr  (FILE*)  ;
+extern int fclose  (FILE*)  ;
+extern int feof  (FILE*)  ;
+extern int ferror  (FILE*)  ;
+extern int fflush  (FILE*)  ;
+extern int fgetc  (FILE *)  ;
+extern int fgetpos  (FILE* fp, fpos_t *pos)  ;
+extern char* fgets  (char*, int, FILE*)  ;
+extern FILE* fopen  (__const char*, __const char*)  ;
+extern int fprintf  (FILE*, __const char* format, ...)  ;
+extern int fputc  (int, FILE*)  ;
+extern int fputs  (__const char *str, FILE *fp)  ;
+extern size_t fread  (void*, size_t, size_t, FILE*)  ;
+extern FILE* freopen  (__const char*, __const char*, FILE*)  ;
+extern int fscanf  (FILE *fp, __const char* format, ...)  ;
+extern int fseek  (FILE* fp, long int offset, int whence)  ;
+extern int fsetpos  (FILE* fp, __const fpos_t *pos)  ;
+extern long int ftell  (FILE* fp)  ;
+extern size_t fwrite  (__const void*, size_t, size_t, FILE*)  ;
+extern int getc  (FILE *)  ;
+extern int getchar  (void)  ;
+extern char* gets  (char*)  ;
+extern void perror  (__const char *)  ;
+extern int printf  (__const char* format, ...)  ;
+extern int putc  (int, FILE *)  ;
+extern int putchar  (int)  ;
+extern int puts  (__const char *str)  ;
+extern int remove  (__const char*)  ;
+extern int rename  (__const char* _old, __const char* _new)  ;
+extern void rewind  (FILE*)  ;
+extern int scanf  (__const char* format, ...)  ;
+extern void setbuf  (FILE*, char*)  ;
+extern void setlinebuf  (FILE*)  ;
+extern void setbuffer  (FILE*, char*, int)  ;
+extern int setvbuf  (FILE*, char*, int mode, size_t size)  ;
+extern int sprintf  (char*, __const char* format, ...)  ;
+extern int sscanf  (__const char* string, __const char* format, ...)  ;
+extern FILE* tmpfile  (void)  ;
+extern char* tmpnam  (char*)  ;
+extern int ungetc  (int c, FILE* fp)  ;
+extern int vfprintf  (FILE *fp, char __const *fmt0, _G_va_list)  ;
+extern int vprintf  (char __const *fmt, _G_va_list)  ;
+extern int vsprintf  (char* string, __const char* format, _G_va_list)  ;
+
+
+extern int vfscanf  (FILE*, __const char *, _G_va_list)  ;
+extern int vscanf  (__const char *, _G_va_list)  ;
+extern int vsscanf  (__const char *, __const char *, _G_va_list)  ;
+
+extern int getw  (FILE*)  ;
+extern int putw  (int, FILE*)  ;
+
+extern char* tempnam  (__const char *__dir, __const char *__pfx)  ;
+
+
+
+
+
+extern int sys_nerr;
+extern char *sys_errlist[];
+
+
+extern int _sys_nerr;
+extern char *_sys_errlist[];
+
+ 
+
+ 
+extern void psignal  (int __sig, __const char *__s)  ;
+
+
+
+
+
+
+
+extern _G_ssize_t  getdelim  (char **, size_t *, int, FILE*)  ;
+
+
+
+
+
+extern int snprintf  (char *, size_t, const char *, ...)  ;
+extern int vsnprintf  (char *, size_t, const char *, _G_va_list)  ;
+
+extern int asprintf  (char **, const char *, ...)  ;
+extern int vasprintf  (char **, const char *, _G_va_list)  ;
+
+
+
+extern FILE *fdopen  (int, __const char *)  ;
+extern int fileno  (FILE*)  ;
+extern FILE* popen  (__const char*, __const char*)  ;
+extern int pclose  (FILE*)  ;
+
+
+
+
+ 
+extern char *ctermid  (char *__buf)  ;
+
+ 
+extern char *cuserid  (char * __buf)  ;
+
+
+
+extern int __underflow  (struct _IO_FILE*)  ;
+extern int __overflow  (struct _IO_FILE*, int)  ;
+
+# 234 "/usr/include/stdio.h" 3
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+# 29 "g10.c" 2
+
+# 1 "/usr/include/stdlib.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+ 
+
+
+
+
+
+
+ 
+
+
+
+# 1 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 1 3
+
+
+
+
+
+ 
+
+
+# 17 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+ 
+
+
+ 
+
+
+
+
+
+ 
+
+
+# 59 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+ 
+
+ 
+
+# 129 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+ 
+
+
+# 180 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+
+ 
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef long int wchar_t;
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+# 288 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 34 "/usr/include/stdlib.h" 2 3
+
+
+ 
+
+
+
+
+
+
+
+ 
+
+ 
+typedef struct
+  {
+    int quot;			 
+    int rem;			 
+  } div_t;
+
+ 
+typedef struct
+  {
+    long int quot;		 
+    long int rem;		 
+  } ldiv_t;
+
+
+ 
+
+
+
+
+
+ 
+
+
+
+
+
+ 
+
+
+
+
+ 
+extern double atof  (__const char *__nptr)  ;
+ 
+extern int atoi  (__const char *__nptr)  ;
+ 
+extern long int atol  (__const char *__nptr)  ;
+
+ 
+extern long long int atoq  (__const char *__nptr)  ;
+
+
+ 
+extern float strtof  (__const char *__nptr, char **__endptr)  ;
+ 
+extern double strtod  (__const char *__nptr, char **__endptr)  ;
+
+ 
+extern __long_double_t strtold  (__const char *__nptr, char **__endptr)  ;
+
+ 
+extern long int strtol  (__const char *__nptr, char **__endptr,
+			     int __base)  ;
+ 
+extern unsigned long int strtoul  (__const char *__nptr,
+				       char **__endptr, int __base)  ;
+
+ 
+extern long long int strtoq  (__const char *__nptr, char **__endptr,
+				int __base)  ;
+ 
+extern unsigned long long int strtouq  (__const char *__nptr,
+					char **__endptr, int __base)  ;
+
+
+ 
+
+
+extern double __strtod_internal (__const char *__nptr,
+				 char **__endptr, int __group);
+extern float __strtof_internal (__const char *__nptr, char **__endptr,
+				int __group);
+extern __long_double_t __strtold_internal (__const char *__nptr,
+					   char **__endptr, int __group);
+extern long int __strtol_internal (__const char *__nptr, char **__endptr,
+				   int __base, int __group);
+extern unsigned long int __strtoul_internal (__const char *__nptr,
+					     char **__endptr, int __base,
+					     int __group);
+
+extern long long int __strtoq_internal (__const char *__nptr, char **__endptr,
+					int __base, int __group);
+extern unsigned long long int __strtouq_internal (__const char *__nptr,
+						  char **__endptr, int __base,
+						  int __group);
+
+
+# 170 "/usr/include/stdlib.h" 3
+
+
+
+ 
+extern int rand  (void)  ;
+ 
+extern void srand  (unsigned int __seed)  ;
+
+ 
+
+
+
+ 
+extern long int __random  (void)  ;
+ 
+extern void __srandom  (unsigned int __seed)  ;
+
+ 
+
+
+
+extern void *  __initstate  (unsigned int __seed, void *  __statebuf,
+				 size_t __statelen)  ;
+ 
+
+extern void *  __setstate  (void *  __statebuf)  ;
+
+
+extern long int random  (void)  ;
+extern void srandom  (unsigned int __seed)  ;
+extern void *  initstate  (unsigned int __seed, void *  __statebuf,
+			       size_t __statelen)  ;
+extern void *  setstate  (void *  __statebuf)  ;
+
+# 214 "/usr/include/stdlib.h" 3
+
+
+
+
+ 
+extern void *  malloc  (size_t __size)  ;
+ 
+
+extern void *  realloc  (void *  __ptr, size_t __size)  ;
+ 
+extern void *  calloc  (size_t __nmemb, size_t __size)  ;
+ 
+extern void free  (void *  __ptr)  ;
+
+
+ 
+extern void cfree  (void *  __ptr)  ;
+
+
+
+# 1 "/usr/include/alloca.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 1 3
+
+
+
+
+
+ 
+
+
+# 17 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+ 
+
+
+ 
+
+
+
+
+
+ 
+
+
+# 59 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+ 
+
+ 
+
+# 129 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+ 
+
+
+# 180 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+
+ 
+
+
+
+
+ 
+
+# 256 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+# 288 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 24 "/usr/include/alloca.h" 2 3
+
+
+ 
+
+ 
+
+
+
+ 
+extern void *  __alloca  (size_t __size)  ;
+
+ 
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+# 234 "/usr/include/stdlib.h" 2 3
+
+
+
+
+ 
+extern void *  valloc  (size_t __size)  ;
+
+
+
+ 
+extern   void abort  (void)  ;
+
+
+ 
+extern int atexit  (void (*__func) (void))  ;
+
+
+ 
+
+extern int on_exit  (void (*__func) (int __status, void *  __arg),
+			 void *  __arg)  ;
+
+
+ 
+
+
+extern   void exit  (int __status)  ;
+
+
+ 
+extern char *getenv  (__const char *__name)  ;
+
+
+ 
+ 
+
+extern int putenv  (__const char *__string)  ;
+
+
+
+ 
+
+extern int setenv  (__const char *__name, __const char *__value,
+			int __replace)  ;
+
+
+ 
+extern int system  (__const char *__command)  ;
+
+
+
+
+ 
+typedef int (*__compar_fn_t)  (__const void * , __const void * )  ;
+
+
+
+typedef __compar_fn_t comparison_fn_t;
+
+
+ 
+
+extern void *  bsearch  (__const void *  __key, __const void *  __base,
+			     size_t __nmemb, size_t __size,
+			     __compar_fn_t __compar)  ;
+
+ 
+
+extern void qsort  (void *  __base, size_t __nmemb, size_t __size,
+			__compar_fn_t __compar)  ;
+
+
+# 314 "/usr/include/stdlib.h" 3
+
+
+ 
+extern   int abs  (int __x)  ;
+extern   long int labs  (long int __x)  ;
+
+
+ 
+
+ 
+extern   div_t div  (int __numer, int __denom)  ;
+extern   ldiv_t ldiv  (long int __numer, long int __denom)  ;
+
+
+ 
+
+extern int mblen  (__const char *__s, size_t __n)  ;
+ 
+
+extern int mbtowc  (wchar_t * __pwc, __const char *__s, size_t __n)  ;
+ 
+
+extern int wctomb  (char *__s, wchar_t __wchar)  ;
+
+
+
+
+
+
+
+ 
+extern size_t mbstowcs  (wchar_t * __pwcs, __const char *__s, size_t __n)  ;
+ 
+extern size_t wcstombs  (char *__s, __const wchar_t * __pwcs, size_t __n)  ;
+
+ 
+
+
+
+
+ 
+
+
+
+
+
+ 
+# 375 "/usr/include/stdlib.h" 3
+
+
+ 
+
+
+extern char **environ;
+extern char **__environ;
+
+extern char*	ecvt  (double __value, size_t __ndigit, int *__decpt,
+			int *__sign)  ;
+extern char*	fcvt  (double __value, size_t __ndigit, int *__decpt,
+			int *__sign)  ;
+extern char*	gcvt  (double __value, size_t __ndigit, char *__buf)  ;
+
+extern double	drand48  (void)  ;
+extern double	erand48  (unsigned short int __xsubi[3])  ;
+extern long int	lrand48  (void)  ;
+extern long int	nrand48  (unsigned short int __xsubi[3])  ;
+extern long int	mrand48  (void)  ;
+extern long int	jrand48  (unsigned short int __xsubi[3])  ;
+extern void	srand48  (long int __seedval)  ;
+extern unsigned short int
+			*seed48  (unsigned short int __seed16v[3])  ;
+extern void	lcong48  (unsigned short int __param[7])  ;
+
+extern int	setenv  (__const char *__name, __const char *__value,
+			int __overwrite)  ;
+extern void	unsetenv  (__const char *__name)  ;
+
+struct qelem {
+  struct qelem *q_forw;
+  struct qelem *q_back;
+  char q_data[1];
+};
+
+extern void insque  (struct qelem *__elem, struct qelem *__prev)  ;
+extern void remque  (struct qelem *__elem)  ;
+
+
+
+ 
+
+
+# 30 "g10.c" 2
+
+# 1 "/usr/include/string.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+ 
+
+ 
+
+
+# 1 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 1 3
+
+
+
+
+
+ 
+
+
+# 17 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+ 
+
+
+ 
+
+
+
+
+
+ 
+
+
+# 59 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+ 
+
+ 
+
+# 129 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+ 
+
+
+# 180 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+
+ 
+
+
+
+
+ 
+
+# 256 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+# 288 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 33 "/usr/include/string.h" 2 3
+
+
+ 
+
+
+
+
+
+
+ 
+
+extern void *  memmove  (void *  __dest, __const void *  __src,
+			     size_t __n)  ;
+
+ 
+
+
+extern void *  __memccpy  (void *  __dest, __const void *  __src,
+			       int __c, size_t __n)  ;
+
+extern void *  memccpy  (void *  __dest, __const void *  __src,
+			     int __c, size_t __n)  ;
+
+
+
+ 
+extern void *  memset  (void *  __s, int __c, size_t __n)  ;
+
+ 
+
+
+
+
+
+
+ 
+extern void *  memchr  (__const void *  __s, int __c, size_t __n)  ;
+
+
+ 
+extern char *strcpy  (char *__dest, __const char *__src)  ;
+ 
+extern char *strncpy  (char *__dest, __const char *__src, size_t __n)  ;
+
+ 
+extern char *strcat  (char *__dest, __const char *__src)  ;
+ 
+extern char *strncat  (char *__dest, __const char *__src, size_t __n)  ;
+
+ 
+extern int strcmp  (__const char *__s1, __const char *__s2)  ;
+ 
+extern int strncmp  (__const char *__s1, __const char *__s2, size_t __n)  ;
+
+ 
+extern int strcoll  (__const char *__s1, __const char *__s2)  ;
+ 
+extern size_t strxfrm  (char *__dest, __const char *__src, size_t __n)  ;
+
+
+ 
+extern char *strdup  (__const char *__s)  ;
+
+
+ 
+extern char *strchr  (__const char *__s, int __c)  ;
+ 
+extern char *strrchr  (__const char *__s, int __c)  ;
+
+ 
+
+extern size_t strcspn  (__const char *__s, __const char *__reject)  ;
+ 
+
+extern size_t strspn  (__const char *__s, __const char *__accept)  ;
+ 
+extern char *strpbrk  (__const char *__s, __const char *__accept)  ;
+ 
+extern char *strstr  (__const char *__haystack, __const char *__needle)  ;
+ 
+extern char *strtok  (char *__s, __const char *__delim)  ;
+
+
+ 
+
+
+extern void *  memmem  (__const void *  __haystack,
+			    size_t __haystacklen,
+			    __const void *  __needle,
+			    size_t __needlelen)  ;
+
+
+ 
+extern size_t strlen  (__const char *__s)  ;
+
+ 
+extern char *strerror  (int __errnum)  ;
+
+
+ 
+extern char *index  (__const char *__s, int __c)  ;
+
+ 
+extern char *rindex  (__const char *__s, int __c)  ;
+
+# 149 "/usr/include/string.h" 3
+
+
+ 
+extern void bcopy  (__const void *  __src, void *  __dest, int __n)  ;
+
+ 
+extern void bzero  (void *  __s, int __n)  ;
+
+ 
+extern int bcmp  (__const void *  __s1, __const void *  __s2, int __n)  ;
+
+
+
+ 
+
+extern int ffs  (int __i)  ;
+
+ 
+extern int strcasecmp  (__const char *__s1, __const char *__s2)  ;
+
+ 
+
+extern char *strsep  (char **__stringp, __const char *__delim)  ;
+
+
+
+ 
+extern int strncasecmp  (__const char *__s1, __const char *__s2,
+			     size_t __n)  ;
+
+ 
+extern char *strsignal  (int __sig)  ;
+
+ 
+extern char *stpcpy  (char *__dest, __const char *__src)  ;
+
+ 
+
+extern char *__stpncpy  (char *__dest, __const char *__src, size_t __n)  ;
+extern char *stpncpy  (char *__dest, __const char *__src, size_t __n)  ;
+
+ 
+extern char *strfry  (char *__string)  ;
+
+ 
+extern void *  memfrob  (void *  __s, size_t __n)  ;
+
+extern void swab  (__const void *  __from, void *  __to,
+                        size_t __nbytes)  ;
+
+
+ 
+
+
+# 31 "g10.c" 2
+
+# 1 "/usr/include/unistd.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+ 
+
+ 
+
+
+ 
+
+
+ 
+
+
+
+
+ 
+
+
+
+ 
+
+
+
+ 
+
+
+
+ 
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "/usr/include/posix_opt.h" 1 3
+
+
+
+ 
+
+
+ 
+
+
+ 
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+# 85 "/usr/include/unistd.h" 2 3
+
+
+
+ 
+
+
+
+
+
+ 
+
+# 1 "/usr/include/gnu/types.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+typedef unsigned char __u_char;
+typedef unsigned short __u_short;
+typedef unsigned int __u_int;
+typedef unsigned long __u_long;
+typedef struct
+{
+  long val[2];
+} __quad;
+typedef struct
+{
+  __u_long val[2];
+} __u_quad;
+
+
+typedef unsigned short __dev_t;	 
+typedef unsigned short __gid_t;	 
+typedef unsigned short __uid_t;	 
+typedef unsigned short __mode_t; 
+typedef long	__daddr_t;	 
+typedef long	__off_t;	 
+
+typedef long long __loff_t;	 
+
+typedef unsigned long __ino_t;	 
+typedef unsigned short __nlink_t;	 
+typedef long	__time_t;
+# 61 "/usr/include/gnu/types.h" 3
+
+
+typedef int __pid_t;		 
+typedef int __ssize_t;		 
+typedef __quad __fsid_t;	 
+
+ 
+typedef char *__caddr_t;
+typedef long int __swblk_t;	 
+
+
+ 
+
+
+
+
+
+# 1 "/usr/include/linux/posix_types.h" 1 3
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct fd_set {
+	unsigned long fds_bits [(1024 / (8 * sizeof(unsigned long)) ) ];
+} __kernel_fd_set;
+
+# 1 "/usr/include/asm/posix_types.h" 1 3
+
+
+
+ 
+
+
+
+
+
+typedef unsigned short	__kernel_dev_t;
+typedef unsigned long	__kernel_ino_t;
+typedef unsigned short	__kernel_mode_t;
+typedef unsigned short	__kernel_nlink_t;
+typedef long		__kernel_off_t;
+typedef int		__kernel_pid_t;
+typedef unsigned short	__kernel_uid_t;
+typedef unsigned short	__kernel_gid_t;
+typedef unsigned int	__kernel_size_t;
+typedef int		__kernel_ssize_t;
+typedef int		__kernel_ptrdiff_t;
+typedef long		__kernel_time_t;
+typedef long		__kernel_clock_t;
+typedef int		__kernel_daddr_t;
+typedef char *		__kernel_caddr_t;
+
+
+typedef long long	__kernel_loff_t;
+
+
+typedef struct {
+
+
+
+	int	__val[2];
+
+} __kernel_fsid_t;
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 48 "/usr/include/linux/posix_types.h" 2 3
+
+
+
+# 78 "/usr/include/gnu/types.h" 2 3
+
+
+
+
+
+
+typedef struct __fd_set {
+        unsigned long fds_bits [(1024 / (8 * sizeof(unsigned long)) ) ];
+} __fd_set;
+
+# 128 "/usr/include/gnu/types.h" 3
+
+
+# 152 "/usr/include/gnu/types.h" 3
+
+
+
+# 96 "/usr/include/unistd.h" 2 3
+
+
+
+
+
+
+
+
+# 1 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 1 3
+
+
+
+
+
+ 
+
+
+# 17 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+ 
+
+
+ 
+
+
+
+
+
+ 
+
+
+# 59 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+ 
+
+ 
+
+# 129 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+ 
+
+
+# 180 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+
+ 
+
+
+
+
+ 
+
+# 256 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+ 
+
+# 288 "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include/stddef.h" 3
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 104 "/usr/include/unistd.h" 2 3
+
+
+
+ 
+
+
+
+
+
+
+ 
+extern int __access  (__const char *__name, int __type)  ;
+extern int access  (__const char *__name, int __type)  ;
+
+
+ 
+
+
+
+
+
+
+ 
+
+
+
+
+extern __off_t __lseek  (int __fd, __off_t __offset, int __whence)  ;
+extern __off_t lseek  (int __fd, __off_t __offset, int __whence)  ;
+
+
+ 
+extern __loff_t __llseek  (int __fd, __loff_t __offset, int __whence)  ;
+extern __loff_t llseek  (int __fd, __loff_t __offset, int __whence)  ;
+
+
+ 
+extern int __close  (int __fd)  ;
+extern int close  (int __fd)  ;
+
+ 
+
+extern __ssize_t  __read  (int __fd, void *  __buf, size_t __nbytes)  ;
+extern __ssize_t  read  (int __fd, void *  __buf, size_t __nbytes)  ;
+
+ 
+extern __ssize_t  __write  (int __fd, __const void *  __buf, size_t __n)  ;
+extern __ssize_t  write  (int __fd, __const void *  __buf, size_t __n)  ;
+
+
+ 
+
+
+
+extern int __pipe  (int __pipedes[2])  ;
+extern int pipe  (int __pipedes[2])  ;
+
+ 
+
+
+
+
+
+
+extern unsigned int alarm  (unsigned int __seconds)  ;
+
+ 
+
+
+
+
+
+
+extern unsigned int sleep  (unsigned int __seconds)  ;
+
+
+ 
+
+extern int pause  (void)  ;
+
+
+ 
+extern int __chown  (__const char *__file,
+			 __uid_t __owner, __gid_t __group)  ;
+extern int chown  (__const char *__file,
+		       __uid_t __owner, __gid_t __group)  ;
+
+
+ 
+extern int __fchown  (int __fd,
+			  __uid_t __owner, __gid_t __group)  ;
+extern int fchown  (int __fd,
+			__uid_t __owner, __gid_t __group)  ;
+ 
+
+extern int __fchdir  (int __fd)  ;
+extern int fchdir  (int __fd)  ;
+
+
+ 
+extern int __chdir  (__const char *__path)  ;
+extern int chdir  (__const char *__path)  ;
+
+ 
+
+
+
+
+
+
+extern char *getcwd  (char *__buf, size_t __size)  ;
+
+
+ 
+
+
+extern char *get_current_dir_name  (void)  ;
+
+
+
+ 
+
+
+extern char *getwd  (char __buf [])  ;
+
+
+
+ 
+extern int __dup  (int __fd)  ;
+extern int dup  (int __fd)  ;
+
+ 
+extern int __dup2  (int __fd, int __fd2)  ;
+extern int dup2  (int __fd, int __fd2)  ;
+
+ 
+extern char **__environ;
+extern char **environ;
+
+
+ 
+
+extern int __execve  (__const char *__path, char *__const __argv[],
+			  char *__const __envp[])  ;
+extern int execve  (__const char *__path, char *__const __argv[],
+			char *__const __envp[])  ;
+
+ 
+extern int execv  (__const char *__path, char *__const __argv[])  ;
+
+ 
+
+extern int execle  (__const char *__path, __const char *__arg,...)  ;
+
+ 
+
+extern int execl  (__const char *__path, __const char *__arg,...)  ;
+
+ 
+
+extern int execvp  (__const char *__file, char *__const __argv[])  ;
+
+ 
+
+
+extern int execlp  (__const char *__file, __const char *arg,...)  ;
+
+
+ 
+extern   void _exit  (int __status)   __attribute__ ((noreturn)) ;
+
+
+ 
+
+
+
+# 1 "/usr/include/confname.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+enum
+  {
+    _PC_LINK_MAX
+
+
+
+    ,
+    _PC_MAX_CANON,
+    _PC_MAX_INPUT,
+    _PC_NAME_MAX,
+    _PC_PATH_MAX,
+    _PC_PIPE_BUF,
+
+    _PC_CHOWN_RESTRICTED,
+
+    _PC_NO_TRUNC,
+    _PC_VDISABLE,
+
+
+
+
+     
+    _PC_ASYNC_IO,
+    _PC_PRIO_IO,
+    _PC_SYNC_IO
+  };
+
+ 
+enum
+  {
+    _SC_ARG_MAX
+
+
+
+    ,
+    _SC_CHILD_MAX,
+    _SC_CLK_TCK,
+    _SC_NGROUPS_MAX,
+    _SC_OPEN_MAX,
+
+
+    _SC_STREAM_MAX,
+    _SC_TZNAME_MAX,
+
+    _SC_JOB_CONTROL,
+    _SC_SAVED_IDS,
+    _SC_VERSION,
+
+
+
+
+    _SC_PAGESIZE,
+
+
+
+
+
+     
+
+    _SC_BC_BASE_MAX,
+    _SC_BC_DIM_MAX,
+    _SC_BC_SCALE_MAX,
+    _SC_BC_STRING_MAX,
+    _SC_COLL_WEIGHTS_MAX,
+    _SC_EQUIV_CLASS_MAX,
+    _SC_EXPR_NEST_MAX,
+    _SC_LINE_MAX,
+    _SC_RE_DUP_MAX,
+
+    _SC_2_VERSION,
+    _SC_2_C_BIND,
+    _SC_2_C_DEV,
+    _SC_2_FORT_DEV,
+    _SC_2_FORT_RUN,
+    _SC_2_SW_DEV,
+    _SC_2_LOCALEDEF,
+
+     
+    _SC_AIO_LISTIO_MAX,
+    _SC_AIO_MAX,
+    _SC_AIO_PRIO_DELTA_MAX,
+    _SC_DELAYTIMER_MAX,
+    _SC_MQ_OPEN_MAX,
+    _SC_MQ_PRIO_MAX,
+    _SC_RTSIG_MAX,
+    _SC_SEM_NSEMS_MAX,
+    _SC_SEM_VALUE_MAX,
+    _SC_SIGQUEUE_MAX,
+    _SC_TIMER_MAX,
+    _SC_ASYNCHRONOUS_IO,
+    _SC_FSYNC,
+    _SC_MAPPED_FILES,
+    _SC_MEMLOCK,
+    _SC_MEMLOCK_RANGE,
+    _SC_MEMORY_PROTECTION,
+    _SC_MESSAGE_PASSING,
+    _SC_PRIORITIZED_IO,
+    _SC_PRIORITY_SCHEDULING,
+    _SC_REALTIME_SIGNALS,
+    _SC_SEMAPHORES,
+    _SC_SHARED_MEMORY_OBJECTS,
+    _SC_SYNCHRONIZED_IO,
+    _SC_TIMERS
+  };
+
+
+ 
+enum
+  {
+    _CS_PATH			 
+  };
+
+
+ 
+
+
+
+
+
+# 280 "/usr/include/unistd.h" 2 3
+
+
+ 
+extern long int __pathconf  (__const char *__path, int __name)  ;
+extern long int pathconf  (__const char *__path, int __name)  ;
+
+ 
+extern long int __fpathconf  (int __fd, int __name)  ;
+extern long int fpathconf  (int __fd, int __name)  ;
+
+
+ 
+extern long int __sysconf  (int __name)  ;
+extern long int sysconf  (int __name)  ;
+
+
+ 
+extern size_t confstr  (int __name, char *__buf, size_t __len)  ;
+
+
+
+ 
+extern __pid_t __getpid  (void)  ;
+extern __pid_t getpid  (void)  ;
+
+ 
+extern __pid_t __getppid  (void)  ;
+extern __pid_t getppid  (void)  ;
+
+
+
+ 
+
+
+extern __pid_t getpgid  (__pid_t __pid)  ;
+
+ 
+extern __pid_t getpgrp  (void)  ;
+
+ 
+
+
+extern int setpgid  (__pid_t __pid, __pid_t __pgid)  ;
+
+extern int setpgrp  (void)  ;
+
+# 350 "/usr/include/unistd.h" 3
+
+
+ 
+
+
+extern __pid_t __setsid  (void)  ;
+extern __pid_t setsid  (void)  ;
+
+extern __pid_t __getsid  (__pid_t __pid)  ;
+extern __pid_t getsid  (__pid_t __pid)  ;
+
+ 
+extern __uid_t __getuid  (void)  ;
+extern __uid_t getuid  (void)  ;
+
+ 
+extern __uid_t __geteuid  (void)  ;
+extern __uid_t geteuid  (void)  ;
+
+ 
+extern __gid_t __getgid  (void)  ;
+extern __gid_t getgid  (void)  ;
+
+ 
+extern __gid_t __getegid  (void)  ;
+extern __gid_t getegid  (void)  ;
+
+ 
+
+
+extern int __getgroups  (int __size, __gid_t __list[])  ;
+extern int getgroups  (int __size, __gid_t __list[])  ;
+
+ 
+
+
+
+extern int __setuid  (__uid_t __uid)  ;
+extern int setuid  (__uid_t __uid)  ;
+
+
+ 
+
+extern int __setreuid  (__uid_t __ruid, __uid_t __euid)  ;
+extern int setreuid  (__uid_t __ruid, __uid_t __euid)  ;
+
+ 
+extern int seteuid  (__uid_t __uid)  ;
+
+
+ 
+
+
+
+extern int __setgid  (__gid_t __gid)  ;
+extern int setgid  (__gid_t __gid)  ;
+
+
+ 
+
+extern int __setregid  (__gid_t __rgid, __gid_t __egid)  ;
+extern int setregid  (__gid_t __rgid, __gid_t __egid)  ;
+
+ 
+extern int setegid  (__uid_t __uid)  ;
+
+
+ 
+extern int __setfsuid  (__uid_t __uid)  ;
+extern int setfsuid  (__uid_t __uid)  ;
+
+ 
+extern int __setfsgid  (__gid_t __gid)  ;
+extern int setfsgid  (__gid_t __gid)  ;
+
+
+ 
+
+
+extern __pid_t __fork  (void)  ;
+extern __pid_t fork  (void)  ;
+
+
+ 
+
+
+
+extern __pid_t __vfork  (void)  ;
+extern __pid_t vfork  (void)  ;
+
+
+
+# 450 "/usr/include/unistd.h" 3
+
+
+ 
+
+extern char *ttyname  (int __fd)  ;
+
+ 
+
+extern int __isatty  (int __fd)  ;
+extern int isatty  (int __fd)  ;
+
+
+ 
+extern int __link  (__const char *__from, __const char *__to)  ;
+extern int link  (__const char *__from, __const char *__to)  ;
+
+
+ 
+extern int __symlink  (__const char *__from, __const char *__to)  ;
+extern int symlink  (__const char *__from, __const char *__to)  ;
+
+ 
+
+
+extern int __readlink  (__const char *__path, char *__buf, size_t __len)  ;
+extern int readlink  (__const char *__path, char *__buf, size_t __len)  ;
+
+
+
+ 
+extern int __unlink  (__const char *__name)  ;
+extern int unlink  (__const char *__name)  ;
+
+ 
+extern int __rmdir  (__const char *__path)  ;
+extern int rmdir  (__const char *__path)  ;
+
+
+ 
+extern __pid_t tcgetpgrp  (int __fd)  ;
+
+ 
+extern int tcsetpgrp  (int __fd, __pid_t __pgrp_id)  ;
+
+
+ 
+extern char *getlogin  (void)  ;
+
+
+ 
+extern int setlogin  (__const char *__name)  ;
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+extern int getopt  (int __argc, char *__const * __argv,
+			__const char *__opts)  ;
+extern int opterr;
+extern int optind;
+extern int optopt;
+extern char *optarg;
+
+
+
+
+
+ 
+
+
+extern int __gethostname  (char *__name, size_t __len)  ;
+extern int gethostname  (char *__name, size_t __len)  ;
+
+ 
+
+extern int sethostname  (__const char *__name, size_t __len)  ;
+
+ 
+extern long int gethostid  (void)  ;
+
+ 
+
+extern int sethostid  (long int __id)  ;
+
+
+ 
+
+extern size_t __getpagesize  (void)  ;
+extern size_t getpagesize  (void)  ;
+
+
+ 
+
+extern int __getdtablesize  (void)  ;
+extern int getdtablesize  (void)  ;
+
+ 
+
+extern int fdatasync  (int __fd)  ;
+
+ 
+extern int fsync  (int __fd)  ;
+
+ 
+extern int sync  (void)  ;
+
+
+ 
+
+
+extern int vhangup  (void)  ;
+
+
+ 
+
+
+extern int acct  (__const char *__name)  ;
+
+ 
+
+extern int chroot  (__const char *__path)  ;
+
+ 
+
+extern int swapon  (__const char *__path, int __swapflags)  ;
+
+ 
+extern char *getusershell  (void)  ;
+extern void endusershell  (void)  ;  
+extern void setusershell  (void)  ;  
+
+ 
+
+extern char *getpass  (__const char *__prompt)  ;
+
+
+
+
+ 
+
+
+
+ 
+
+
+
+
+
+
+
+
+extern int lockf  (int __fd, int __cmd, __off_t __len)  ;
+
+
+
+
+ 
+# 1 "/usr/include/sys/types.h" 1 3
+
+
+
+# 1 "/usr/include/linux/types.h" 1 3
+
+
+
+
+# 1 "/usr/include/asm/types.h" 1 3
+
+
+
+typedef unsigned short umode_t;
+
+ 
+
+
+
+
+typedef __signed__ char __s8;
+typedef unsigned char __u8;
+
+typedef __signed__ short __s16;
+typedef unsigned short __u16;
+
+typedef __signed__ int __s32;
+typedef unsigned int __u32;
+
+
+typedef __signed__ long long __s64;
+typedef unsigned long long __u64;
+
+
+ 
+
+
+# 42 "/usr/include/asm/types.h" 3
+
+
+
+# 5 "/usr/include/linux/types.h" 2 3
+
+
+
+
+typedef __kernel_fd_set		fd_set;
+typedef __kernel_dev_t		dev_t;
+typedef __kernel_ino_t		ino_t;
+typedef __kernel_mode_t		mode_t;
+typedef __kernel_nlink_t	nlink_t;
+typedef __kernel_off_t		off_t;
+typedef __kernel_pid_t		pid_t;
+typedef __kernel_uid_t		uid_t;
+typedef __kernel_gid_t		gid_t;
+typedef __kernel_daddr_t	daddr_t;
+
+
+typedef __kernel_loff_t		loff_t;
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef __kernel_ptrdiff_t	ptrdiff_t;
+
+
+
+
+typedef __kernel_time_t		time_t;
+
+
+
+
+typedef __kernel_clock_t	clock_t;
+
+
+
+
+typedef __kernel_caddr_t	caddr_t;
+
+
+ 
+typedef unsigned char		u_char;
+typedef unsigned short		u_short;
+typedef unsigned int		u_int;
+typedef unsigned long		u_long;
+
+ 
+typedef unsigned char		unchar;
+typedef unsigned short		ushort;
+typedef unsigned int		uint;
+typedef unsigned long		ulong;
+
+
+
+ 
+
+
+
+
+struct ustat {
+	__kernel_daddr_t	f_tfree;
+	__kernel_ino_t		f_tinode;
+	char			f_fname[6];
+	char			f_fpack[6];
+};
+
+
+# 4 "/usr/include/sys/types.h" 2 3
+
+# 1 "/usr/include/sys/bitypes.h" 1 3
+ 
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+	 
+
+
+
+	typedef   char            int8_t;
+	typedef unsigned char            u_int8_t;
+	typedef short                     int16_t;
+	typedef unsigned short          u_int16_t;
+	typedef int                       int32_t;
+	typedef unsigned int            u_int32_t;
+
+
+	typedef long long                 int64_t;
+	typedef unsigned long long      u_int64_t;
+
+
+
+
+ 
+# 5 "/usr/include/sys/types.h" 2 3
+
+
+
+
+
+
+
+
+
+
+ 
+typedef unsigned long fd_mask;
+
+
+# 630 "/usr/include/unistd.h" 2 3
+
+
+extern int	__brk  (void* __end_data_segment)  ;
+extern int	brk  (void* __end_data_segment)  ;
+extern void*	__sbrk  (ptrdiff_t __increment)  ;
+extern void*	sbrk  (ptrdiff_t __increment)  ;
+
+extern char*	crypt  (__const char *__key, __const char *__salt)  ;
+extern void	encrypt  (char __block[64], int __edflag)  ;
+extern void	setkey  (__const char *__key)  ;
+
+extern int	ftruncate  (int __fildes, size_t __length)  ;
+extern int	truncate  (__const char *__path, size_t __length)  ;
+
+extern int	ioperm   (unsigned long __from,
+			unsigned long __num, int __turn_on)  ;
+extern int	iopl  (int __level)  ;
+
+extern char*	mktemp  (char *__template)  ;
+extern int	mkstemp  (char *__template)  ;
+
+extern int	nice  (int __val)  ;
+
+extern int	profil  (char *__buf, int __bufsiz, int __offset,
+			int __scale)  ;
+
+extern void	usleep  (unsigned long __usec)  ;
+
+
+
+extern int	_xustat  (int __ver, dev_t __dev, struct ustat* __ubuf)  ;
+static __inline__ int
+ustat (dev_t __dev, struct ustat* __ubuf)
+{
+  return _xustat (1 , __dev, __ubuf);
+}
+
+extern int	idle  (void)  ;
+extern int	reboot  (int __magic, int __magic_too,
+			int __flag)  ;
+
+extern int	swapoff  (__const char * __specialfile)  ;
+
+extern int	uselib  (__const char *__filename)  ;
+
+extern int	getdomainname  (char *__name, size_t __len)  ;
+extern int	setdomainname  (__const char *__name, size_t __len)  ;
+extern char*	realpath  (__const char *__path,
+			char __resolved_path [])  ;
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+# 32 "g10.c" 2
+
+
+# 1 "packet.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "../include/types.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+  
+  typedef unsigned char byte;
+  
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+  
+  
+
+
+    typedef unsigned short u16;
+  
+
+
+  
+
+
+
+  
+  
+    typedef unsigned int u32;
+  
+
+
+
+
+  
+
+
+
+
+
+typedef struct string_list {
+    struct string_list *next;
+    char d[1];
+} *STRLIST;
+
+
+
+# 24 "packet.h" 2
+
+# 1 "../include/iobuf.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct iobuf_struct *IOBUF;
+
+struct iobuf_struct {
+    int usage;		  
+    unsigned long nlimit;
+    unsigned long nbytes;  
+    unsigned long ntotal;  
+    struct {
+	size_t size;    
+	size_t start;   
+	size_t len;     
+	byte *buf;
+    } d;
+    int filter_eof;
+    int (*filter)( void *opaque, int control,
+		   IOBUF chain, byte *buf, size_t *len);
+    void *filter_ov;	 
+    IOBUF chain;	 
+    int no, subno;
+    const char *desc;
+    void *opaque;       
+		        
+    struct {
+	size_t size;    
+	size_t start;   
+	size_t len;     
+	byte *buf;
+    } unget;
+};
+
+int iobuf_debug_mode;
+
+IOBUF iobuf_alloc(int usage, size_t bufsize);
+IOBUF iobuf_temp(void);
+IOBUF iobuf_open( const char *fname );
+IOBUF iobuf_create( const char *fname );
+IOBUF iobuf_append( const char *fname );
+IOBUF iobuf_openrw( const char *fname );
+int   iobuf_close( IOBUF iobuf );
+int   iobuf_cancel( IOBUF iobuf );
+
+int iobuf_push_filter( IOBUF a, int (*f)(void *opaque, int control,
+		       IOBUF chain, byte *buf, size_t *len), void *ov );
+int iobuf_pop_filter( IOBUF a, int (*f)(void *opaque, int control,
+		      IOBUF chain, byte *buf, size_t *len), void *ov );
+int iobuf_flush(IOBUF a);
+void iobuf_clear_eof(IOBUF a);
+
+void iobuf_set_limit( IOBUF a, unsigned long nlimit );
+
+ulong iobuf_tell( IOBUF a );
+int   iobuf_seek( IOBUF a, ulong newpos );
+
+int  iobuf_readbyte(IOBUF a);
+int  iobuf_read(IOBUF a, byte *buf, unsigned buflen );
+int  iobuf_peek(IOBUF a, byte *buf, unsigned buflen );
+int  iobuf_writebyte(IOBUF a, unsigned c);
+int  iobuf_write(IOBUF a, byte *buf, unsigned buflen );
+int  iobuf_writestr(IOBUF a, const char *buf );
+
+int  iobuf_write_temp( IOBUF a, IOBUF temp );
+size_t iobuf_temp_to_buffer( IOBUF a, byte *buffer, size_t buflen );
+void iobuf_unget_and_close_temp( IOBUF a, IOBUF temp );
+
+u32 iobuf_get_filelength( IOBUF a );
+const char *iobuf_get_fname( IOBUF a );
+
+void iobuf_set_block_mode( IOBUF a, size_t n );
+void iobuf_set_partial_block_mode( IOBUF a, size_t len );
+int  iobuf_in_block_mode( IOBUF a );
+
+ 
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+
+
+
+# 25 "packet.h" 2
+
+# 1 "../include/mpi.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "../include/memory.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 49 "../include/memory.h"
+
+void *m_alloc( size_t n );
+void *m_alloc_clear( size_t n );
+void *m_alloc_secure( size_t n );
+void *m_alloc_secure_clear( size_t n );
+void *m_realloc( void *a, size_t n );
+void m_free( void *p );
+void m_check( const void *a );
+ 
+char *m_strdup( const char * a);
+
+
+size_t m_size( const void *a );
+
+ 
+void secmem_init( size_t npool );
+void secmem_term( void );
+void *secmem_malloc( size_t size );
+void *secmem_realloc( void *a, size_t newsize );
+void secmem_free( void *a );
+int  m_is_secure( const void *p );
+void secmem_dump_stats(void);
+void secmem_set_flags( unsigned flags );
+unsigned secmem_get_flags(void);
+
+
+
+
+
+int memory_debug_mode;
+int memory_stat_debug_mode;
+
+
+
+
+# 36 "../include/mpi.h" 2
+
+
+
+
+int mpi_debug_mode;
+
+
+
+typedef unsigned long int mpi_limb_t;
+typedef   __signed  long int mpi_limb_signed_t;
+
+typedef struct mpi_struct {
+    int alloced;     
+    int nlimbs;      
+    int nbits;	     
+    int sign;	     
+    int secure;      
+    mpi_limb_t *d;   
+} *MPI;
+
+
+
+
+
+
+ 
+
+# 74 "../include/mpi.h"
+
+  MPI mpi_alloc( unsigned nlimbs );
+  MPI mpi_alloc_secure( unsigned nlimbs );
+  void mpi_free( MPI a );
+  void mpi_resize( MPI a, unsigned nlimbs );
+  MPI  mpi_copy( MPI a );
+
+
+void mpi_set_secure( MPI a );
+void mpi_clear( MPI a );
+void mpi_set( MPI w, MPI u);
+void mpi_set_ui( MPI w, ulong u);
+MPI  mpi_alloc_set_ui( unsigned long u);
+void mpi_m_check( MPI a );
+void mpi_swap( MPI a, MPI b);
+
+ 
+int mpi_write( IOBUF out, MPI a );
+
+
+
+
+  MPI mpi_read(IOBUF inp, unsigned *nread, int secure);
+
+int mpi_fromstr(MPI val, const char *str);
+int mpi_print( FILE *fp, MPI a, int mode );
+u32 mpi_get_keyid( MPI a, u32 *keyid );
+byte *mpi_get_buffer( MPI a, unsigned *nbytes, int *sign );
+void  mpi_set_buffer( MPI a, const byte *buffer, unsigned nbytes, int sign );
+
+ 
+void mpi_add_ui(MPI w, MPI u, ulong v );
+void mpi_add(MPI w, MPI u, MPI v);
+void mpi_addm(MPI w, MPI u, MPI v, MPI m);
+void mpi_sub_ui(MPI w, MPI u, ulong v );
+void mpi_sub( MPI w, MPI u, MPI v);
+void mpi_subm( MPI w, MPI u, MPI v, MPI m);
+
+ 
+void mpi_mul_ui(MPI w, MPI u, ulong v );
+void mpi_mul_2exp( MPI w, MPI u, ulong cnt);
+void mpi_mul( MPI w, MPI u, MPI v);
+void mpi_mulm( MPI w, MPI u, MPI v, MPI m);
+
+ 
+ulong mpi_fdiv_r_ui( MPI rem, MPI dividend, ulong divisor );
+void  mpi_fdiv_r( MPI rem, MPI dividend, MPI divisor );
+void  mpi_fdiv_q( MPI quot, MPI dividend, MPI divisor );
+void  mpi_fdiv_qr( MPI quot, MPI rem, MPI dividend, MPI divisor );
+void  mpi_tdiv_r( MPI rem, MPI num, MPI den);
+void  mpi_tdiv_qr( MPI quot, MPI rem, MPI num, MPI den);
+void  mpi_tdiv_q_2exp( MPI w, MPI u, unsigned count );
+int   mpi_divisible_ui(MPI dividend, ulong divisor );
+
+ 
+int mpi_gcd( MPI g, MPI a, MPI b );
+
+ 
+void mpi_pow( MPI w, MPI u, MPI v);
+void mpi_powm( MPI res, MPI base, MPI exp, MPI mod);
+
+ 
+void mpi_mulpowm( MPI res, MPI *basearray, MPI *exparray, MPI mod);
+
+ 
+int mpi_cmp_ui( MPI u, ulong v );
+int mpi_cmp( MPI u, MPI v );
+
+ 
+int mpi_getbyte( MPI a, unsigned index );
+void mpi_putbyte( MPI a, unsigned index, int value );
+unsigned mpi_trailing_zeros( MPI a );
+
+ 
+unsigned mpi_get_nbits( MPI a );
+int  mpi_test_bit( MPI a, unsigned n );
+void mpi_set_bit( MPI a, unsigned n );
+void mpi_set_highbit( MPI a, unsigned n );
+void mpi_clear_bit( MPI a, unsigned n );
+void mpi_set_bytes( MPI a, unsigned nbits, byte (*fnc)(int), int opaque );
+void mpi_rshift( MPI x, MPI a, unsigned n );
+
+ 
+void mpi_invm( MPI x, MPI u, MPI v );
+
+
+
+# 26 "packet.h" 2
+
+# 1 "../include/cipher.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "../include/../cipher/md.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "../include/../cipher/rmd.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct {
+    u32  h0,h1,h2,h3,h4;
+    u32  nblocks;
+    byte buf[64];
+    int  count;
+} RMD160_CONTEXT;
+
+
+void rmd160_init( RMD160_CONTEXT *c );
+void rmd160_write( RMD160_CONTEXT *hd, byte *inbuf, size_t inlen);
+void rmd160_final(RMD160_CONTEXT *hd);
+void rmd160_mixblock( RMD160_CONTEXT *hd, char *buffer );
+
+
+
+# 25 "../include/../cipher/md.h" 2
+
+# 1 "../include/../cipher/sha1.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct {
+    u32  h0,h1,h2,h3,h4;
+    u32  nblocks;
+    byte buf[64];
+    int  count;
+} SHA1_CONTEXT;
+
+
+void sha1_init( SHA1_CONTEXT *c );
+void sha1_write( SHA1_CONTEXT *hd, byte *inbuf, size_t inlen);
+void sha1_final( SHA1_CONTEXT *hd);
+
+
+
+# 26 "../include/../cipher/md.h" 2
+
+# 1 "../include/../cipher/md5.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct {
+    u32 A,B,C,D;	   
+    u32 total[2];
+    u32  buflen;
+    char buffer[128];
+} MD5_CONTEXT;
+
+
+void md5_init( MD5_CONTEXT *ctx );
+void md5_write( MD5_CONTEXT *ctx, const void *buffer, size_t len);
+void md5_final( MD5_CONTEXT *ctx);
+
+
+
+# 27 "../include/../cipher/md.h" 2
+
+
+
+
+typedef struct {
+    int use_rmd160;
+    RMD160_CONTEXT rmd160;
+    int use_sha1;
+    SHA1_CONTEXT sha1;
+    int use_md5;
+    MD5_CONTEXT md5;
+    byte buffer[512 ];  
+    int  bufcount;
+    int  secure;
+    FILE  *debug;
+} *MD_HANDLE;
+
+
+
+
+
+
+
+
+
+ 
+MD_HANDLE md_open( int algo, int secure );
+void md_enable( MD_HANDLE hd, int algo );
+MD_HANDLE md_copy( MD_HANDLE a );
+void md_close(MD_HANDLE a);
+void md_write( MD_HANDLE a, byte *inbuf, size_t inlen);
+void md_final(MD_HANDLE a);
+byte *md_read( MD_HANDLE a, int algo );
+int md_get_algo( MD_HANDLE a );
+const byte *md_asn_oid( int algo, size_t *asnlen, size_t *mdlen );
+
+
+
+# 31 "../include/cipher.h" 2
+
+
+
+
+# 1 "../include/../cipher/blowfish.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct {
+    u32 s0[256];
+    u32 s1[256];
+    u32 s2[256];
+    u32 s3[256];
+    u32 p[16 +2];
+    byte iv[8 ];
+    byte eniv[8 ];
+    int  count;
+} BLOWFISH_context;
+
+void blowfish_setkey( BLOWFISH_context *c, byte *key, unsigned keylen );
+void blowfish_setiv( BLOWFISH_context *c, byte *iv );
+void blowfish_encode( BLOWFISH_context *c, byte *outbuf, byte *inbuf,
+						    unsigned nblocks );
+void blowfish_decode( BLOWFISH_context *c, byte *outbuf, byte *inbuf,
+						    unsigned nblocks );
+void blowfish_encode_cfb( BLOWFISH_context *c, byte *outbuf,
+					 byte *inbuf, unsigned nbytes);
+void blowfish_decode_cfb( BLOWFISH_context *c, byte *outbuf,
+					 byte *inbuf, unsigned nbytes);
+
+
+
+# 35 "../include/cipher.h" 2
+
+# 1 "../include/../cipher/elgamal.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct {
+    MPI p;	     
+    MPI g;	     
+    MPI y;	     
+} ELG_public_key;
+
+
+typedef struct {
+    MPI p;	     
+    MPI g;	     
+    MPI y;	     
+    MPI x;	     
+} ELG_secret_key;
+
+
+void elg_free_public_key( ELG_public_key *pk );
+void elg_free_secret_key( ELG_secret_key *sk );
+void elg_generate( ELG_public_key *pk, ELG_secret_key *sk,
+				unsigned nbits, MPI **factors );
+int  elg_check_secret_key( ELG_secret_key *sk );
+void elg_encrypt(MPI a, MPI b, MPI input, ELG_public_key *pkey );
+void elg_decrypt(MPI output, MPI a, MPI b, ELG_secret_key *skey );
+void elg_sign(MPI a, MPI b, MPI input, ELG_secret_key *skey);
+int  elg_verify(MPI a, MPI b, MPI input, ELG_public_key *pkey);
+
+
+# 36 "../include/cipher.h" 2
+
+# 1 "../include/../cipher/random.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+void secure_random_alloc(void);
+int  quick_random_gen( int onoff );
+void randomize_buffer( byte *buffer, size_t length, int level );
+byte get_random_byte( int level );
+void add_randomness( const void *buffer, size_t length, int source );
+
+
+ 
+
+void random_poll(void);
+void fast_random_poll(void);
+
+
+
+# 37 "../include/cipher.h" 2
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct {
+    int algo;
+    int keylen;
+    byte key[20];  
+} DEK;
+
+
+int cipher_debug_mode;
+
+
+ 
+int string_to_cipher_algo( const char *string );
+int string_to_pubkey_algo( const char *string );
+int string_to_digest_algo( const char *string );
+const char * cipher_algo_to_string( int algo );
+const char * pubkey_algo_to_string( int algo );
+const char * digest_algo_to_string( int algo );
+int check_cipher_algo( int algo );
+int check_pubkey_algo( int algo );
+int check_digest_algo( int algo );
+
+
+ 
+extern ushort small_prime_numbers[];
+
+ 
+MPI generate_secret_prime( unsigned nbits );
+MPI generate_public_prime( unsigned nbits );
+MPI generate_elg_prime( unsigned pbits, unsigned qbits, MPI g, MPI **factors );
+
+
+
+# 27 "packet.h" 2
+
+# 1 "filter.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+typedef struct {
+    MD_HANDLE md;       
+    size_t maxbuf_size;
+} md_filter_context_t;
+
+typedef struct {
+    int status;
+    int what;
+    byte radbuf[4];
+    int  idx, idx2;
+    u32 crc;
+    byte helpbuf[100];
+    int  helpidx, helplen;
+    unsigned empty;     
+    int faked;
+    int parse_state;
+    int inp_checked;    
+    int inp_bypass;     
+    int inp_eof;
+    const char *hdrlines;
+} armor_filter_context_t;
+
+
+typedef struct {
+    int status;
+    void *opaque;    
+    byte *inbuf;
+    unsigned inbufsize;
+    byte *outbuf;
+    unsigned outbufsize;
+    int pgpmode;
+} compress_filter_context_t;
+
+
+typedef struct {
+    DEK *dek;
+    u32 datalen;
+    BLOWFISH_context *bf_ctx;
+    int header;
+} cipher_filter_context_t;
+
+
+
+typedef struct {
+    int eof;
+    size_t idx;
+    size_t len;
+    byte buf[256];
+} text_filter_context_t;
+
+
+ 
+
+ 
+int md_filter( void *opaque, int control, IOBUF a, byte *buf, size_t *ret_len);
+void free_md_filter_context( md_filter_context_t *mfx );
+
+ 
+int use_armor_filter( IOBUF a );
+int armor_filter( void *opaque, int control,
+		  IOBUF chain, byte *buf, size_t *ret_len);
+
+ 
+int compress_filter( void *opaque, int control,
+		     IOBUF chain, byte *buf, size_t *ret_len);
+
+ 
+int cipher_filter( void *opaque, int control,
+		   IOBUF chain, byte *buf, size_t *ret_len);
+
+ 
+int text_filter( void *opaque, int control,
+		 IOBUF chain, byte *buf, size_t *ret_len);
+
+
+
+
+# 28 "packet.h" 2
+
+
+typedef enum {
+	PKT_NONE	   =0,
+	PKT_PUBKEY_ENC	   =1,  
+	PKT_SIGNATURE	   =2,  
+	PKT_SESSION_KEY    =3,  
+	PKT_ONEPASS_SIG    =4,  
+	PKT_SECRET_CERT    =5,  
+	PKT_PUBLIC_CERT    =6,  
+	PKT_SECKEY_SUBCERT =7,  
+	PKT_COMPRESSED	   =8,  
+	PKT_ENCRYPTED	   =9,  
+	PKT_MARKER	  =10,  
+	PKT_PLAINTEXT	  =11,  
+	PKT_RING_TRUST	  =12,  
+	PKT_USER_ID	  =13,  
+	PKT_PUBKEY_SUBCERT=14,  
+	PKT_COMMENT	  =16   
+} pkttype_t;
+
+typedef struct packet_struct PACKET;
+
+typedef struct {
+    u32     keyid[2];	     
+    byte    pubkey_algo;     
+    union {
+      struct {
+	MPI  a, b;	     
+      } elg;
+      struct {
+	MPI  rsa_integer;    
+      } rsa;
+    } d;
+} PKT_pubkey_enc;
+
+
+typedef struct {
+    u32     keyid[2];	     
+    byte    sig_class;	     
+    byte    digest_algo;     
+    byte    pubkey_algo;     
+    byte    last;	     
+} PKT_onepass_sig;
+
+
+typedef struct {
+    u32     keyid[2];	     
+    ulong   local_id;	     
+    u32     timestamp;	     
+    byte    sig_class;	     
+    byte    pubkey_algo;     
+			     
+    union {
+      struct {
+	byte digest_algo;      
+	byte digest_start[2];  
+	MPI  a, b;	       
+      } elg;
+      struct {
+	byte digest_algo;      
+	byte digest_start[2];  
+	MPI  rsa_integer;      
+      } rsa;
+    } d;
+} PKT_signature;
+
+
+typedef struct {
+    u32     timestamp;	     
+    u16     valid_days;      
+    byte    hdrbytes;	     
+    byte    version;
+    byte    pubkey_algo;     
+    ulong   local_id;	     
+    union {
+      struct {
+	MPI p;		     
+	MPI g;		     
+	MPI y;		     
+      } elg;
+      struct {
+	MPI rsa_n;	     
+	MPI rsa_e;	     
+      } rsa;
+    } d;
+} PKT_public_cert;
+
+typedef struct {
+    u32     timestamp;	     
+    u16     valid_days;      
+    byte    hdrbytes;	     
+    byte    version;
+    byte    pubkey_algo;     
+    union {
+      struct {
+	MPI p;		     
+	MPI g;		     
+	MPI y;		     
+	MPI x;		     
+	u16 csum;	     
+	byte is_protected;   
+			     
+	struct {
+	    byte algo;	 
+	    byte s2k;
+	    byte hash;
+	    byte salt[8];
+	    byte count;
+	    byte iv[8];  
+	} protect;	     
+
+      } elg;
+      struct {
+	MPI rsa_n;	     
+	MPI rsa_e;	     
+	MPI rsa_d;	     
+	MPI rsa_p;	     
+	MPI rsa_q;	     
+	MPI rsa_u;	     
+	u16 csum;	     
+	byte is_protected;   
+			     
+	byte protect_algo;   
+	union { 	     
+	  struct {
+	    byte iv[8];      
+			     
+
+	  } blowfish;
+	} protect;
+      } rsa;
+    } d;
+} PKT_secret_cert;
+
+
+typedef struct {
+    int  len;		   
+    char data[1];
+} PKT_comment;
+
+typedef struct {
+    int  len;		   
+    char name[1];
+} PKT_user_id;
+
+typedef struct {
+    u32  len;		   
+    byte  algorithm;
+    IOBUF buf;		   
+} PKT_compressed;
+
+typedef struct {
+    u32  len;		   
+    IOBUF buf;		   
+} PKT_encrypted;
+
+typedef struct {
+    u32  len;		   
+    IOBUF buf;		   
+    int mode;
+    u32 timestamp;
+    int  namelen;
+    char name[1];
+} PKT_plaintext;
+
+ 
+struct packet_struct {
+    pkttype_t pkttype;
+    union {
+	void *generic;
+	PKT_pubkey_enc	*pubkey_enc;	 
+	PKT_onepass_sig *onepass_sig;	 
+	PKT_signature	*signature;	 
+	PKT_public_cert *public_cert;	 
+	PKT_secret_cert *secret_cert;	 
+	PKT_comment	*comment;	 
+	PKT_user_id	*user_id;	 
+	PKT_compressed	*compressed;	 
+	PKT_encrypted	*encrypted;	 
+	PKT_plaintext	*plaintext;	 
+    } pkt;
+};
+
+
+
+
+
+ 
+int proc_packets( IOBUF a );
+int proc_signature_packets( IOBUF a, STRLIST signedfiles );
+int proc_encryption_packets( IOBUF a );
+int list_packets( IOBUF a );
+
+ 
+int set_packet_list_mode( int mode );
+int search_packet( IOBUF inp, PACKET *pkt, int pkttype, ulong *retpos );
+int parse_packet( IOBUF inp, PACKET *ret_pkt);
+int copy_all_packets( IOBUF inp, IOBUF out );
+int copy_some_packets( IOBUF inp, IOBUF out, ulong stopoff );
+int skip_some_packets( IOBUF inp, unsigned n );
+
+ 
+int build_packet( IOBUF inp, PACKET *pkt );
+u32 calc_packet_length( PACKET *pkt );
+void hash_public_cert( MD_HANDLE md, PKT_public_cert *pkc );
+
+ 
+void free_pubkey_enc( PKT_pubkey_enc *enc );
+void free_seckey_enc( PKT_signature *enc );
+int  digest_algo_from_sig( PKT_signature *sig );
+void release_public_cert_parts( PKT_public_cert *cert );
+void free_public_cert( PKT_public_cert *cert );
+void release_secret_cert_parts( PKT_secret_cert *cert );
+void free_secret_cert( PKT_secret_cert *cert );
+void free_user_id( PKT_user_id *uid );
+void free_comment( PKT_comment *rem );
+void free_packet( PACKET *pkt );
+PKT_public_cert *copy_public_cert( PKT_public_cert *d, PKT_public_cert *s );
+PKT_secret_cert *copy_secret_cert( PKT_secret_cert *d, PKT_secret_cert *s );
+int cmp_public_certs( PKT_public_cert *a, PKT_public_cert *b );
+int cmp_public_secret_cert( PKT_public_cert *pkc, PKT_secret_cert *skc );
+int cmp_user_ids( PKT_user_id *a, PKT_user_id *b );
+
+
+ 
+int signature_check( PKT_signature *sig, MD_HANDLE digest );
+
+ 
+int is_secret_key_protected( PKT_secret_cert *cert );
+int check_secret_key( PKT_secret_cert *cert );
+int protect_secret_key( PKT_secret_cert *cert, DEK *dek );
+
+ 
+int get_session_key( PKT_pubkey_enc *k, DEK *dek );
+
+ 
+int handle_compressed( PKT_compressed *cd,
+		       int (*callback)(IOBUF, void *), void *passthru );
+
+ 
+int decrypt_data( PKT_encrypted *ed, DEK *dek );
+int encrypt_data( PKT_encrypted *ed, DEK *dek );
+
+ 
+int handle_plaintext( PKT_plaintext *pt, md_filter_context_t *mfx );
+int ask_for_detached_datafile( md_filter_context_t *mfx, const char *inname );
+
+ 
+int write_comment( IOBUF out, const char *s );
+
+ 
+int make_keysig_packet( PKT_signature **ret_sig, PKT_public_cert *pkc,
+			PKT_user_id *uid, PKT_secret_cert *skc,
+			int sigclass, int digest_algo );
+
+
+# 34 "g10.c" 2
+
+
+
+# 1 "../include/util.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "../include/errors.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 24 "../include/util.h" 2
+
+
+
+
+
+typedef struct {
+     int  *argc;	     
+     char ***argv;	     
+     unsigned flags;	     
+     int err;		     
+			     
+     int r_opt; 	     
+     int r_type;	     
+     union {
+	 int   ret_int;
+	 long  ret_long;
+	 ulong ret_ulong;
+	 char *ret_str;
+     } r;		     
+     struct {
+	 int index;
+	 int inarg;
+	 int stopped;
+	 const char *last;
+     } internal;	     
+} ARGPARSE_ARGS;
+
+typedef struct {
+    int 	short_opt;
+    const char *long_opt;
+    unsigned flags;
+    const char *description;  
+} ARGPARSE_OPTS;
+
+ 
+void log_set_name( const char *name );
+const char *log_get_name(void);
+void log_set_pid( int pid );
+int  log_get_errorcount( int clear );
+void log_hexdump( const char *text, char *buf, size_t len );
+void log_mpidump( const char *text, MPI a );
+
+
+  void log_bug( const char *fmt, ... )
+			    __attribute__ ((noreturn, format (printf,1,2)));
+  void log_bug0( const char *, int, const char * ) __attribute__ ((noreturn));
+  void log_fatal( const char *fmt, ... )
+			    __attribute__ ((noreturn, format (printf,1,2)));
+  void log_error( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
+  void log_info( const char *fmt, ... )  __attribute__ ((format (printf,1,2)));
+  void log_debug( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
+  
+# 84 "../include/util.h"
+
+
+
+ 
+const char * g10_errstr( int no );
+
+ 
+int arg_parse( ARGPARSE_ARGS *arg, ARGPARSE_OPTS *opts);
+int optfile_parse( FILE *fp, const char *filename, unsigned *lineno,
+		   ARGPARSE_ARGS *arg, ARGPARSE_OPTS *opts);
+void usage( int level );
+const char *default_strusage( int level );
+
+
+ 
+const char *strusage( int level );
+
+
+ 
+char *make_filename( const char *first_part, ... );
+const char *print_fname_stdin( const char *s );
+const char *print_fname_stdout( const char *s );
+
+
+ 
+u32 make_timestamp(void);
+void print_string( FILE *fp, byte *p, size_t n, int delim );
+int answer_is_yes( const char *s );
+
+ 
+void free_strlist( STRLIST sl );
+
+void add_to_strlist( STRLIST *list, const char *string );
+STRLIST strlist_prev( STRLIST head, STRLIST node );
+STRLIST strlist_last( STRLIST node );
+char *memistr( char *buf, size_t buflen, const char *sub );
+char *mem2str( char *, const void *, size_t);
+char *trim_spaces( char *string );
+int string_count_chr( const char *string, int c );
+
+
+
+
+
+
+char *strlwr(char *a);
+
+
+
+
+
+ 
+
+  
+
+
+
+
+
+
+# 37 "g10.c" 2
+
+# 1 "main.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 1 "keydb.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+typedef struct kbnode_struct *KBNODE;
+struct kbnode_struct {
+    KBNODE next;
+    PACKET *pkt;
+    int flag;
+    int private_flag;
+};
+
+ 
+
+
+
+struct keyblock_pos_struct {
+    int   resno;      
+    ulong offset;     
+    unsigned count;   
+    IOBUF  fp;	      
+    PACKET *pkt;      
+};
+typedef struct keyblock_pos_struct KBPOS;
+
+ 
+typedef struct pkc_list *PKC_LIST;
+struct pkc_list {
+    PKC_LIST next;
+    PKT_public_cert *pkc;
+    int mark;
+};
+
+ 
+typedef struct skc_list *SKC_LIST;
+struct skc_list {
+    SKC_LIST next;
+    PKT_secret_cert *skc;
+    int mark;
+};
+
+ 
+
+typedef struct pubkey_find_info *PUBKEY_FIND_INFO;
+struct pubkey_find_info {
+    u32  keyid[2];
+    unsigned nbits;
+    byte pubkey_algo;
+    byte fingerprint[20];
+    char userid[1];
+};
+
+
+ 
+void release_pkc_list( PKC_LIST pkc_list );
+int  build_pkc_list( STRLIST remusr, PKC_LIST *ret_pkc_list );
+
+ 
+void release_skc_list( SKC_LIST skc_list );
+int  build_skc_list( STRLIST locusr, SKC_LIST *ret_skc_list, int unlock );
+
+ 
+void set_passphrase_fd( int fd );
+int  get_passphrase_fd(void);
+DEK *get_passphrase_hash( u32 *keyid, char *text, byte *salt );
+int make_dek_from_passphrase( DEK *dek, int mode, byte *salt );
+
+ 
+void add_keyring( const char *name );
+const char *get_keyring( int sequence );
+void add_secret_keyring( const char *name );
+void cache_public_cert( PKT_public_cert *pkc );
+void cache_user_id( PKT_user_id *uid, u32 *keyid );
+int get_pubkey( PKT_public_cert *pkc, u32 *keyid );
+int get_pubkey_byname( PKT_public_cert *pkc, const char *name );
+int get_seckey( PKT_secret_cert *skc, u32 *keyid );
+int seckey_available( u32 *keyid );
+int get_seckey_byname( PKT_secret_cert *skc, const char *name, int unlock );
+int enum_secret_keys( void **context, PKT_secret_cert *skc );
+char*get_user_id_string( u32 *keyid );
+char*get_user_id( u32 *keyid, size_t *rn );
+
+ 
+int pubkey_letter( int algo );
+u32 keyid_from_skc( PKT_secret_cert *skc, u32 *keyid );
+u32 keyid_from_pkc( PKT_public_cert *pkc, u32 *keyid );
+u32 keyid_from_sig( PKT_signature *sig, u32 *keyid );
+unsigned nbits_from_pkc( PKT_public_cert *pkc );
+unsigned nbits_from_skc( PKT_secret_cert *skc );
+const char *datestr_from_pkc( PKT_public_cert *pkc );
+const char *datestr_from_skc( PKT_secret_cert *skc );
+const char *datestr_from_sig( PKT_signature *sig );
+byte *fingerprint_from_skc( PKT_secret_cert *skc, size_t *ret_len );
+byte *fingerprint_from_pkc( PKT_public_cert *pkc, size_t *ret_len );
+
+ 
+KBNODE new_kbnode( PACKET *pkt );
+KBNODE clone_kbnode( KBNODE node );
+void release_kbnode( KBNODE n );
+void delete_kbnode( KBNODE node );
+void add_kbnode( KBNODE root, KBNODE node );
+void insert_kbnode( KBNODE root, KBNODE node, int pkttype );
+KBNODE find_prev_kbnode( KBNODE root, KBNODE node, int pkttype );
+KBNODE find_next_kbnode( KBNODE node, int pkttype );
+KBNODE find_kbnode( KBNODE node, int pkttype );
+KBNODE walk_kbnode( KBNODE root, KBNODE *context, int all );
+void clear_kbnode_flags( KBNODE n );
+int  commit_kbnode( KBNODE *root );
+
+ 
+int add_keyblock_resource( const char *filename, int force, int secret );
+const char *keyblock_resource_name( KBPOS *kbpos );
+int get_keyblock_handle( const char *filename, int secret, KBPOS *kbpos );
+int find_keyblock( PUBKEY_FIND_INFO info, KBPOS *kbpos );
+int find_keyblock_byname( KBPOS *kbpos, const char *username );
+int find_keyblock_bypkc( KBPOS *kbpos, PKT_public_cert *pkc );
+int find_secret_keyblock_byname( KBPOS *kbpos, const char *username );
+int lock_keyblock( KBPOS *kbpos );
+void unlock_keyblock( KBPOS *kbpos );
+int read_keyblock( KBPOS *kbpos, KBNODE *ret_root );
+int enum_keyblocks( int mode, KBPOS *kbpos, KBNODE *ret_root );
+int insert_keyblock( KBPOS *kbpos, KBNODE root );
+int delete_keyblock( KBPOS *kbpos );
+int update_keyblock( KBPOS *kbpos, KBNODE root );
+
+
+
+# 25 "main.h" 2
+
+
+
+typedef struct {
+    int header_okay;
+    PKC_LIST pkc_list;
+    cipher_filter_context_t cfx;
+} encrypt_filter_context_t;
+
+
+ 
+
+  void g10_exit(int rc) __attribute__ ((noreturn));
+
+
+
+
+ 
+int encode_symmetric( const char *filename );
+int encode_store( const char *filename );
+int encode_crypt( const char *filename, STRLIST remusr );
+int encrypt_filter( void *opaque, int control,
+		    IOBUF a, byte *buf, size_t *ret_len);
+
+
+ 
+int sign_file( STRLIST filenames, int detached, STRLIST locusr,
+	       int encrypt, STRLIST remusr, const char *outfile );
+int clearsign_file( const char *fname, STRLIST locusr, const char *outfile );
+int sign_key( const char *username, STRLIST locusr );
+int edit_keysigs( const char *username );
+int delete_key( const char *username, int secure );
+int change_passphrase( const char *username );
+
+ 
+int check_key_signature( KBNODE root, KBNODE node, int *is_selfsig );
+
+ 
+void generate_keypair(void);
+
+ 
+int overwrite_filep( const char *fname );
+IOBUF open_outfile( const char *fname, int mode );
+IOBUF open_sigfile( const char *iname );
+
+ 
+void make_session_key( DEK *dek );
+MPI encode_session_key( DEK *dek, unsigned nbits );
+MPI encode_md_value( MD_HANDLE md, unsigned nbits );
+
+ 
+KBNODE make_comment_node( const char *s );
+KBNODE make_mpi_comment_node( const char *s, MPI a );
+
+ 
+void g10_elg_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek );
+void g10_elg_sign( PKT_secret_cert *skc, PKT_signature *sig,
+					 MD_HANDLE md, int digest_algo );
+
+ 
+void g10_rsa_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek );
+void g10_rsa_sign( PKT_secret_cert *skc, PKT_signature *sig,
+					 MD_HANDLE md, int digest_algo );
+
+ 
+int import_pubkeys( const char *filename );
+ 
+int export_pubkeys( STRLIST users );
+ 
+int dearmor_file( const char *fname );
+int enarmor_file( const char *fname );
+
+ 
+int gen_revoke( const char *uname );
+
+ 
+void std_key_list( int nnames, char **names );
+
+ 
+int verify_signatures( int nfiles, char **files );
+
+ 
+int decrypt_message( const char *filename );
+
+ 
+int hash_datafiles( MD_HANDLE md, STRLIST files, int textmode );
+
+
+# 38 "g10.c" 2
+
+# 1 "options.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+struct {
+    int verbose;
+    unsigned debug;
+    int armor;
+    int compress;
+    char *outfile;
+    int textmode;
+    int batch;	     
+    int answer_yes;  
+    int answer_no;   
+    int check_sigs;  
+    int with_colons;
+    int fingerprint;  
+    int list_sigs;    
+    int no_armor;
+    int list_packets;  
+    int def_cipher_algo;
+    int def_pubkey_algo;
+    int def_digest_algo;
+    int no_comment;
+    int marginals_needed;
+    int completes_needed;
+    const char *homedir;
+    int reserved13;
+    int reserved14;
+    int reserved15;
+} opt;
+
+
+
+
+
+				 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# 39 "g10.c" 2
+
+
+
+
+
+# 1 "trustdb.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+ 
+
+
+
+ 
+void list_trustdb(const char *username);
+void list_trust_path( int max_depth, const char *username );
+int init_trustdb( int level, const char *dbname );
+int check_trust( PKT_public_cert *pkc, unsigned *r_trustlevel );
+int enum_trust_web( void **context, ulong *lid );
+int get_ownertrust( ulong lid, unsigned *r_otrust );
+int keyid_from_trustdb( ulong lid, u32 *keyid );
+int query_trust_record( PKT_public_cert *pkc );
+int insert_trust_record( PKT_public_cert *pkc );
+int update_ownertrust( ulong lid, unsigned new_trust );
+int verify_private_data(void);
+int sign_private_data(void);
+
+
+# 44 "g10.c" 2
+
+# 1 "../include/ttyio.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+void tty_printf( const char *fmt, ... );
+void tty_print_string( byte *p, size_t n );
+char *tty_get( const char *prompt );
+char *tty_get_hidden( const char *prompt );
+void tty_kill_prompt(void);
+
+
+
+# 45 "g10.c" 2
+
+# 1 "../include/i18n.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+  
+# 1 "/usr/include/locale.h" 1 3
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+
+
+
+
+
+
+
+
+ 
+
+ 
+
+
+
+
+
+
+
+
+
+
+ 
+struct lconv
+{
+   
+
+  char *decimal_point;		 
+  char *thousands_sep;		 
+   
+
+
+
+
+  char *grouping;
+
+   
+
+   
+
+  char *int_curr_symbol;
+  char *currency_symbol;	 
+  char *mon_decimal_point;	 
+  char *mon_thousands_sep;	 
+  char *mon_grouping;		 
+  char *positive_sign;		 
+  char *negative_sign;		 
+  char int_frac_digits;		 
+  char frac_digits;		 
+   
+  char p_cs_precedes;
+   
+  char p_sep_by_space;
+   
+  char n_cs_precedes;
+   
+  char n_sep_by_space;
+   
+
+
+
+
+
+  char p_sign_posn;
+  char n_sign_posn;
+};
+
+
+ 
+extern char *setlocale  (int __category, __const char *__locale)  ;
+
+ 
+extern struct lconv *localeconv  (void)  ;
+
+ 
+
+
+# 25 "../include/i18n.h" 2
+
+
+
+# 36 "../include/i18n.h"
+
+  
+  
+
+
+
+# 46 "g10.c" 2
+
+# 1 "status.h" 1
+ 
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ 
+void set_status_fd( int fd );
+void write_status( int no );
+
+
+
+# 47 "g10.c" 2
+
+
+
+
+
+
+
+static ARGPARSE_OPTS opts[] = {
+
+    { 300, ((void *)0) , 0, ( "\vCommands:\n " )  },
+
+  
+# 67 "g10.c"
+
+    { 551, "list-keys", 0, ( "list keys" ) },
+    { 552, "list-sigs", 0, ( "list keys and signatures" ) },
+    { 508, "check-sigs",0, ( "check key signatures" ) },
+    { 515, "fingerprint", 0, ( "list keys and fingerprints" ) },
+  
+
+
+
+
+
+
+
+    { 537, "export"          , 0, ( "export keys" )  },
+    { 530, "import",      0     , ( "import/merge keys" ) },
+    { 521, "list-packets",0,( "list only the sequence of packets" ) },
+  
+    { 546, "dearmor", 0, ( "De-Armor a file or stdin" )  },
+    { 547, "enarmor", 0, ( "En-Armor a file or stdin" )  },
+    { 516, "print-mds" , 0, ( "print all message digests" ) },
+    { 513, "gen-prime" , 0, "\r" },
+    { 548, "gen-random" , 0, "\r" },
+  
+
+    { 301, ((void *)0) , 0, ( "\v\nOptions:\n " )  },
+
+  
+
+
+
+
+
+
+    { 'o', "output",    2, ( "use as output file" ) },
+    { 'v', "verbose",   0, ( "verbose" )  },
+    { 'n', "dry-run",   0, ( "don't make any changes" )  },
+    { 500, "batch",     0, ( "batch mode: never ask" ) },
+    { 501, "yes",       0, ( "assume yes on most questions" ) },
+    { 502, "no",        0, ( "assume no on most questions" ) },
+    { 509, "keyring"   ,2, ( "add this keyring to the list of keyrings" ) },
+    { 517, "secret-keyring" ,2, ( "add this secret keyring to the list" ) },
+    { 518, "options"   , 2, ( "read options from file" ) },
+
+    { 510, "debug"     ,4|16, ( "set debugging flags" ) },
+    { 511, "debug-all" ,0, ( "enable full debugging" ) },
+    { 512, "status-fd" ,1, ( "write status info to this fd" )  },
+    { 534, "no-comment", 0,   ( "do not write comment packets" ) },
+    { 535, "completes-needed", 1, ( "(default is 1)" ) },
+    { 536, "marginals-needed", 1, ( "(default is 3)" ) },
+  
+
+
+
+
+
+  
+
+
+
+
+
+
+
+
+   
+  
+    { 514, "test"      , 0, "\r" },
+    { 531, "list-trustdb",0 , "\r"},
+    { 533, "list-trust-path",0, "\r"},
+  
+  
+
+
+
+
+
+    { 532, "quick-random", 0, "\r"},
+    { 526, "no-verbose", 0, "\r"},
+    { 538, "trustdb-name", 2, "\r" },
+    { 540, "no-secmem-warning", 0, "\r" },  
+    { 519, "no-armor",   0, "\r"},
+    { 520, "no-default-keyring", 0, "\r" },
+    { 522, "no-greeting", 0, "\r" },
+    { 541, "no-operation", 0, "\r" },       
+    { 543, "no-options", 0, "\r" },  
+    { 544, "homedir", 2, "\r" },    
+    { 545, "no-batch", 0, "\r" },
+    { 549, "with-colons", 0, "\r"},
+    { 551, "list-key", 0, "\r" },  
+    { 552, "list-sig", 0, "\r" },  
+    { 508, "check-sig",0, "\r" },  
+
+
+{0} };
+
+
 
 
 enum cmd_values { aNull = 0,
-    aPrimegen, aPrintMDs, aListPackets, aKMode, aKModeC,
-    aListTrustDB, aListTrustPath, aDeArmor, aEnArmor,
-aTest };
+    aSym, aStore, aEncr, aKeygen, aSign, aSignEncr,
+    aSignKey, aClearsign, aListPackets, aEditSig, aDeleteKey, aDeleteSecretKey,
+    aKMode, aKModeC, aChangePass, aImport, aVerify, aDecrypt, aListKeys,
+    aListSigs,
+    aExport, aCheckKeys, aGenRevoke, aPrimegen, aPrintMDs,
+    aListTrustDB, aListTrustPath, aDeArmor, aEnArmor, aGenRandom, aTest,
+aNOP };
 
 
 static char *build_list( const char *text,
 			 const char *(*mapf)(int), int (*chkf)(int) );
 static void set_cmd( enum cmd_values *ret_cmd,
 			enum cmd_values new_cmd );
+
 static void print_hex( byte *p, size_t n );
 static void print_mds( const char *fname );
 static void do_test(int);
@@ -62,20 +5970,36 @@
   static char *digests, *pubkeys, *ciphers;
     const char *p;
     switch( level ) {
-      case 11: p = "gpgm (GNUPG)"; break;
-      case 13: p = VERSION; break;
-      case 17: p = PRINTABLE_OS_NAME; break;
-      case 19: p = _(
-"Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"
-	); break;
+      case 11: p =
+	  
+	    "gpgm (GNUPG)";
+	  
+
+
+	break;
+      case 13: p = "0.2.11b" ; break;
+      case 17: p = "Linux" ; break;
+      case 19: p =
+	    ( "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n" ) ;
+	break;
       case 1:
-      case 40:	p = _(
-"Usage: gpgm [options] [files] (-h for help)"
-	); break;
-      case 41:	p = _(
-"Syntax: gpgm [options] [files]\n"
-"GNUPG maintenance utility\n"
-	); break;
+      case 40:	p =
+	  
+	    ( "Usage: gpgm [options] [files] (-h for help)" ) ;
+	  
+
+
+	break;
+      case 41:	p =
+	  
+	    ( "Syntax: gpgm [options] [files]\n"
+	      "GNUPG maintenance utility\n" ) ;
+	  
+
+
+
+
+	break;
 
       case 31: p = "\n"; break;
       case 32:
@@ -115,7 +6039,7 @@
 	if( !chkf(i) && (s=mapf(i)) )
 	    n += strlen(s) + 2;
     list = m_alloc( 21 + n ); *list = 0;
-    for(p=NULL, i=1; i < 100; i++ ) {
+    for(p= ((void *)0) , i=1; i < 100; i++ ) {
 	if( !chkf(i) && (s=mapf(i)) ) {
 	    if( !p )
 		p = stpcpy( list, text );
@@ -129,41 +6053,40 @@
     return list;
 }
 
+
 static void
 i18n_init(void)
 {
-  #ifdef HAVE_LIBINTL
-    #ifdef HAVE_LC_MESSAGES
-       setlocale( LC_MESSAGES, "" );
-    #else
-       setlocale( LC_ALL, "" );
-    #endif
-    bindtextdomain( PACKAGE, G10_LOCALEDIR );
-    textdomain( PACKAGE );
-  #endif
+  
+# 286 "g10.c"
+
 }
 
 static void
 wrong_args( const char *text)
 {
-    fputs(_("Usage: gpgm [options] "),stderr);
-    fputs(text,stderr);
-    putc('\n',stderr);
+  
+    fputs(( "usage: gpgm [options] " ) ,((_IO_FILE*)(&_IO_stderr_))  );
+  
+
+
+    fputs(text,((_IO_FILE*)(&_IO_stderr_))  );
+    (((   ((_IO_FILE*)(&_IO_stderr_))    )->_IO_write_ptr >= (   ((_IO_FILE*)(&_IO_stderr_))    )->_IO_write_end) ? __overflow(   ((_IO_FILE*)(&_IO_stderr_))    , (unsigned char)(  '\n'  )) : (unsigned char)(*(   ((_IO_FILE*)(&_IO_stderr_))    )->_IO_write_ptr++ = (  '\n'  )))  ;
     g10_exit(2);
 }
 
 static void
 set_debug(void)
 {
-    if( opt.debug & DBG_MEMORY_VALUE )
+    if( opt.debug & 32  )
 	memory_debug_mode = 1;
-    if( opt.debug & DBG_MEMSTAT_VALUE )
+    if( opt.debug & 128  )
 	memory_stat_debug_mode = 1;
-    if( opt.debug & DBG_MPI_VALUE )
+    if( opt.debug & 2  )
 	mpi_debug_mode = 1;
-    if( opt.debug & DBG_CIPHER_VALUE )
+    if( opt.debug & 4  )
 	cipher_debug_mode = 1;
-    if( opt.debug & DBG_IOBUF_VALUE )
+    if( opt.debug & 16  )
 	iobuf_debug_mode = 1;
 }
 
@@ -175,10 +6098,17 @@
 
     if( !cmd || cmd == new_cmd )
 	cmd = new_cmd;
-    else if( cmd == aKMode && new_cmd == aKModeC )
+    else if( cmd == aSign && new_cmd == aEncr )
+	cmd = aSignEncr;
+    else if( cmd == aEncr && new_cmd == aSign )
+	cmd = aSignEncr;
+    else if( cmd == aKMode && new_cmd == aSym )
 	cmd = aKModeC;
+    else if(	( cmd == aSign	   && new_cmd == aClearsign )
+	     || ( cmd == aClearsign && new_cmd == aSign )  )
+	cmd = aClearsign;
     else {
-	log_error(_("conflicting commands\n"));
+	log_error(( "conflicting commands\n" ) );
 	g10_exit(2);
     }
 
@@ -186,159 +6116,163 @@
 }
 
 
+
+static void
+check_opts(void)
+{
+    if( !opt.def_cipher_algo || check_cipher_algo(opt.def_cipher_algo) )
+	log_error(( "selected cipher algorithm is invalid\n" ) );
+    if( !opt.def_pubkey_algo || check_pubkey_algo(opt.def_pubkey_algo) )
+	log_error(( "selected pubkey algorithm is invalid\n" ) );
+    if( !opt.def_digest_algo || check_digest_algo(opt.def_digest_algo) )
+	log_error(( "selected digest algorithm is invalid\n" ) );
+    if( opt.completes_needed < 1 )
+	log_error(( "completes-needed must be greater than 0\n" ) );
+    if( opt.marginals_needed < 2 )
+	log_error(( "marginals-needed must be greater than 1\n" ) );
+}
+
+
+
+
 void
 main( int argc, char **argv )
 {
-    static ARGPARSE_OPTS opts[] = {
-    { 'v', "verbose",   0, N_("verbose") },
-    { 'n', "dry-run",   0, N_("don't make any changes") },
-    { 'o', "output",    2, N_("use as output file")},
-    { 'c', NULL    ,    0, N_("check signatures")},
-    { 500, "batch",     0, N_("batch mode: never ask")},
-    { 501, "yes",       0, N_("assume yes on most questions")},
-    { 502, "no",        0, N_("assume no on most questions")},
-    { 509, "keyring"   ,2, N_("add this keyring to the list of keyrings")},
-    { 'k', NULL      , 0, N_("list keys")},
-    { 510, "debug"     ,4|16, N_("set debugging flags")},
-    { 511, "debug-all" ,0, N_("enable full debugging")},
-    { 512, "status-fd" ,1, N_("write status info to this fd") },
-    { 513, "gen-prime" , 0, "\r" },
-    { 514, "test"      , 0, "\r" },
-    { 516, "print-mds" , 0, N_("print all message digests")},
-    { 517, "secret-keyring" ,2, N_("add this secret keyring to the list")},
-    { 518, "options"   , 2, N_("read options from file")},
-    { 519, "no-armor",   0, "\r"},
-    { 520, "no-default-keyring", 0, "\r" },
-    { 521, "list-packets",0,N_("list only the sequence of packets")},
-    { 522, "no-greeting", 0, "\r" },
-    { 526, "no-verbose", 0, "\r"},
-    { 531, "list-trustdb",0 , "\r"},
-    { 533, "list-trust-path",0, "\r"},
-    { 532, "quick-random", 0, "\r"},
-    { 534, "no-comment", 0,   N_("do not write comment packets")},
-    { 535, "completes-needed", 1, N_("(default is 1)")},
-    { 536, "marginals-needed", 1, N_("(default is 3)")},
-    { 538, "trustdb-name", 2, "\r" },
-    { 540, "no-secmem-warning", 0, "\r" }, /* dummy */
-    { 543, "no-options", 0, "\r" }, /* shortcut for --options /dev/null */
-    { 544, "homedir", 2, "\r" },   /* defaults to "~/.gpg" */
-    { 545, "no-batch", 0, "\r" },
-    { 546, "dearmor", 0, N_("De-Armor a file or stdin") },
-    { 547, "enarmor", 0, N_("En-Armor a file or stdin") },
-
-    {0} };
     ARGPARSE_ARGS pargs;
     IOBUF a;
     int rc=0;
     int orig_argc;
     char **orig_argv;
-    const char *fname, *fname_print;
-    STRLIST remusr= NULL, locusr=NULL;
+    const char *fname;
+    STRLIST sl, remusr= ((void *)0) , locusr= ((void *)0) ;
     int nrings=0, sec_nrings=0;
     armor_filter_context_t afx;
-    FILE *configfp = NULL;
-    char *configname = NULL;
+    int detached_sig = 0;
+    FILE *configfp = ((void *)0) ;
+    char *configname = ((void *)0) ;
     unsigned configlineno;
-    int parse_verbose = 0;
+    int parse_debug = 0;
     int default_config =1;
     int errors=0;
     int default_keyring = 1;
     int greeting = 1;
     enum cmd_values cmd = 0;
-    const char *trustdb_name = NULL;
+    const char *trustdb_name = ((void *)0) ;
+
+  
+    secmem_init( 0 );	    
+    log_set_name("gpgm");
+  
+
+
+
+
 
 
-    secmem_init( 0 ); /* disable use of secmem */
 
-    log_set_name("gpgm");
     i18n_init();
-    opt.compress = -1; /* defaults to standard compress level */
-    opt.def_cipher_algo = CIPHER_ALGO_BLOWFISH;
-    opt.def_pubkey_algo = PUBKEY_ALGO_ELGAMAL;
-    opt.def_digest_algo = DIGEST_ALGO_RMD160;
+    opt.compress = -1;  
+    opt.def_cipher_algo = 42 ;
+    opt.def_pubkey_algo = 16 ;
+    opt.def_digest_algo = 3 ;
     opt.completes_needed = 1;
     opt.marginals_needed = 3;
     opt.homedir = getenv("GNUPGHOME");
-    if( !opt.homedir || !*opt.homedir  ) {
-      #ifdef __MINGW32__
-	opt.homedir = "c:/gnupg";
-      #else
+    if( !opt.homedir || !*opt.homedir ) {
+      
+
+
 	opt.homedir = "~/.gnupg";
-      #endif
+      
     }
 
-    /* check wether we have a config file on the commandline */
+     
     orig_argc = argc;
     orig_argv = argv;
     pargs.argc = &argc;
     pargs.argv = &argv;
-    pargs.flags=  1;  /* do not remove the args */
+    pargs.flags=  1;   
     while( arg_parse( &pargs, opts) ) {
-	if( pargs.r_opt == 'v' )
-	    parse_verbose++;
+	if( pargs.r_opt == 510 || pargs.r_opt == 511 )
+	    parse_debug++;
 	else if( pargs.r_opt == 518 ) {
-	    /* yes there is one, so we do not try the default one, but
-	     * read the option file when it is encountered at the commandline
-	     */
+	     
+
+
 	    default_config = 0;
 	}
 	else if( pargs.r_opt == 543 )
-	    default_config = 0; /* --no-options */
+	    default_config = 0;  
 	else if( pargs.r_opt == 544 )
 	    opt.homedir = pargs.r.ret_str;
     }
 
     if( default_config )
-	configname = make_filename(opt.homedir, "options", NULL );
+	configname = make_filename(opt.homedir, "options", ((void *)0)  );
 
     argc = orig_argc;
     argv = orig_argv;
     pargs.argc = &argc;
     pargs.argv = &argv;
-    pargs.flags=  1;  /* do not remove the args */
+    pargs.flags=  1;   
   next_pass:
     if( configname ) {
 	configlineno = 0;
 	configfp = fopen( configname, "r" );
 	if( !configfp ) {
 	    if( default_config ) {
-		if( parse_verbose > 1 )
-		log_info(_("note: no default option file '%s'\n"), configname );
+		if( parse_debug )
+		    log_info(( "note: no default option file '%s'\n" ) ,
+							    configname );
 	    }
-	    else
-		log_fatal(_("option file '%s': %s\n"),
+	    else {
+		log_error(( "option file '%s': %s\n" ) ,
 				    configname, strerror(errno) );
-	    m_free(configname); configname = NULL;
+		g10_exit(1);
+	    }
+	    m_free(configname); configname = ((void *)0) ;
 	}
-	if( parse_verbose > 1 )
-	    log_info(_("reading options from '%s'\n"), configname );
+	if( parse_debug && configname )
+	    log_info(( "reading options from '%s'\n" ) , configname );
 	default_config = 0;
     }
 
     while( optfile_parse( configfp, configname, &configlineno,
 						&pargs, opts) ) {
 	switch( pargs.r_opt ) {
-	  case 'v': opt.verbose++;
-		    opt.list_sigs=1;
-		    break;
+
+	
+# 510 "g10.c"
+
+
+	
+	  case 513: set_cmd( &cmd, aPrimegen); break;
+	  case 514: set_cmd( &cmd, aTest); break;
+	  case 516: set_cmd( &cmd, aPrintMDs); break;
+	  case 531: set_cmd( &cmd, aListTrustDB); break;
+	  case 533: set_cmd( &cmd, aListTrustPath); break;
+	  case 540: break;  
+	  case 546: set_cmd( &cmd, aDeArmor); break;
+	  case 547: set_cmd( &cmd, aEnArmor); break;
+	  case 548: set_cmd( &cmd, aGenRandom); break;
+	
+
 	  case 'o': opt.outfile = pargs.r.ret_str; break;
+	  case 'v': opt.verbose++; opt.list_sigs=1; break;
 	  case 'k': set_cmd( &cmd, aKMode ); break;
-	  case 'c': set_cmd( &cmd, aKModeC ); break;
+
 	  case 500: opt.batch = 1; greeting = 0; break;
 	  case 501: opt.answer_yes = 1; break;
 	  case 502: opt.answer_no = 1; break;
-	  case 508: opt.check_sigs = 1; opt.list_sigs = 1; break;
+	  case 508: set_cmd( &cmd, aCheckKeys); break;
 	  case 509: add_keyring(pargs.r.ret_str); nrings++; break;
 	  case 510: opt.debug |= pargs.r.ret_ulong; break;
 	  case 511: opt.debug = ~0; break;
 	  case 512: set_status_fd( pargs.r.ret_int ); break;
-	  case 513: set_cmd( &cmd, aPrimegen); break;
-	  case 514: set_cmd( &cmd, aTest); break;
 	  case 515: opt.fingerprint = 1; break;
-	  case 516: set_cmd( &cmd, aPrintMDs); break;
 	  case 517: add_secret_keyring(pargs.r.ret_str); sec_nrings++; break;
 	  case 518:
-	    /* config files may not be nested (silently ignore them) */
+	     
 	    if( !configfp ) {
 		m_free(configname);
 		configname = m_strdup(pargs.r.ret_str);
@@ -349,67 +6283,53 @@
 	  case 520: default_keyring = 0; break;
 	  case 521: set_cmd( &cmd, aListPackets); break;
 	  case 522: greeting = 0; break;
-	  case 523: set_passphrase_fd( pargs.r.ret_int ); break;
 	  case 526: opt.verbose = 0; opt.list_sigs=0; break;
-	  case 527:
-	    opt.def_cipher_algo = string_to_cipher_algo(pargs.r.ret_str);
-	    break;
-	  case 528:
-	    opt.def_pubkey_algo = string_to_pubkey_algo(pargs.r.ret_str);
-	    break;
-	  case 529:
-	    opt.def_digest_algo = string_to_digest_algo(pargs.r.ret_str);
-	    break;
-	  case 531: set_cmd( &cmd, aListTrustDB); break;
+	  case 530: set_cmd( &cmd, aImport); break;
 	  case 532: quick_random_gen(1); break;
-	  case 533: set_cmd( &cmd, aListTrustPath); break;
 	  case 534: opt.no_comment=1; break;
 	  case 535: opt.completes_needed = pargs.r.ret_int; break;
 	  case 536: opt.marginals_needed = pargs.r.ret_int; break;
+	  case 537: set_cmd( &cmd, aExport); break;
 	  case 538: trustdb_name = pargs.r.ret_str; break;
-	  case 540: break; /*dummy*/
-	  case 543: break; /* no-options */
+	  case 541: set_cmd( &cmd, aNOP); break;
+	  case 543: break;  
 	  case 544: opt.homedir = pargs.r.ret_str; break;
 	  case 545: opt.batch = 0; break;
-	  case 546: set_cmd( &cmd, aDeArmor); break;
-	  case 547: set_cmd( &cmd, aEnArmor); break;
+	  case 549: opt.with_colons=':'; break;
+	  case 551: set_cmd( &cmd, aListKeys); break;
+	  case 552: set_cmd( &cmd, aListSigs); break;
 	  default : errors++; pargs.err = configfp? 1:2; break;
 	}
     }
     if( configfp ) {
 	fclose( configfp );
-	configfp = NULL;
-	m_free(configname); configname = NULL;
+	configfp = ((void *)0) ;
+	m_free(configname); configname = ((void *)0) ;
 	goto next_pass;
     }
-    m_free( configname ); configname = NULL;
-    if( !opt.def_cipher_algo || check_cipher_algo(opt.def_cipher_algo) ) {
-	log_error(_("selected cipher algorithm is invalid\n"));
-	errors++;
-    }
-    if( !opt.def_pubkey_algo || check_pubkey_algo(opt.def_pubkey_algo) ) {
-	log_error(_("selected pubkey algorithm is invalid\n"));
-	errors++;
-    }
-    if( !opt.def_digest_algo || check_digest_algo(opt.def_digest_algo) ) {
-	log_error(_("selected digest algorithm is invalid\n"));
-	errors++;
-    }
-    if( opt.completes_needed < 1 ) {
-	log_error(_("completes-needed must be greater than 0\n"));
-	errors++;
-    }
-    if( opt.marginals_needed < 2 ) {
-	log_error(_("marginals-needed must be greater than 1\n"));
-	errors++;
-    }
-    if( errors )
+    m_free( configname ); configname = ((void *)0) ;
+    check_opts();
+    if( log_get_errorcount(0) )
 	g10_exit(2);
 
-    write_status( STATUS_ENTER );
+    if( greeting ) {
+	tty_printf("%s %s; %s\n", strusage(11), strusage(13), strusage(14) );
+	tty_printf("%s\n", strusage(15) );
+    }
+
+  
+
+
+
+
+
+     
 
     set_debug();
-    if( cmd == aKMode || cmd == aKModeC ) { /* kludge to be compatible to pgp */
+    if( !cmd && opt.fingerprint )
+	set_cmd( &cmd, aListKeys);
+
+    if( cmd == aKMode || cmd == aKModeC ) {  
 	if( cmd == aKModeC ) {
 	    opt.fingerprint = 1;
 	    cmd = aKMode;
@@ -422,130 +6342,194 @@
 
 	opt.verbose = opt.verbose > 1;
     }
+
+
+     
+    if( opt.textmode && !detached_sig && opt.armor && cmd == aSign )
+	cmd = aClearsign;
+
     if( opt.verbose > 1 )
 	set_packet_list_mode(1);
-    if( greeting ) {
-	tty_printf("%s %s; %s\n", strusage(11), strusage(13), strusage(14) );
-	tty_printf("%s", strusage(15) );
-    }
 
-    if( cmd != aDeArmor && cmd != aEnArmor ) {
-	if( !sec_nrings || default_keyring ) { /* add default secret rings */
-	    char *p = make_filename(opt.homedir, "secring.gpg", NULL );
-	    add_secret_keyring(p);
-	    m_free(p);
-	}
-	if( !nrings || default_keyring ) { /* add default ring */
-	    char *p = make_filename(opt.homedir, "pubring.gpg", NULL );
-	    add_keyring(p);
-	    m_free(p);
-	}
-    }
+     
 
-    if( argc ) {
-	fname_print = fname = *argv;
+    if( cmd != aDeArmor && cmd != aEnArmor
+	&& !(cmd == aKMode && argc == 2 ) ) {
+	if( !sec_nrings || default_keyring )   
+	    add_secret_keyring("secring.gpg");
+	if( !nrings || default_keyring )   
+	    add_keyring("pubring.gpg");
     }
+
+    if( argc )
+	fname = *argv;
     else {
-	fname_print = "[stdin]";
-	fname = NULL;
+	fname = ((void *)0) ;
 	if( get_passphrase_fd() == 0 ) {
-	    /* reading data and passphrase form stdin:
-	     * we assume the first line is the passphrase, so
-	     * we read it now
-	     */
-	    /* FIXME: doit */
+	     
+
+
+
+	     
 	}
     }
 
     switch( cmd ) {
       case aPrimegen:
       case aPrintMDs:
+      case aGenRandom:
       case aDeArmor:
       case aEnArmor:
 	break;
+      case aKMode:
+      case aListKeys:
+      case aCheckKeys:
+	break;
       case aListTrustDB: rc = init_trustdb( argc? 1:0, trustdb_name ); break;
       default: rc = init_trustdb(1, trustdb_name ); break;
     }
     if( rc )
-	log_error(_("failed to initialize the TrustDB: %s\n"), g10_errstr(rc));
+	log_error(( "failed to initialize the TrustDB: %s\n" ) , g10_errstr(rc));
 
 
     switch( cmd ) {
-      case aKMode: /* list keyring */
-	if( !argc ) { /* list the default public keyrings */
-	    int i, seq=0;
-	    const char *s;
-
-	    while( (s=get_keyring(seq++)) ) {
-		if( !(a = iobuf_open(s)) ) {
-		    log_error(_("can't open '%s'\n"), s);
-		    continue;
-		}
-		if( seq > 1 )
-		    putchar('\n');
-		printf("%s\n", s );
-		for(i=strlen(s); i; i-- )
-		    putchar('-');
-		putchar('\n');
+      case aStore:  
+	if( argc > 1 )
+	    wrong_args(( "--store [filename]" ) );
+	if( (rc = encode_store(fname)) )
+	    log_error("%s: store failed: %s\n",
+				 print_fname_stdin(fname), g10_errstr(rc) );
+	break;
+    
+# 771 "g10.c"
+
+
+      case aCheckKeys:
+	opt.check_sigs = 1;
+      case aListSigs:
+	opt.list_sigs = 1;
+      case aListKeys:
+	std_key_list( argc, argv );
+	break;
 
-		proc_packets( a );
-		iobuf_close(a);
+      case aKMode:  
+	if( argc < 2 )	 
+	    std_key_list( (argc && **argv)? 1:0, argv );
+	else if( argc == 2 ) {  
+	    if( access( argv[1], 4  ) ) {
+		log_error(( "can't open %s: %s\n" ) ,
+			       print_fname_stdin(argv[1]), strerror(errno));
 	    }
+	    else {
+		 
 
-	}
-	else if( argc == 1) { /* list the given keyring */
-	    if( !(a = iobuf_open(fname)) )
-		log_fatal(_("can't open '%s'\n"), fname_print);
-	    proc_packets( a );
-	    iobuf_close(a);
+		add_keyring( argv[1] );
+		std_key_list( **argv?1:0, argv );
+	    }
 	}
 	else
-	    usage(1);
+	    wrong_args(( "-k[v][v][v][c] [userid] [keyring]" )  );
+	break;
+
+    
+
+
+
+
+
+
+
+      case aImport:
+	if( !argc  ) {
+	    rc = import_pubkeys( ((void *)0)  );
+	    if( rc )
+		log_error("import failed: %s\n", g10_errstr(rc) );
+	}
+	for( ; argc; argc--, argv++ ) {
+	    rc = import_pubkeys( *argv );
+	    if( rc )
+		log_error("import from '%s' failed: %s\n",
+						*argv, g10_errstr(rc) );
+	}
+	break;
+
+      case aExport:
+	sl = ((void *)0) ;
+	for( ; argc; argc--, argv++ )
+	    add_to_strlist( &sl, *argv );
+	export_pubkeys( sl );
+	free_strlist(sl);
 	break;
 
+    
+
+
+
+
+
+
+
+    
       case aDeArmor:
 	if( argc > 1 )
 	    wrong_args("--dearmor [file]");
-	rc = dearmor_file( argc? *argv: NULL );
+	rc = dearmor_file( argc? *argv: ((void *)0)  );
 	if( rc )
-	    log_error(_("dearmoring failed: %s\n"), g10_errstr(rc));
+	    log_error(( "dearmoring failed: %s\n" ) , g10_errstr(rc));
 	break;
 
       case aEnArmor:
 	if( argc > 1 )
 	    wrong_args("--enarmor [file]");
-	rc = enarmor_file( argc? *argv: NULL );
+	rc = enarmor_file( argc? *argv: ((void *)0)  );
 	if( rc )
-	    log_error(_("enarmoring failed: %s\n"), g10_errstr(rc));
+	    log_error(( "enarmoring failed: %s\n" ) , g10_errstr(rc));
 	break;
 
 
       case aPrimegen:
 	if( argc == 1 ) {
-	    mpi_print( stdout, generate_public_prime( atoi(argv[0]) ), 1);
-	    putchar('\n');
+	    mpi_print( ((_IO_FILE*)(&_IO_stdout_))  , generate_public_prime( atoi(argv[0]) ), 1);
+	    (((    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr >= (    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_end) ? __overflow(    ((_IO_FILE*)(&_IO_stdout_))    , (unsigned char)(   '\n'   )) : (unsigned char)(*(    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr++ = (   '\n'   )))   ;
 	}
 	else if( argc == 2 ) {
-	    mpi_print( stdout, generate_elg_prime( atoi(argv[0]),
-						   atoi(argv[1]), NULL,NULL ), 1);
-	    putchar('\n');
+	    mpi_print( ((_IO_FILE*)(&_IO_stdout_))  , generate_elg_prime( atoi(argv[0]),
+						   atoi(argv[1]), ((void *)0) ,((void *)0)  ), 1);
+	    (((    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr >= (    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_end) ? __overflow(    ((_IO_FILE*)(&_IO_stdout_))    , (unsigned char)(   '\n'   )) : (unsigned char)(*(    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr++ = (   '\n'   )))   ;
 	}
 	else if( argc == 3 ) {
 	    MPI g = mpi_alloc(1);
-	    mpi_print( stdout, generate_elg_prime( atoi(argv[0]),
-						   atoi(argv[1]), g, NULL ), 1);
+	    mpi_print( ((_IO_FILE*)(&_IO_stdout_))  , generate_elg_prime( atoi(argv[0]),
+						   atoi(argv[1]), g, ((void *)0)  ), 1);
 	    printf("\nGenerator: ");
-	    mpi_print( stdout, g, 1 );
-	    putchar('\n');
+	    mpi_print( ((_IO_FILE*)(&_IO_stdout_))  , g, 1 );
+	    (((    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr >= (    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_end) ? __overflow(    ((_IO_FILE*)(&_IO_stdout_))    , (unsigned char)(   '\n'   )) : (unsigned char)(*(    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr++ = (   '\n'   )))   ;
 	    mpi_free(g);
 	}
 	else
 	    usage(1);
 	break;
 
+      case aGenRandom:
+	if( argc < 1 || argc > 2 )
+	    wrong_args("--gen-random level [hex]");
+	{
+	    int level = atoi(*argv);
+	    for(;;) {
+		int c = get_random_byte(level);
+		if( argc == 1 ) {
+		    printf("%02x", c );
+		    fflush(((_IO_FILE*)(&_IO_stdout_))  );
+		}
+		else
+		    (((    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr >= (    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_end) ? __overflow(    ((_IO_FILE*)(&_IO_stdout_))    , (unsigned char)(   c&0xff   )) : (unsigned char)(*(    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr++ = (   c&0xff   )))   ;
+	    }
+	}
+	break;
+
       case aPrintMDs:
 	if( !argc )
-	    print_mds(NULL);
+	    print_mds(((void *)0) );
 	else {
 	    for(; argc; argc--, argv++ )
 		print_mds(*argv);
@@ -556,7 +6540,7 @@
 
       case aListTrustDB:
 	if( !argc )
-	    list_trustdb(NULL);
+	    list_trustdb(((void *)0) );
 	else {
 	    for( ; argc; argc--, argv++ )
 		list_trustdb( *argv );
@@ -569,30 +6553,40 @@
 	list_trust_path( atoi(*argv), argv[1] );
 	break;
 
+     
+
+
+      case aNOP:
+	break;
+
       case aListPackets:
 	opt.list_packets=1;
-      default:	/* do regular maintenace tasks */
+      default:
+	 
 	if( argc > 1 )
-	    usage(1);
+	    wrong_args(( "[filename]" ) );
 	if( !(a = iobuf_open(fname)) )
-	    log_fatal(_("can't open '%s'\n"), fname_print);
-	if( !opt.no_armor ) {
-	    /* push the armor filter, so it can peek at the input data */
-	    memset( &afx, 0, sizeof afx);
-	    iobuf_push_filter( a, armor_filter, &afx );
-	}
-	if( cmd == aListPackets ) {
-	    set_packet_list_mode(1);
-	    opt.list_packets=1;
+	    log_error(( "can't open '%s'\n" ) , print_fname_stdin(fname));
+	else {
+	    if( !opt.no_armor ) {
+		if( use_armor_filter( a ) ) {
+		    memset( &afx, 0, sizeof afx);
+		    iobuf_push_filter( a, armor_filter, &afx );
+		}
+	    }
+	    if( cmd == aListPackets ) {
+		set_packet_list_mode(1);
+		opt.list_packets=1;
+	    }
+	    proc_packets( a );
+	    iobuf_close(a);
 	}
-	proc_packets( a );
-	iobuf_close(a);
 	break;
     }
 
-    /* cleanup */
-    FREE_STRLIST(remusr);
-    FREE_STRLIST(locusr);
+     
+    do { free_strlist(( remusr )); ( remusr ) = ((void *)0)  ; } while(0) ;
+    do { free_strlist(( locusr )); ( locusr ) = ((void *)0)  ; } while(0) ;
     g10_exit(0);
 }
 
@@ -600,11 +6594,11 @@
 void
 g10_exit( int rc )
 {
-    if( opt.verbose )
+    if( opt.debug )
 	secmem_dump_stats();
     secmem_term();
     rc = rc? rc : log_get_errorcount(0)? 2:0;
-    write_status( STATUS_LEAVE );
+     
     exit(rc );
 }
 
@@ -617,14 +6611,14 @@
     if( n == 20 ) {
 	for(i=0; i < n ; i++, i++, p += 2 ) {
 	    if( i == 10 )
-		putchar(' ');
+		(((    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr >= (    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_end) ? __overflow(    ((_IO_FILE*)(&_IO_stdout_))    , (unsigned char)(   ' '   )) : (unsigned char)(*(    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr++ = (   ' '   )))   ;
 	    printf(" %02X%02X", *p, p[1] );
 	}
     }
     else {
 	for(i=0; i < n ; i++, p++ ) {
 	    if( i && !(i%8) )
-		putchar(' ');
+		(((    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr >= (    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_end) ? __overflow(    ((_IO_FILE*)(&_IO_stdout_))    , (unsigned char)(   ' '   )) : (unsigned char)(*(    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr++ = (   ' '   )))   ;
 	    printf(" %02X", *p );
 	}
     }
@@ -639,7 +6633,7 @@
     MD_HANDLE md;
 
     if( !fname ) {
-	fp = stdin;
+	fp = ((_IO_FILE*)(&_IO_stdin_))  ;
 	fname = "[stdin]";
     }
     else
@@ -649,26 +6643,26 @@
 	return;
     }
 
-    md = md_open( DIGEST_ALGO_MD5, 0 );
-    md_enable( md, DIGEST_ALGO_RMD160 );
-    md_enable( md, DIGEST_ALGO_SHA1 );
+    md = md_open( 1 , 0 );
+    md_enable( md, 3  );
+    md_enable( md, 2  );
 
-    while( (n=fread( buf, 1, DIM(buf), fp )) )
+    while( (n=fread( buf, 1, (sizeof( buf )/sizeof(( buf )[0])) , fp )) )
 	md_write( md, buf, n );
     if( ferror(fp) )
 	log_error("%s: %s\n", fname, strerror(errno) );
     else {
 	md_final(md);
-	printf(  "%s:    MD5 =", fname ); print_hex(md_read(md, DIGEST_ALGO_MD5), 16 );
-	printf("\n%s: RMD160 =", fname ); print_hex(md_read(md, DIGEST_ALGO_RMD160), 20 );
-	printf("\n%s:   SHA1 =", fname ); print_hex(md_read(md, DIGEST_ALGO_SHA1), 20 );
-	putchar('\n');
+	printf(  "%s:    MD5 =", fname ); print_hex(md_read(md, 1 ), 16 );
+	printf("\n%s: RMD160 =", fname ); print_hex(md_read(md, 3 ), 20 );
+	printf("\n%s:   SHA1 =", fname ); print_hex(md_read(md, 2 ), 20 );
+	(((    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr >= (    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_end) ? __overflow(    ((_IO_FILE*)(&_IO_stdout_))    , (unsigned char)(   '\n'   )) : (unsigned char)(*(    ((_IO_FILE*)(&_IO_stdout_))    )->_IO_write_ptr++ = (   '\n'   )))   ;
     }
 
 
     md_close(md);
 
-    if( fp != stdin )
+    if( fp != ((_IO_FILE*)(&_IO_stdin_))   )
 	fclose(fp);
 }
 
@@ -693,12 +6687,12 @@
     mpi_fromstr( base[1], "0x000effff9999000000001100001" );
     base[2] = mpi_alloc_set_ui( 2 );
     mpi_fromstr( base[2], "0x499eeeaaaaa0444444545466672" );
-    base[3] = NULL;
+    base[3] = ((void *)0) ;
     exp[0]  = mpi_alloc_set_ui( 30 );
     exp[1]  = mpi_alloc_set_ui( 10 );
     mpi_fromstr( exp[1], "0x3457878888888888aabbbccccc1" );
     exp[2]  = mpi_alloc_set_ui( 24 );
-    exp[3] = NULL;
+    exp[3] = ((void *)0) ;
 
     mpi_powm( t1, base[0], exp[0], m );
     mpi_powm( t2, base[1], exp[1], m );
@@ -712,6 +6706,7 @@
     log_mpidump("X=", res );
 
 
-    m_check(NULL);
+    m_check(((void *)0) );
 }
+
 
diff -urN gnupg-0.2.11/g10/getkey.c gnupg-0.2.12/g10/getkey.c
--- gnupg-0.2.11/g10/getkey.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.12/g10/getkey.c	Wed Mar  4 17:21:29 1998
@@ -323,6 +323,8 @@
 	int i;
 	char buf[9];
 
+	if( *s == '0' && s[1] == 'x' && isxdigit(s[2]) )
+	    s += 2; /*kludge to allow 0x034343434 */
 	for(i=0; isxdigit(s[i]); i++ )
 	    ;
 	if( s[i] && !isspace(s[i]) ) /* not terminated by EOS or blank*/
@@ -417,6 +419,33 @@
   leave:
     return rc;
 }
+
+/****************
+ * Check wether the secret key is available
+ * Returns: 0 := key is available
+ *	    G10ERR_NO_SECKEY := not availabe
+ */
+int
+seckey_available( u32 *keyid )
+{
+    PKT_secret_cert *skc;
+    STRLIST sl;
+    int rc=0;
+
+    skc = m_alloc_clear( sizeof *skc );
+    for(sl = secret_keyrings; sl; sl = sl->next )
+	if( !(rc=scan_secret_keyring( skc, keyid, NULL, sl->d )) )
+	    goto found;
+    /* fixme: look at other places */
+    goto leave;
+
+  found:
+  leave:
+    free_secret_cert( skc );
+    return rc;
+}
+
+
 
 /****************
  * Get a secret key by name and store it into skc
diff -urN gnupg-0.2.11/g10/import.c gnupg-0.2.12/g10/import.c
--- gnupg-0.2.11/g10/import.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.12/g10/import.c	Sat Mar  7 11:56:51 1998
@@ -259,7 +259,7 @@
 		  (ulong)keyid[1], datestr_from_pkc(pkc) );
 	if( uidnode )
 	    print_string( stderr, uidnode->pkt->pkt.user_id->name,
-				  uidnode->pkt->pkt.user_id->len );
+				  uidnode->pkt->pkt.user_id->len, 0 );
 	putc('\n', stderr);
     }
     if( !uidnode ) {
@@ -532,7 +532,7 @@
 		    log_info("%s: key %08lX, removed userid '",
 						  fname, (ulong)keyid[1]);
 		    print_string( stderr, node->pkt->pkt.user_id->name,
-				      node->pkt->pkt.user_id->len );
+				      node->pkt->pkt.user_id->len, 0 );
 		    fputs("'\n", stderr );
 		}
 		delete_kbnode( node ); /* the user-id */
diff -urN gnupg-0.2.11/g10/kbnode.c gnupg-0.2.12/g10/kbnode.c
--- gnupg-0.2.11/g10/kbnode.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.12/g10/kbnode.c	Sat Mar  7 11:57:07 1998
@@ -48,8 +48,8 @@
     KBNODE n = m_alloc( sizeof *n );
     n->next = NULL;
     n->pkt = node->pkt;
-    n->private_flag |= 2; /* mark cloned */
     n->flag = 0;
+    n->private_flag = node->private_flag | 2; /* mark cloned */
     return n;
 }
 
@@ -268,7 +268,7 @@
 	if( node->pkt->pkttype == PKT_USER_ID ) {
 	    fputs("  \"", stderr);
 	    print_string( stderr, node->pkt->pkt.user_id->name,
-				  node->pkt->pkt.user_id->len );
+				  node->pkt->pkt.user_id->len, 0 );
 	    fputs("\"\n", stderr);
 	}
 	else if( node->pkt->pkttype == PKT_SIGNATURE ) {
diff -urN gnupg-0.2.11/g10/keydb.h gnupg-0.2.12/g10/keydb.h
--- gnupg-0.2.11/g10/keydb.h	Tue Feb 24 15:06:35 1998
+++ gnupg-0.2.12/g10/keydb.h	Tue Mar  3 10:17:59 1998
@@ -107,6 +107,7 @@
 int get_pubkey( PKT_public_cert *pkc, u32 *keyid );
 int get_pubkey_byname( PKT_public_cert *pkc, const char *name );
 int get_seckey( PKT_secret_cert *skc, u32 *keyid );
+int seckey_available( u32 *keyid );
 int get_seckey_byname( PKT_secret_cert *skc, const char *name, int unlock );
 int enum_secret_keys( void **context, PKT_secret_cert *skc );
 char*get_user_id_string( u32 *keyid );
diff -urN gnupg-0.2.11/g10/keygen.c gnupg-0.2.12/g10/keygen.c
--- gnupg-0.2.11/g10/keygen.c	Wed Feb 25 08:38:19 1998
+++ gnupg-0.2.12/g10/keygen.c	Wed Mar  4 10:57:15 1998
@@ -299,8 +299,10 @@
     char *aname, *acomment, *amail;
 
 #ifndef TEST_ALGO
-    if( opt.batch || opt.answer_yes || opt.answer_no )
-	log_fatal(_("Key generation can only be used in interactive mode\n"));
+    if( opt.batch || opt.answer_yes || opt.answer_no ) {
+	log_error(_("Key generation can only be used in interactive mode\n"));
+	return;
+    }
 
     tty_printf(_("Please select the algorithm to use:\n"
 		 "   (1) ElGamal is the suggested one.\n"
diff -urN gnupg-0.2.11/g10/keylist.c gnupg-0.2.12/g10/keylist.c
--- gnupg-0.2.11/g10/keylist.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.12/g10/keylist.c	Sat Mar  7 12:25:31 1998
@@ -0,0 +1,262 @@
+/* keylist.c
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <assert.h>
+
+#include "options.h"
+#include "packet.h"
+#include "errors.h"
+#include "keydb.h"
+#include "memory.h"
+#include "util.h"
+#include "trustdb.h"
+#include "main.h"
+#include "i18n.h"
+
+static void list_all(void);
+static void list_one(const char *name);
+static void fingerprint( PKT_public_cert *pkc );
+
+
+/****************
+ * List the keys
+ * If NNAMES is 0; all available keys are listed
+ */
+void
+std_key_list( int nnames, char **names )
+{
+    if( !nnames )
+	list_all();
+    else { /* List by user id */
+	for( ; nnames ; nnames--, names++ )
+	    list_one( *names );
+    }
+}
+
+
+static void
+list_all()
+{
+    int i, seq=0;
+    const char *s;
+    IOBUF a;
+
+    while( (s=get_keyring(seq++)) ) {
+	if( !(a = iobuf_open(s)) ) {
+	    log_error(_("can't open %s: %s\n"), s, strerror(errno));
+	    continue;
+	}
+	if( seq > 1 )
+	    putchar('\n');
+	printf("%s\n", s );
+	for(i=strlen(s); i; i-- )
+	    putchar('-');
+	putchar('\n');
+
+	proc_packets( a );
+	iobuf_close(a);
+    }
+}
+
+
+static void
+list_one( const char *name )
+{
+    int rc = 0;
+    KBNODE keyblock = NULL;
+    KBNODE kbctx;
+    KBNODE node;
+    KBPOS kbpos;
+    PKT_public_cert *pkc;
+    u32 keyid[2];
+    int any=0;
+
+    /* search the userid */
+    rc = find_keyblock_byname( &kbpos, name );
+    if( rc ) {
+	log_error("%s: user not found\n", name );
+	goto leave;
+    }
+
+    /* read the keyblock */
+    rc = read_keyblock( &kbpos, &keyblock );
+    if( rc ) {
+	log_error("%s: keyblock read problem: %s\n", name, g10_errstr(rc) );
+	goto leave;
+    }
+
+    /* get the keyid from the keyblock */
+    node = find_kbnode( keyblock, PKT_PUBLIC_CERT );
+    if( !node ) {
+	log_error("Oops; public key not found anymore!\n");
+	goto leave;
+    }
+
+    pkc = node->pkt->pkt.public_cert;
+    keyid_from_pkc( pkc, keyid );
+    if( opt.with_colons )
+	printf("pub::%u:%d:%08lX%08lX:%s:::",
+		/* fixme: add trust value here */
+		nbits_from_pkc( pkc ),
+		pkc->pubkey_algo,
+		(ulong)keyid[0],(ulong)keyid[1],
+		datestr_from_pkc( pkc )
+		/* fixme: add LID and ownertrust here */
+					);
+    else
+	printf("pub  %4u%c/%08lX %s ", nbits_from_pkc( pkc ),
+				   pubkey_letter( pkc->pubkey_algo ),
+				   (ulong)keyid[1],
+				   datestr_from_pkc( pkc ) );
+
+    for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 0)) ; ) {
+	if( node->pkt->pkttype == PKT_USER_ID ) {
+	    if( any ) {
+		if( opt.with_colons )
+		    printf("uid::::::::");
+		else
+		    printf("uid%*s", 28, "");
+	    }
+	    print_string( stdout,  node->pkt->pkt.user_id->name,
+			  node->pkt->pkt.user_id->len, opt.with_colons );
+	    if( opt.with_colons )
+		putchar(':');
+	    putchar('\n');
+	    if( !any ) {
+		if( opt.fingerprint )
+		    fingerprint( pkc );
+		any = 1;
+	    }
+	}
+	else if( opt.list_sigs && node->pkt->pkttype == PKT_SIGNATURE ) {
+	    PKT_signature *sig = node->pkt->pkt.signature;
+	    int sigrc;
+
+	    if( !any ) { /* no user id, (maybe a revocation follows)*/
+		if( sig->sig_class == 0x20 )
+		    puts("[revoked]");
+		else
+		    putchar('\n');
+		if( opt.fingerprint )
+		    fingerprint( pkc );
+		any=1;
+	    }
+
+	    if( sig->sig_class == 0x20 || sig->sig_class == 0x30 )
+		fputs("rev", stdout);
+	    else if( (sig->sig_class&~3) == 0x10 )
+		fputs("sig", stdout);
+	    else {
+		if( opt.with_colons )
+		    printf("sig:::::::::%02x:\n",sig->sig_class );
+		else
+		    printf("sig                              "
+		       "[unexpected signature class 0x%02x]\n",sig->sig_class );
+		continue;
+	    }
+	    if( opt.check_sigs ) {
+		fflush(stdout);
+		rc = check_key_signature( keyblock, node, NULL );
+		switch( rc ) {
+		  case 0:		   sigrc = '!'; break;
+		  case G10ERR_BAD_SIGN:    sigrc = '-'; break;
+		  case G10ERR_NO_PUBKEY:   sigrc = '?'; break;
+		  default:		   sigrc = '%'; break;
+		}
+	    }
+	    else {
+		rc = 0;
+		sigrc = ' ';
+	    }
+	    if( opt.with_colons ) {
+		putchar(':');
+		if( sigrc != ' ' )
+		    putchar(sigrc);
+		printf(":::%08lX%08lX:%s:::", (ulong)sig->keyid[0],
+			   (ulong)sig->keyid[1], datestr_from_sig(sig));
+	    }
+	    else
+		printf("%c       %08lX %s  ",
+		    sigrc, (ulong)sig->keyid[1], datestr_from_sig(sig));
+	    if( sigrc == '%' )
+		printf("[%s] ", g10_errstr(rc) );
+	    else if( sigrc == '?' )
+		;
+	    else {
+		size_t n;
+		char *p = get_user_id( sig->keyid, &n );
+		print_string( stdout, p, n, opt.with_colons );
+		m_free(p);
+	    }
+	    if( opt.with_colons )
+		printf(":%02x:", sig->sig_class );
+	    putchar('\n');
+	}
+    }
+    if( !any ) {/* oops, no user id */
+	if( opt.with_colons )
+	    putchar(':');
+	putchar('\n');
+    }
+
+
+  leave:
+    release_kbnode( keyblock );
+}
+
+static void
+fingerprint( PKT_public_cert *pkc )
+{
+    byte *array, *p;
+    size_t i, n;
+
+    p = array = fingerprint_from_pkc( pkc, &n );
+    if( opt.with_colons ) {
+	printf("fpr::::::::");
+	for(i=0; i < n ; i++, p++ )
+	    printf("%02X", *p );
+	putchar(':');
+    }
+    else {
+	printf("     Key fingerprint =");
+	if( n == 20 ) {
+	    for(i=0; i < n ; i++, i++, p += 2 ) {
+		if( i == 10 )
+		    putchar(' ');
+		printf(" %02X%02X", *p, p[1] );
+	    }
+	}
+	else {
+	    for(i=0; i < n ; i++, p++ ) {
+		if( i && !(i%8) )
+		    putchar(' ');
+		printf(" %02X", *p );
+	    }
+	}
+    }
+    putchar('\n');
+    m_free(array);
+}
+
diff -urN gnupg-0.2.11/g10/main.h gnupg-0.2.12/g10/main.h
--- gnupg-0.2.11/g10/main.h	Mon Mar  2 14:25:32 1998
+++ gnupg-0.2.12/g10/main.h	Sat Mar  7 11:44:04 1998
@@ -53,7 +53,7 @@
 int clearsign_file( const char *fname, STRLIST locusr, const char *outfile );
 int sign_key( const char *username, STRLIST locusr );
 int edit_keysigs( const char *username );
-int delete_key( const char *username );
+int delete_key( const char *username, int secure );
 int change_passphrase( const char *username );
 
 /*-- sig-check.c --*/
@@ -96,5 +96,17 @@
 
 /*-- revoke.c --*/
 int gen_revoke( const char *uname );
+
+/*-- keylist.c --*/
+void std_key_list( int nnames, char **names );
+
+/*-- verify.c --*/
+int verify_signatures( int nfiles, char **files );
+
+/*-- decrypt.c --*/
+int decrypt_message( const char *filename );
+
+/*-- plaintext.c --*/
+int hash_datafiles( MD_HANDLE md, STRLIST files, int textmode );
 
 #endif /*G10_MAIN_H*/
diff -urN gnupg-0.2.11/g10/mainproc.c gnupg-0.2.12/g10/mainproc.c
--- gnupg-0.2.11/g10/mainproc.c	Fri Feb 27 16:46:58 1998
+++ gnupg-0.2.12/g10/mainproc.c	Sat Mar  7 12:51:25 1998
@@ -45,6 +45,9 @@
     PKT_secret_cert *last_seckey;
     PKT_user_id     *last_user_id;
     md_filter_context_t mfx;
+    int sigs_only;   /* process only signatures and reject all other stuff */
+    int encrypt_only; /* process onyl encrytion messages */
+    STRLIST signed_data;
     DEK *dek;
     int last_was_pubkey_enc;
     KBNODE list;   /* the current list of packets */
@@ -53,6 +56,7 @@
 } *CTX;
 
 
+static int do_proc_packets( CTX c, IOBUF a );
 
 static void list_node( CTX c, KBNODE node );
 static void proc_tree( CTX c, KBNODE node );
@@ -234,6 +238,18 @@
 }
 
 
+static int
+proc_compressed_cb( IOBUF a, void *info )
+{
+    return proc_signature_packets( a, ((CTX)info)->signed_data );
+}
+
+static int
+proc_encrypt_cb( IOBUF a, void *info )
+{
+    return proc_encryption_packets( a );
+}
+
 static void
 proc_compressed( CTX c, PACKET *pkt )
 {
@@ -241,7 +257,12 @@
     int rc;
 
     /*printf("zip: compressed data packet\n");*/
-    rc = handle_compressed( zd );
+    if( c->sigs_only )
+	rc = handle_compressed( zd, proc_compressed_cb, c );
+    else if( c->encrypt_only )
+	rc = handle_compressed( zd, proc_encrypt_cb, c );
+    else
+	rc = handle_compressed( zd, NULL, NULL );
     if( rc )
 	log_error("uncompressing failed: %s\n", g10_errstr(rc));
     free_packet(pkt);
@@ -337,7 +358,8 @@
 	printf("ERROR: unexpected packet type %d", pkt->pkttype );
 	return;
     }
-    print_string( stdout,  pkt->pkt.user_id->name, pkt->pkt.user_id->len );
+    print_string( stdout,  pkt->pkt.user_id->name, pkt->pkt.user_id->len,
+							opt.with_colons );
 }
 
 
@@ -349,19 +371,27 @@
 
     p = array = skc? fingerprint_from_skc( skc, &n )
 		   : fingerprint_from_pkc( pkc, &n );
-    printf("     Key fingerprint =");
-    if( n == 20 ) {
-	for(i=0; i < n ; i++, i++, p += 2 ) {
-	    if( i == 10 )
-		putchar(' ');
-	    printf(" %02X%02X", *p, p[1] );
-	}
+    if( opt.with_colons ) {
+	printf("fpr::::::::");
+	for(i=0; i < n ; i++, p++ )
+	    printf("%02X", *p );
+	putchar(':');
     }
     else {
-	for(i=0; i < n ; i++, p++ ) {
-	    if( i && !(i%8) )
-		putchar(' ');
-	    printf(" %02X", *p );
+	printf("     Key fingerprint =");
+	if( n == 20 ) {
+	    for(i=0; i < n ; i++, i++, p += 2 ) {
+		if( i == 10 )
+		    putchar(' ');
+		printf(" %02X%02X", *p, p[1] );
+	    }
+	}
+	else {
+	    for(i=0; i < n ; i++, p++ ) {
+		if( i && !(i%8) )
+		    putchar(' ');
+		printf(" %02X", *p );
+	    }
 	}
     }
     putchar('\n');
@@ -383,24 +413,47 @@
     else if( node->pkt->pkttype == PKT_PUBLIC_CERT ) {
 	PKT_public_cert *pkc = node->pkt->pkt.public_cert;
 
-	printf("pub  %4u%c/%08lX %s ", nbits_from_pkc( pkc ),
+	if( opt.with_colons ) {
+	    u32 keyid[2];
+	    keyid_from_pkc( pkc, keyid );
+	    printf("pub::%u:%d:%08lX%08lX:%s:::",
+		    /* fixme: add trust value here */
+		    nbits_from_pkc( pkc ),
+		    pkc->pubkey_algo,
+		    (ulong)keyid[0],(ulong)keyid[1],
+		    datestr_from_pkc( pkc )
+		    /* fixme: add LID and ownertrust here */
+					    );
+	}
+	else
+	    printf("pub  %4u%c/%08lX %s ", nbits_from_pkc( pkc ),
 				      pubkey_letter( pkc->pubkey_algo ),
 				      (ulong)keyid_from_pkc( pkc, NULL ),
 				      datestr_from_pkc( pkc )	  );
 	/* and now list all userids with their signatures */
 	for( node = node->next; node; node = node->next ) {
 	    if( any != 2 && node->pkt->pkttype == PKT_SIGNATURE ) {
-		if( !any )
-		    putchar('\n');
+		if( !any ) {
+		    if( node->pkt->pkt.signature->sig_class == 0x20 )
+			puts("[revoked]");
+		    else
+			putchar('\n');
+		}
 		list_node(c,  node );
 		any = 1;
 	    }
 	    else if( node->pkt->pkttype == PKT_USER_ID ) {
 		KBNODE n;
 
-		if( any )
-		    printf( "%*s", 31, "" );
+		if( any ) {
+		    if( opt.with_colons )
+			printf("uid::::::::");
+		    else
+			printf( "uid%*s", 28, "" );
+		}
 		print_userid( node->pkt );
+		if( opt.with_colons )
+		    putchar(':');
 		putchar('\n');
 		if( opt.fingerprint && !any )
 		    print_fingerprint( pkc, NULL );
@@ -457,17 +510,27 @@
 	      default:		       sigrc = '%'; break;
 	    }
 	}
-	printf("%c       %08lX %s   ",
-		sigrc, (ulong)sig->keyid[1], datestr_from_sig(sig));
+	if( opt.with_colons ) {
+	    putchar(':');
+	    if( sigrc != ' ' )
+		putchar(sigrc);
+	    printf(":::%08lX%08lX:%s:::", (ulong)sig->keyid[0],
+		       (ulong)sig->keyid[1], datestr_from_sig(sig));
+	}
+	else
+	    printf("%c       %08lX %s   ",
+		    sigrc, (ulong)sig->keyid[1], datestr_from_sig(sig));
 	if( sigrc == '%' )
 	    printf("[%s] ", g10_errstr(rc2) );
 	else if( sigrc == '?' )
 	    ;
 	else {
 	    p = get_user_id( sig->keyid, &n );
-	    print_string( stdout, p, n );
+	    print_string( stdout, p, n, opt.with_colons );
 	    m_free(p);
 	}
+	if( opt.with_colons )
+	    printf(":%02x:", sig->sig_class );
 	putchar('\n');
     }
     else
@@ -479,8 +542,40 @@
 proc_packets( IOBUF a )
 {
     CTX c = m_alloc_clear( sizeof *c );
-    PACKET *pkt = m_alloc( sizeof *pkt );
+    int rc = do_proc_packets( c, a );
+    m_free( c );
+    return rc;
+}
+
+int
+proc_signature_packets( IOBUF a, STRLIST signedfiles )
+{
+    CTX c = m_alloc_clear( sizeof *c );
+    int rc;
+    c->sigs_only = 1;
+    c->signed_data = signedfiles;
+    rc = do_proc_packets( c, a );
+    m_free( c );
+    return rc;
+}
+
+int
+proc_encryption_packets( IOBUF a )
+{
+    CTX c = m_alloc_clear( sizeof *c );
     int rc;
+    c->encrypt_only = 1;
+    rc = do_proc_packets( c, a );
+    m_free( c );
+    return rc;
+}
+
+
+int
+do_proc_packets( CTX c, IOBUF a )
+{
+    PACKET *pkt = m_alloc( sizeof *pkt );
+    int rc=0;
     int newpkt;
 
     c->iobuf = a;
@@ -507,6 +602,38 @@
 	      default: newpkt = 0; break;
 	    }
 	}
+	else if( c->sigs_only ) {
+	    switch( pkt->pkttype ) {
+	      case PKT_PUBLIC_CERT:
+	      case PKT_SECRET_CERT:
+	      case PKT_USER_ID:
+	      case PKT_PUBKEY_ENC:
+	      case PKT_ENCRYPTED:
+		rc = G10ERR_UNEXPECTED;
+		goto leave;
+	      case PKT_SIGNATURE:   newpkt = add_signature( c, pkt ); break;
+	      case PKT_PLAINTEXT:   proc_plaintext( c, pkt ); break;
+	      case PKT_COMPRESSED:  proc_compressed( c, pkt ); break;
+	      case PKT_ONEPASS_SIG: newpkt = add_onepass_sig( c, pkt ); break;
+	      default: newpkt = 0; break;
+	    }
+	}
+	else if( c->encrypt_only ) {
+	    switch( pkt->pkttype ) {
+	      case PKT_PUBLIC_CERT:
+	      case PKT_SECRET_CERT:
+	      case PKT_USER_ID:
+		rc = G10ERR_UNEXPECTED;
+		goto leave;
+	      case PKT_SIGNATURE:   newpkt = add_signature( c, pkt ); break;
+	      case PKT_PUBKEY_ENC:  proc_pubkey_enc( c, pkt ); break;
+	      case PKT_ENCRYPTED:   proc_encrypted( c, pkt ); break;
+	      case PKT_PLAINTEXT:   proc_plaintext( c, pkt ); break;
+	      case PKT_COMPRESSED:  proc_compressed( c, pkt ); break;
+	      case PKT_ONEPASS_SIG: newpkt = add_onepass_sig( c, pkt ); break;
+	      default: newpkt = 0; break;
+	    }
+	}
 	else {
 	    switch( pkt->pkttype ) {
 	      case PKT_PUBLIC_CERT: newpkt = add_public_cert( c, pkt ); break;
@@ -533,14 +660,15 @@
 	else
 	    free_packet(pkt);
     }
+    rc = 0;
 
+  leave:
     release_list( c );
     m_free(c->dek);
     free_packet( pkt );
     m_free( pkt );
     free_md_filter_context( &c->mfx );
-    m_free( c );
-    return 0;
+    return rc;
 }
 
 
@@ -549,7 +677,7 @@
 {
     size_t n;
     char *p = get_user_id( keyid, &n );
-    print_string( fp, p, n );
+    print_string( fp, p, n, opt.with_colons );
     m_free(p);
 }
 
@@ -607,12 +735,17 @@
 	    free_md_filter_context( &c->mfx );
 	    /* prepare to create all requested message digests */
 	    c->mfx.md = md_open(0, 0);
+	    /* fixme: why looking for the signature packet and not 1passpacket*/
 	    for( n1 = node; (n1 = find_next_kbnode(n1, PKT_SIGNATURE )); ) {
 		md_enable( c->mfx.md,
 			   digest_algo_from_sig(n1->pkt->pkt.signature));
 	    }
 	    /* ask for file and hash it */
-	    rc = ask_for_detached_datafile( &c->mfx,
+	    if( c->sigs_only )
+		rc = hash_datafiles( c->mfx.md, c->signed_data,
+			    n1->pkt->pkt.onepass_sig->sig_class == 0x01 );
+	    else
+		rc = ask_for_detached_datafile( &c->mfx,
 					    iobuf_get_fname(c->iobuf));
 	    if( rc ) {
 		log_error("can't hash datafile: %s\n", g10_errstr(rc));
@@ -629,7 +762,11 @@
 	if( !c->have_data ) {
 	    free_md_filter_context( &c->mfx );
 	    c->mfx.md = md_open(digest_algo_from_sig(sig), 0);
-	    rc = ask_for_detached_datafile( &c->mfx,
+	    if( c->sigs_only )
+		rc = hash_datafiles( c->mfx.md, c->signed_data,
+				     sig->sig_class == 0x01 );
+	    else
+		rc = ask_for_detached_datafile( &c->mfx,
 					    iobuf_get_fname(c->iobuf));
 	    if( rc ) {
 		log_error("can't hash datafile: %s\n", g10_errstr(rc));
diff -urN gnupg-0.2.11/g10/options.h gnupg-0.2.12/g10/options.h
--- gnupg-0.2.11/g10/options.h	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.12/g10/options.h	Fri Mar  6 11:36:22 1998
@@ -31,7 +31,7 @@
     int answer_yes; /* answer yes on most questions */
     int answer_no;  /* answer no on most questions */
     int check_sigs; /* check key signatures */
-    int reserved1;
+    int with_colons;
     int fingerprint; /* list fingerprints */
     int list_sigs;   /* list signatures */
     int no_armor;
diff -urN gnupg-0.2.11/g10/packet.h gnupg-0.2.12/g10/packet.h
--- gnupg-0.2.11/g10/packet.h	Tue Feb 24 14:10:07 1998
+++ gnupg-0.2.12/g10/packet.h	Fri Mar  6 11:36:22 1998
@@ -215,6 +215,8 @@
 
 /*-- mainproc.c --*/
 int proc_packets( IOBUF a );
+int proc_signature_packets( IOBUF a, STRLIST signedfiles );
+int proc_encryption_packets( IOBUF a );
 int list_packets( IOBUF a );
 
 /*-- parse-packet.c --*/
@@ -260,7 +262,8 @@
 int get_session_key( PKT_pubkey_enc *k, DEK *dek );
 
 /*-- compress.c --*/
-int handle_compressed( PKT_compressed *zd );
+int handle_compressed( PKT_compressed *cd,
+		       int (*callback)(IOBUF, void *), void *passthru );
 
 /*-- encr-data.c --*/
 int decrypt_data( PKT_encrypted *ed, DEK *dek );
diff -urN gnupg-0.2.11/g10/plaintext.c gnupg-0.2.12/g10/plaintext.c
--- gnupg-0.2.11/g10/plaintext.c	Wed Feb 25 11:41:34 1998
+++ gnupg-0.2.12/g10/plaintext.c	Sat Mar  7 12:52:51 1998
@@ -30,6 +30,7 @@
 #include "ttyio.h"
 #include "filter.h"
 #include "main.h"
+#include "i18n.h"
 
 
 /****************
@@ -58,7 +59,8 @@
 	fname[pt->namelen] = 0;
     }
 
-    if( !*fname ) { /* no filename given; write to stdout */
+    if( !*fname || (*fname=='-' && !fname[1])) {
+	/* no filename or "-" given; write to stdout */
 	fp = stdout;
     }
     else if( overwrite_filep( fname ) )
@@ -178,6 +180,47 @@
   leave:
     m_free(answer);
     return rc;
+}
+
+
+/****************
+ * Hash the given files and append the hash to hash context md.
+ * If FILES is NULL, hash stdin.
+ */
+int
+hash_datafiles( MD_HANDLE md, STRLIST files, int textmode )
+{
+    IOBUF fp;
+    STRLIST sl=NULL;
+    text_filter_context_t tfx;
+    int c;
+
+    if( !files )
+	add_to_strlist( &sl, "-");
+    else
+	sl = files;
+
+    for( ; sl; sl = sl->next ) {
+	fp = iobuf_open( sl->d );
+	if( !fp ) {
+	    log_error(_("can't open signed data '%s'\n"),
+						print_fname_stdin(sl->d));
+	    if( !files )
+		free_strlist(sl);
+	    return G10ERR_OPEN_FILE;
+	}
+	if( textmode ) {
+	    memset( &tfx, 0, sizeof tfx);
+	    iobuf_push_filter( fp, text_filter, &tfx );
+	}
+	while( (c = iobuf_get(fp)) != -1 )
+	    md_putc(md, c );
+	iobuf_close(fp);
+    }
+
+    if( !files )
+	free_strlist(sl);
+    return 0;
 }
 
 
diff -urN gnupg-0.2.11/g10/ringedit.c gnupg-0.2.12/g10/ringedit.c
--- gnupg-0.2.11/g10/ringedit.c	Fri Feb 27 18:13:00 1998
+++ gnupg-0.2.12/g10/ringedit.c	Fri Mar  6 15:53:58 1998
@@ -866,6 +866,8 @@
 	/* append the new data */
 	kbctx=NULL;
 	while( (node = walk_kbnode( root, &kbctx, 0 )) ) {
+		log_info("build_packet(%d)\n",
+			    node->pkt->pkttype );
 	    if( (rc = build_packet( newfp, node->pkt )) ) {
 		log_error("build_packet(%d) failed: %s\n",
 			    node->pkt->pkttype, g10_errstr(rc) );
diff -urN gnupg-0.2.11/g10/sign.c gnupg-0.2.12/g10/sign.c
--- gnupg-0.2.11/g10/sign.c	Mon Mar  2 14:33:32 1998
+++ gnupg-0.2.12/g10/sign.c	Thu Mar  5 14:49:16 1998
@@ -35,6 +35,7 @@
 #include "main.h"
 #include "filter.h"
 #include "ttyio.h"
+#include "i18n.h"
 
 
 
@@ -855,21 +856,23 @@
 
 
 /****************
- * Eine public key aus dem keyring entfernen.
+ * Delete a public or secret key from a keyring.
  */
 int
-delete_key( const char *username )
+delete_key( const char *username, int secret )
 {
     int rc = 0;
     KBNODE keyblock = NULL;
     KBNODE node;
     KBPOS kbpos;
     PKT_public_cert *pkc;
-    u32 pkc_keyid[2];
+    PKT_secret_cert *skc;
+    u32 keyid[2];
     int okay=0;
 
     /* search the userid */
-    rc = find_keyblock_byname( &kbpos, username );
+    rc = secret? find_secret_keyblock_byname( &kbpos, username )
+	       : find_keyblock_byname( &kbpos, username );
     if( rc ) {
 	log_error("%s: user not found\n", username );
 	goto leave;
@@ -878,40 +881,77 @@
     /* read the keyblock */
     rc = read_keyblock( &kbpos, &keyblock );
     if( rc ) {
-	log_error("%s: certificate read problem: %s\n", username, g10_errstr(rc) );
+	log_error("%s: read problem: %s\n", username, g10_errstr(rc) );
 	goto leave;
     }
 
     /* get the keyid from the keyblock */
-    node = find_kbnode( keyblock, PKT_PUBLIC_CERT );
+    node = find_kbnode( keyblock, secret? PKT_SECRET_CERT:PKT_PUBLIC_CERT );
     if( !node ) {
-	log_error("Oops; public key not found anymore!\n");
+	log_error("Oops; key not found anymore!\n");
 	rc = G10ERR_GENERAL;
 	goto leave;
     }
 
-    pkc = node->pkt->pkt.public_cert;
-    keyid_from_pkc( pkc, pkc_keyid );
+    if( secret ) {
+	skc = node->pkt->pkt.secret_cert;
+	keyid_from_skc( skc, keyid );
+    }
+    else {
+	pkc = node->pkt->pkt.public_cert;
+	keyid_from_pkc( pkc, keyid );
+	rc = seckey_available( keyid );
+	if( !rc ) {
+	    log_error(_(
+	    "there is a secret key for this public key!\n"));
+	    log_info(_(
+	    "use option \"--delete-secret-key\" to delete it first.\n"));
+	    rc = -1;
+	}
+	else if( rc != G10ERR_NO_SECKEY )
+	    log_error("%s: get secret key: %s\n", username, g10_errstr(rc) );
+	else
+	    rc = 0;
+    }
 
-    if( opt.batch && opt.answer_yes )
+    if( rc )
+	rc = 0;
+    else if( opt.batch && secret )
+	log_error(_("can't do that in batch-mode\n"));
+    else if( opt.batch && opt.answer_yes )
 	okay++;
     else if( opt.batch )
-	log_error("can't do that in batch-mode without \"--yes\"\n");
+	log_error(_("can't do that in batch-mode without \"--yes\"\n"));
     else {
 	char *p;
 	size_t n;
 
-	tty_printf("pub  %4u%c/%08lX %s   ",
-		  nbits_from_pkc( pkc ),
-		  pubkey_letter( pkc->pubkey_algo ),
-		  pkc_keyid[1], datestr_from_pkc(pkc) );
-	p = get_user_id( pkc_keyid, &n );
+	if( secret )
+	    tty_printf("sec  %4u%c/%08lX %s   ",
+		      nbits_from_skc( skc ),
+		      pubkey_letter( skc->pubkey_algo ),
+		      keyid[1], datestr_from_skc(skc) );
+	else
+	    tty_printf("pub  %4u%c/%08lX %s   ",
+		      nbits_from_pkc( pkc ),
+		      pubkey_letter( pkc->pubkey_algo ),
+		      keyid[1], datestr_from_pkc(pkc) );
+	p = get_user_id( keyid, &n );
 	tty_print_string( p, n );
 	m_free(p);
 	tty_printf("\n\n");
 
-	p = tty_get("Delete this key from the keyring? ");
+	p = tty_get(_("Delete this key from the keyring? "));
 	tty_kill_prompt();
+	if( secret && answer_is_yes(p)) {
+	    /* I think it is not required to check a passphrase; if
+	     * the user is so stupid to let others access his secret keyring
+	     * (and has no backup) - it is up him to read some very
+	     * basic texts about security.
+	     */
+	    m_free(p);
+	    p = tty_get(_("This is a secret key! - really delete? "));
+	}
 	if( answer_is_yes(p) )
 	    okay++;
 	m_free(p);
diff -urN gnupg-0.2.11/g10/trustdb.c gnupg-0.2.12/g10/trustdb.c
--- gnupg-0.2.11/g10/trustdb.c	Mon Mar  2 21:03:22 1998
+++ gnupg-0.2.12/g10/trustdb.c	Sat Mar  7 11:57:50 1998
@@ -836,7 +836,7 @@
     while( !(rc=enum_secret_keys( &enum_context, skc) ) ) {
 	/* fixed: to be sure that it is a secret key of our own,
 	 *	  we should check it, but this needs a passphrase
-	 *	  for every key and this boring for the user.
+	 *	  for every key and this is boring for the user.
 	 *	  Solution:  Sign the secring and the trustring
 	 *		     and verify this signature during
 	 *		     startup
@@ -912,7 +912,7 @@
 	putchar(' ');
     }
     putchar('\"');
-    print_string( stdout, p, n );
+    print_string( stdout, p, n, 0 );
     putchar('\"');
     putchar('\n');
     m_free(p);
@@ -1520,13 +1520,18 @@
 		assert(p);
 		*p = 0;
 		if( access( fname, F_OK ) ) {
-		  #if __MINGW32__
-		    if( mkdir( fname ) )
-		  #else
-		    if( mkdir( fname, S_IRUSR|S_IWUSR|S_IXUSR ) )
-		  #endif
-			log_fatal("can't create directory '%s': %s\n",
-				    fname, strerror(errno) );
+		    if( strlen(fname) >= 7
+			&& !strcmp(fname+strlen(fname)-7, "/.gnupg" ) ) {
+		      #if __MINGW32__
+			if( mkdir( fname ) )
+		      #else
+			if( mkdir( fname, S_IRUSR|S_IWUSR|S_IXUSR ) )
+		      #endif
+			    log_fatal("can't create directory '%s': %s\n",
+					fname, strerror(errno) );
+		    }
+		    else
+			log_fatal("directory '%s' does not exist!\n", fname );
 		}
 		*p = '/';
 		create_db( fname );
@@ -1539,7 +1544,7 @@
 	    return 0;
 
 	/* we can verify a signature about our local data (secring and trustdb)
-	 * in ~/.g10/ here */
+	 * in ~/.gnupg/ here */
 	rc = verify_private_data();
 	if( !rc ) {
 	    /* verify, that our own certificates are in the trustDB
diff -urN gnupg-0.2.11/g10/verify.c gnupg-0.2.12/g10/verify.c
--- gnupg-0.2.11/g10/verify.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.12/g10/verify.c	Thu Mar  5 12:57:13 1998
@@ -0,0 +1,87 @@
+/* verify.c - verify signed data
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <assert.h>
+
+#include "options.h"
+#include "packet.h"
+#include "errors.h"
+#include "iobuf.h"
+#include "keydb.h"
+#include "memory.h"
+#include "util.h"
+#include "main.h"
+#include "filter.h"
+#include "ttyio.h"
+#include "i18n.h"
+
+
+
+/****************
+ * Assume that the input is a signature and verify it without
+ * generating any output.  With no arguments, the sigature packet
+ * is read from stdin (it may be a detached signature when not
+ * used in batch mode). If only a sigfile is given, is maybe a complete
+ * signature or a detached signature in which case the signed stuff
+ * is expected from stdin. With more than 1 argument, the first should
+ * be a detached signature and the remaining files are the signed stuff.
+ */
+
+int
+verify_signatures( int nfiles, char **files )
+{
+    IOBUF fp;
+    armor_filter_context_t afx;
+    const char *sigfile;
+    int i, rc;
+    STRLIST sl;
+
+    sigfile = nfiles? *files : NULL;
+
+    /* open the signature file */
+    fp = iobuf_open(sigfile);
+    if( !fp ) {
+	log_error(_("can't open '%s'\n"), print_fname_stdin(sigfile));
+	return G10ERR_OPEN_FILE;
+    }
+
+    if( !opt.no_armor ) {
+	if( use_armor_filter( fp ) ) {
+	    memset( &afx, 0, sizeof afx);
+	    iobuf_push_filter( fp, armor_filter, &afx );
+	}
+    }
+
+    sl = NULL;
+    for(i=1 ; i < nfiles; i++ )
+	add_to_strlist( &sl, files[i] );
+    rc = proc_signature_packets( fp, sl );
+    free_strlist(sl);
+    iobuf_close(fp);
+    return rc;
+}
+
+
+
diff -urN gnupg-0.2.11/include/ChangeLog gnupg-0.2.12/include/ChangeLog
--- gnupg-0.2.11/include/ChangeLog	Fri Feb 13 13:19:48 1998
+++ gnupg-0.2.12/include/ChangeLog	Tue Mar  3 15:11:53 1998
@@ -0,0 +1,5 @@
+Tue Mar  3 15:11:21 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* cipher.h (random.h): Add new header and move all relevalt
+	functions to this header.
+
diff -urN gnupg-0.2.11/include/cipher.h gnupg-0.2.12/include/cipher.h
--- gnupg-0.2.11/include/cipher.h	Mon Mar  2 19:21:17 1998
+++ gnupg-0.2.12/include/cipher.h	Tue Mar  3 15:11:17 1998
@@ -34,6 +34,7 @@
 #endif
 #include "../cipher/blowfish.h"
 #include "../cipher/elgamal.h"
+#include "../cipher/random.h"
 
 
 #define CIPHER_ALGO_NONE	 0
@@ -78,10 +79,6 @@
 int check_pubkey_algo( int algo );
 int check_digest_algo( int algo );
 
-/*-- random.c --*/
-int  quick_random_gen( int onoff );
-void randomize_buffer( byte *buffer, size_t length, int level );
-byte get_random_byte( int level );
 
 /*-- smallprime.c --*/
 extern ushort small_prime_numbers[];
diff -urN gnupg-0.2.11/include/errors.h gnupg-0.2.12/include/errors.h
--- gnupg-0.2.11/include/errors.h	Tue Feb 10 13:17:16 1998
+++ gnupg-0.2.12/include/errors.h	Fri Feb 27 10:38:43 1998
@@ -58,5 +58,6 @@
 #define G10ERR_CLOSE_FILE     36
 #define G10ERR_RENAME_FILE    37
 #define G10ERR_DELETE_FILE    38
+#define G10ERR_UNEXPECTED     39
 
 #endif /*G10_ERRORS_H*/
diff -urN gnupg-0.2.11/include/util.h gnupg-0.2.12/include/util.h
--- gnupg-0.2.11/include/util.h	Fri Feb 13 14:54:09 1998
+++ gnupg-0.2.12/include/util.h	Fri Feb 27 10:38:43 1998
@@ -101,10 +101,13 @@
 
 /*-- fileutil.c --*/
 char *make_filename( const char *first_part, ... );
+const char *print_fname_stdin( const char *s );
+const char *print_fname_stdout( const char *s );
+
 
 /*-- miscutil.c --*/
 u32 make_timestamp(void);
-void print_string( FILE *fp, byte *p, size_t n );
+void print_string( FILE *fp, byte *p, size_t n, int delim );
 int answer_is_yes( const char *s );
 
 /*-- strgutil.c --*/
diff -urN gnupg-0.2.11/po/cat-id-tbl.c gnupg-0.2.12/po/cat-id-tbl.c
--- gnupg-0.2.11/po/cat-id-tbl.c	Mon Mar  2 22:03:10 1998
+++ gnupg-0.2.12/po/cat-id-tbl.c	Fri Mar  6 17:10:31 1998
@@ -30,45 +30,50 @@
   {"encryption only with symmetric cipher", 11},
   {"store only", 12},
   {"decrypt data (default)", 13},
-  {"list keys", 14},
-  {"check signatures on a key in the keyring", 15},
-  {"show the fingerprints", 16},
-  {"list only the sequence of packets", 17},
-  {"generate a new key pair", 18},
-  {"make a signature on a key in the keyring", 19},
-  {"remove key from the public keyring", 20},
-  {"edit a key signature", 21},
-  {"change the passphrase of your secret keyring", 22},
-  {"generate a revocation certificate", 23},
-  {"export keys", 24},
-  {"import/merge keys", 25},
+  {"verify a signature", 14},
+  {"list keys", 15},
+  {"list keys and signatures", 16},
+  {"check key signatures", 17},
+  {"list keys and fingerprints", 18},
+  {"generate a new key pair", 19},
+  {"make a signature on a key in the keyring", 20},
+  {"remove key from the public keyring", 21},
+  {"edit a key signature", 22},
+  {"change the passphrase of your secret keyring", 23},
+  {"generate a revocation certificate", 24},
+  {"export keys", 25},
+  {"import/merge keys", 26},
+  {"list only the sequence of packets", 27},
+  {"De-Armor a file or stdin", 28},
+  {"En-Armor a file or stdin", 29},
+  {"print all message digests", 30},
   {"\
 \\v\n\
 Options:\n\
- ", 26},
-  {"create ascii armored output", 27},
-  {"use as output file", 28},
-  {"use this user-id to sign or decrypt", 29},
-  {"use this user-id for encryption", 30},
-  {"verbose", 31},
-  {"set compress level (0 disables)", 32},
-  {"use canonical text mode", 33},
-  {"don't make any changes", 34},
-  {"batch mode: never ask", 35},
-  {"assume yes on most questions", 36},
-  {"assume no on most questions", 37},
-  {"add this keyring to the list of keyrings", 38},
-  {"add this secret keyring to the list", 39},
-  {"read options from file", 40},
-  {"set debugging flags", 41},
-  {"enable full debugging", 42},
-  {"write status info to this fd", 43},
-  {"do not write comment packets", 44},
-  {"(default is 1)", 45},
-  {"(default is 3)", 46},
-  {"select default cipher algorithm", 47},
-  {"select default puplic key algorithm", 48},
-  {"select default message digest algorithm", 49},
+ ", 31},
+  {"create ascii armored output", 32},
+  {"use this user-id to sign or decrypt", 33},
+  {"use this user-id for encryption", 34},
+  {"set compress level (0 disables)", 35},
+  {"use canonical text mode", 36},
+  {"use as output file", 37},
+  {"verbose", 38},
+  {"don't make any changes", 39},
+  {"batch mode: never ask", 40},
+  {"assume yes on most questions", 41},
+  {"assume no on most questions", 42},
+  {"add this keyring to the list of keyrings", 43},
+  {"add this secret keyring to the list", 44},
+  {"read options from file", 45},
+  {"set debugging flags", 46},
+  {"enable full debugging", 47},
+  {"write status info to this fd", 48},
+  {"do not write comment packets", 49},
+  {"(default is 1)", 50},
+  {"(default is 3)", 51},
+  {"select default cipher algorithm", 52},
+  {"select default puplic key algorithm", 53},
+  {"select default message digest algorithm", 54},
   {"\
 \\v\n\
 Examples:\n\
@@ -77,41 +82,51 @@
  -sat [file]                make a clear text signature\n\
  -sb  [file]                make a detached signature\n\
  -k   [userid]              show keys\n\
- -kc  [userid]              show fingerprint\n", 50},
-  {"Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n", 51},
-  {"Usage: gpg [options] [files] (-h for help)", 52},
+ -kc  [userid]              show fingerprint\n", 55},
+  {"Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n", 56},
+  {"Usage: gpgm [options] [files] (-h for help)", 57},
+  {"Usage: gpg [options] [files] (-h for help)", 58},
+  {"\
+Syntax: gpgm [options] [files]\n\
+GNUPG maintenance utility\n", 59},
   {"\
 Syntax: gpg [options] [files]\n\
 sign, check, encrypt or decrypt\n\
-default operation depends on the input data\n", 53},
-  {"usage: gpg [options] ", 54},
-  {"conflicting commands\n", 55},
-  {"selected cipher algorithm is invalid\n", 56},
-  {"selected pubkey algorithm is invalid\n", 57},
-  {"selected digest algorithm is invalid\n", 58},
-  {"completes-needed must be greater than 0\n", 59},
-  {"marginals-needed must be greater than 1\n", 60},
-  {"note: no default option file '%s'\n", 61},
-  {"option file '%s': %s\n", 62},
-  {"reading options from '%s'\n", 63},
-  {"failed to initialize the TrustDB: %s\n", 64},
-  {"--store [filename]", 65},
-  {"--symmetric [filename]", 66},
-  {"--encrypt [filename]", 67},
-  {"--sign [filename]", 68},
-  {"--sign --encrypt [filename]", 69},
-  {"--clearsign [filename]", 70},
-  {"--sign-key username", 71},
-  {"--edit-sig username", 72},
-  {"--delete-key username", 73},
-  {"--change-passphrase [username]", 74},
-  {"can't open '%s'\n", 75},
-  {"-k[v][v][v][c] [keyring]", 76},
-  {"--gen-key", 77},
-  {"[filename]", 78},
+default operation depends on the input data\n", 60},
+  {"usage: gpgm [options] ", 61},
+  {"usage: gpg [options] ", 62},
+  {"conflicting commands\n", 63},
+  {"selected cipher algorithm is invalid\n", 64},
+  {"selected pubkey algorithm is invalid\n", 65},
+  {"selected digest algorithm is invalid\n", 66},
+  {"completes-needed must be greater than 0\n", 67},
+  {"marginals-needed must be greater than 1\n", 68},
+  {"note: no default option file '%s'\n", 69},
+  {"option file '%s': %s\n", 70},
+  {"reading options from '%s'\n", 71},
+  {"failed to initialize the TrustDB: %s\n", 72},
+  {"--store [filename]", 73},
+  {"--symmetric [filename]", 74},
+  {"--encrypt [filename]", 75},
+  {"--sign [filename]", 76},
+  {"--sign --encrypt [filename]", 77},
+  {"--clearsign [filename]", 78},
+  {"--decrypt [filename]", 79},
+  {"--sign-key username", 80},
+  {"--edit-sig username", 81},
+  {"--delete-secret-key username", 82},
+  {"--delete-key username", 83},
+  {"--change-passphrase [username]", 84},
+  {"can't open %s: %s\n", 85},
+  {"-k[v][v][v][c] [userid] [keyring]", 86},
+  {"--gen-key", 87},
+  {"dearmoring failed: %s\n", 88},
+  {"enarmoring failed: %s\n", 89},
+  {"[filename]", 90},
+  {"can't open '%s'\n", 91},
   {"\
 No ownertrust defined for %lu:\n\
-%4u%c/%08lX %s \"", 79},
+%4u%c/%08lX %s \"", 92},
   {"\
 \"\n\
 \n\
@@ -124,89 +139,89 @@
  3 = I trust marginally\n\
  4 = I trust fully\n\
  s = please show me more informations\n\
-\n", 80},
-  {"Your decision? ", 81},
+\n", 93},
+  {"Your decision? ", 94},
   {"\
 It's up to you to assign a value here; this value will never be exported\n\
 to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n\
-to do with the (implicitly created) web-of-certificates.\n", 82},
-  {"You will see a list of signators etc. here\n", 83},
+to do with the (implicitly created) web-of-certificates.\n", 95},
+  {"You will see a list of signators etc. here\n", 96},
   {"\
 Could not find a valid trust path to the key.  Lets see, wether we\n\
 can assign some missing owner trust values.\n\
-\n", 84},
+\n", 97},
   {"\
 No ownertrust values changed.\n\
-\n", 85},
+\n", 98},
   {"\
 It is NOT certain, that the key belongs to his owner.\n\
 If you *really* know what you are doing, you may answer\n\
 the next question with yes\n\
-\n", 86},
+\n", 99},
   {"\
 You did not specify a user ID. (you may use \"-r\")\n\
-\n", 87},
-  {"Enter the user ID: ", 88},
-  {"writing self signature\n", 89},
-  {"Key generation can only be used in interactive mode\n", 90},
+\n", 100},
+  {"Enter the user ID: ", 101},
+  {"writing self signature\n", 102},
+  {"Key generation can only be used in interactive mode\n", 103},
   {"\
 Please select the algorithm to use:\n\
    (1) ElGamal is the suggested one.\n\
-   (2) DSA can only be used for signatures.\n", 91},
-  {"   (3) RSA cannot be used in the U.S.\n", 92},
-  {"Your selection? (1,2,3) ", 93},
-  {"Your selection? (1,2) ", 94},
-  {"Sorry; DSA is not yet supported.\n", 95},
+   (2) DSA can only be used for signatures.\n", 104},
+  {"   (3) RSA cannot be used in the U.S.\n", 105},
+  {"Your selection? (1,2,3) ", 106},
+  {"Your selection? (1,2) ", 107},
+  {"Sorry; DSA is not yet supported.\n", 108},
   {"\
 About to generate a new %s keypair.\n\
               minimum keysize is  768 bits\n\
               default keysize is 1024 bits\n\
-    highest suggested keysize is 2048 bits\n", 96},
-  {"What keysize do you want? (1024) ", 97},
-  {"DSA does only allow keysizes from 512 to 1024\n", 98},
-  {"keysize too small; 768 is smallest value allowed.\n", 99},
-  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 100},
-  {"Are you sure, that you want this keysize? ", 101},
-  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 102},
-  {"Requested keysize is %u bits\n", 103},
-  {"rounded up to %u bits\n", 104},
+    highest suggested keysize is 2048 bits\n", 109},
+  {"What keysize do you want? (1024) ", 110},
+  {"DSA does only allow keysizes from 512 to 1024\n", 111},
+  {"keysize too small; 768 is smallest value allowed.\n", 112},
+  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 113},
+  {"Are you sure, that you want this keysize? ", 114},
+  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 115},
+  {"Requested keysize is %u bits\n", 116},
+  {"rounded up to %u bits\n", 117},
   {"\
 \n\
 You need a User-ID to identify your key; the software constructs the user id\n\
 from Real Name, Comment and Email Address in this form:\n\
     \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n\
-\n", 105},
-  {"Real name: ", 106},
-  {"Invalid character in name\n", 107},
-  {"Name may not start with a digit\n", 108},
-  {"Name must be at least 5 characters long\n", 109},
-  {"Email address: ", 110},
-  {"Not a valid email address\n", 111},
-  {"Comment: ", 112},
-  {"Invalid character in comment\n", 113},
+\n", 118},
+  {"Real name: ", 119},
+  {"Invalid character in name\n", 120},
+  {"Name may not start with a digit\n", 121},
+  {"Name must be at least 5 characters long\n", 122},
+  {"Email address: ", 123},
+  {"Not a valid email address\n", 124},
+  {"Comment: ", 125},
+  {"Invalid character in comment\n", 126},
   {"\
 You selected this USER-ID:\n\
     \"%s\"\n\
-\n", 114},
-  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 115},
+\n", 127},
+  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 128},
   {"\
 You need a Passphrase to protect your secret key.\n\
-\n", 116},
+\n", 129},
   {"\
 You don't what a passphrase - this is probably a *bad* idea!\n\
 I will do it anyway.  You can change your passphrase at anytime,\n\
 using this program with the option \"--change-passphrase\"\n\
-\n", 117},
-  {"passphrase not correctly repeated; try again.\n", 118},
-  {"writing public certificate to '%s'\n", 119},
-  {"writing secret certificate to '%s'\n", 120},
+\n", 130},
+  {"passphrase not correctly repeated; try again.\n", 131},
+  {"writing public certificate to '%s'\n", 132},
+  {"writing secret certificate to '%s'\n", 133},
   {"\
 We need to generate a lot of random bytes. It is a good idea to perform\n\
 some other action (work in another window, move the mouse, utilize the\n\
 network and the disks) during the prime generation; this gives the random\n\
-number generator a better chance to gain enough entropy.\n", 121},
-  {"public and secret key created and signed.\n", 122},
-  {"Key generation failed: %s\n", 123},
+number generator a better chance to gain enough entropy.\n", 134},
+  {"public and secret key created and signed.\n", 135},
+  {"Key generation failed: %s\n", 136},
 };
 
-int _msg_tbl_length = 123;
+int _msg_tbl_length = 136;
diff -urN gnupg-0.2.11/po/gnupg.pot gnupg-0.2.12/po/gnupg.pot
--- gnupg-0.2.11/po/gnupg.pot	Mon Mar  2 22:03:08 1998
+++ gnupg-0.2.12/po/gnupg.pot	Sat Mar  7 12:16:15 1998
@@ -1,6 +1,6 @@
 msgid ""
 msgstr ""
-"Date: 1998-03-02 22:03:08+0100\n"
+"Date: 1998-03-07 12:16:14+0100\n"
 "From: Werner Koch <wk@frodo>\n"
 "Content-Type: text/plain; charset=\n"
 "Xgettext-Options: --default-domain=gnupg --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
@@ -10,18 +10,18 @@
 msgid "Warning: using insecure memory!\n"
 msgstr ""
 
-#: cipher/random.c:146
+#: cipher/random.c:381
 msgid ""
 "\n"
 "Not enough random bytes available.  Please do some other work to give\n"
 "the OS a chance to collect more entropy! (Need %d more bytes)\n"
 msgstr ""
 
-#: cipher/random.c:186
+#: cipher/random.c:421
 msgid "warning: using insecure random number generator!!\n"
 msgstr ""
 
-#: cipher/random.c:187
+#: cipher/random.c:422
 msgid ""
 "The random number generator is only a kludge to let\n"
 "it compile - it is in no way a strong RNG!\n"
@@ -30,188 +30,208 @@
 "\n"
 msgstr ""
 
-#: g10/g10.c:46
+#: g10/g10.c:56
 msgid ""
 "\\vCommands:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:48
+#: g10/g10.c:59
 msgid "make a signature"
 msgstr ""
 
-#: g10/g10.c:49
+#: g10/g10.c:60
 msgid "make a clear text signature"
 msgstr ""
 
-#: g10/g10.c:50
+#: g10/g10.c:61
 msgid "make a detached signature"
 msgstr ""
 
-#: g10/g10.c:51
+#: g10/g10.c:62
 msgid "encrypt data"
 msgstr ""
 
-#: g10/g10.c:52
+#: g10/g10.c:63
 msgid "encryption only with symmetric cipher"
 msgstr ""
 
-#: g10/g10.c:53
+#: g10/g10.c:64
 msgid "store only"
 msgstr ""
 
-#: g10/g10.c:54
+#: g10/g10.c:65
 msgid "decrypt data (default)"
 msgstr ""
 
-#: g10/g10.c:55
+#: g10/g10.c:66
+msgid "verify a signature"
+msgstr ""
+
+#: g10/g10.c:68
 msgid "list keys"
 msgstr ""
 
-#: g10/g10.c:56
-msgid "check signatures on a key in the keyring"
+#: g10/g10.c:69
+msgid "list keys and signatures"
 msgstr ""
 
-#: g10/g10.c:57
-msgid "show the fingerprints"
+#: g10/g10.c:70
+msgid "check key signatures"
 msgstr ""
 
-#: g10/g10.c:58
-msgid "list only the sequence of packets"
+#: g10/g10.c:71
+msgid "list keys and fingerprints"
 msgstr ""
 
-#: g10/g10.c:59
+#: g10/g10.c:73
 msgid "generate a new key pair"
 msgstr ""
 
-#: g10/g10.c:60
+#: g10/g10.c:74
 msgid "make a signature on a key in the keyring"
 msgstr ""
 
-#: g10/g10.c:61
+#: g10/g10.c:75
 msgid "remove key from the public keyring"
 msgstr ""
 
-#: g10/g10.c:62
+#: g10/g10.c:76
 msgid "edit a key signature"
 msgstr ""
 
-#: g10/g10.c:63
+#: g10/g10.c:77
 msgid "change the passphrase of your secret keyring"
 msgstr ""
 
-#: g10/g10.c:64
+#: g10/g10.c:78
 msgid "generate a revocation certificate"
 msgstr ""
 
-#: g10/g10.c:65
+#: g10/g10.c:80
 msgid "export keys"
 msgstr ""
 
-#: g10/g10.c:66
+#: g10/g10.c:81
 msgid "import/merge keys"
 msgstr ""
 
-#: g10/g10.c:68
+#: g10/g10.c:82
+msgid "list only the sequence of packets"
+msgstr ""
+
+#: g10/g10.c:84
+msgid "De-Armor a file or stdin"
+msgstr ""
+
+#: g10/g10.c:85
+msgid "En-Armor a file or stdin"
+msgstr ""
+
+#: g10/g10.c:86
+msgid "print all message digests"
+msgstr ""
+
+#: g10/g10.c:91
 msgid ""
 "\\v\n"
 "Options:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:70
+#: g10/g10.c:94
 msgid "create ascii armored output"
 msgstr ""
 
-#: g10/g10.c:71
-msgid "use as output file"
-msgstr ""
-
-#: g10/g10.c:72
+#: g10/g10.c:95
 msgid "use this user-id to sign or decrypt"
 msgstr ""
 
-#: g10/g10.c:73
+#: g10/g10.c:96
 msgid "use this user-id for encryption"
 msgstr ""
 
-#: g10/g10.c:74
-msgid "verbose"
-msgstr ""
-
-#: g10/g10.c:75
+#: g10/g10.c:97
 msgid "set compress level (0 disables)"
 msgstr ""
 
-#: g10/g10.c:76
+#: g10/g10.c:98
 msgid "use canonical text mode"
 msgstr ""
 
-#: g10/g10.c:77
+#: g10/g10.c:100
+msgid "use as output file"
+msgstr ""
+
+#: g10/g10.c:101
+msgid "verbose"
+msgstr ""
+
+#: g10/g10.c:102
 msgid "don't make any changes"
 msgstr ""
 
-#: g10/g10.c:78
+#: g10/g10.c:103
 msgid "batch mode: never ask"
 msgstr ""
 
-#: g10/g10.c:79
+#: g10/g10.c:104
 msgid "assume yes on most questions"
 msgstr ""
 
-#: g10/g10.c:80
+#: g10/g10.c:105
 msgid "assume no on most questions"
 msgstr ""
 
-#: g10/g10.c:81
+#: g10/g10.c:106
 msgid "add this keyring to the list of keyrings"
 msgstr ""
 
-#: g10/g10.c:82
+#: g10/g10.c:107
 msgid "add this secret keyring to the list"
 msgstr ""
 
-#: g10/g10.c:83
+#: g10/g10.c:108
 msgid "read options from file"
 msgstr ""
 
-#: g10/g10.c:85
+#: g10/g10.c:110
 msgid "set debugging flags"
 msgstr ""
 
-#: g10/g10.c:86
+#: g10/g10.c:111
 msgid "enable full debugging"
 msgstr ""
 
-#: g10/g10.c:87
+#: g10/g10.c:112
 msgid "write status info to this fd"
 msgstr ""
 
-#: g10/g10.c:88
+#: g10/g10.c:113
 msgid "do not write comment packets"
 msgstr ""
 
-#: g10/g10.c:89
+#: g10/g10.c:114
 msgid "(default is 1)"
 msgstr ""
 
-#: g10/g10.c:90
+#: g10/g10.c:115
 msgid "(default is 3)"
 msgstr ""
 
-#: g10/g10.c:91
+#: g10/g10.c:117
 msgid "select default cipher algorithm"
 msgstr ""
 
-#: g10/g10.c:92
+#: g10/g10.c:118
 msgid "select default puplic key algorithm"
 msgstr ""
 
-#: g10/g10.c:93
+#: g10/g10.c:119
 msgid "select default message digest algorithm"
 msgstr ""
 
-#: g10/g10.c:95
+#: g10/g10.c:123
 msgid ""
 "\\v\n"
 "Examples:\n"
@@ -223,125 +243,159 @@
 " -kc  [userid]              show fingerprint\n"
 msgstr ""
 
-#: g10/g10.c:144
+#: g10/g10.c:201
 msgid "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"
 msgstr ""
 
-#: g10/g10.c:148
+#: g10/g10.c:206
+msgid "Usage: gpgm [options] [files] (-h for help)"
+msgstr ""
+
+#: g10/g10.c:208
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:151
+#: g10/g10.c:213
+msgid ""
+"Syntax: gpgm [options] [files]\n"
+"GNUPG maintenance utility\n"
+msgstr ""
+
+#: g10/g10.c:216
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
 "default operation depends on the input data\n"
 msgstr ""
 
-#: g10/g10.c:226
+#: g10/g10.c:293
+msgid "usage: gpgm [options] "
+msgstr ""
+
+#: g10/g10.c:295
 msgid "usage: gpg [options] "
 msgstr ""
 
-#: g10/g10.c:265
+#: g10/g10.c:335
 msgid "conflicting commands\n"
 msgstr ""
 
-#: g10/g10.c:278
+#: g10/g10.c:348
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:280
+#: g10/g10.c:350
 msgid "selected pubkey algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:282
+#: g10/g10.c:352
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:284
+#: g10/g10.c:354
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:286
+#: g10/g10.c:356
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:374
+#: g10/g10.c:449
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:378
+#: g10/g10.c:453
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:385
+#: g10/g10.c:460
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:533
+#: g10/g10.c:656
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
-#: g10/g10.c:539
+#: g10/g10.c:662
 msgid "--store [filename]"
 msgstr ""
 
-#. encrypt the given file only with the symmetric cipher
-#: g10/g10.c:547
+#: g10/g10.c:670
 msgid "--symmetric [filename]"
 msgstr ""
 
-#: g10/g10.c:554
+#: g10/g10.c:678
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:567
+#: g10/g10.c:691
 msgid "--sign [filename]"
 msgstr ""
 
 #. sign and encrypt the given file
-#: g10/g10.c:580
+#: g10/g10.c:704
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:594
+#: g10/g10.c:718
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:602
+#: g10/g10.c:730
+msgid "--decrypt [filename]"
+msgstr ""
+
+#: g10/g10.c:738
 msgid "--sign-key username"
 msgstr ""
 
 #. Edit a key signature
-#: g10/g10.c:610
+#: g10/g10.c:746
 msgid "--edit-sig username"
 msgstr ""
 
-#: g10/g10.c:618
+#: g10/g10.c:754
+msgid "--delete-secret-key username"
+msgstr ""
+
+#: g10/g10.c:757
 msgid "--delete-key username"
 msgstr ""
 
-#: g10/g10.c:626
+#: g10/g10.c:765
 msgid "--change-passphrase [username]"
 msgstr ""
 
-#. list the given keyring
-#: g10/g10.c:641 g10/g10.c:661 g10/g10.c:718
-msgid "can't open '%s'\n"
+#. -kv userid keyring
+#: g10/g10.c:786
+msgid "can't open %s: %s\n"
 msgstr ""
 
-#: g10/g10.c:672
-msgid "-k[v][v][v][c] [keyring]"
+#: g10/g10.c:797
+msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr ""
 
-#: g10/g10.c:677
+#. generate a key (interactive)
+#: g10/g10.c:803
 msgid "--gen-key"
 msgstr ""
 
-#: g10/g10.c:716
+#: g10/g10.c:844
+msgid "dearmoring failed: %s\n"
+msgstr ""
+
+#: g10/g10.c:852
+msgid "enarmoring failed: %s\n"
+msgstr ""
+
+#: g10/g10.c:933
 msgid "[filename]"
 msgstr ""
 
+#: g10/g10.c:935
+msgid "can't open '%s'\n"
+msgstr ""
+
 #: g10/pkclist.c:65
 msgid ""
 "No ownertrust defined for %lu:\n"
@@ -418,30 +472,30 @@
 msgid "Key generation can only be used in interactive mode\n"
 msgstr ""
 
-#: g10/keygen.c:305
+#: g10/keygen.c:307
 msgid ""
 "Please select the algorithm to use:\n"
 "   (1) ElGamal is the suggested one.\n"
 "   (2) DSA can only be used for signatures.\n"
 msgstr ""
 
-#: g10/keygen.c:309
+#: g10/keygen.c:311
 msgid "   (3) RSA cannot be used in the U.S.\n"
 msgstr ""
 
-#: g10/keygen.c:318
+#: g10/keygen.c:320
 msgid "Your selection? (1,2,3) "
 msgstr ""
 
-#: g10/keygen.c:320
+#: g10/keygen.c:322
 msgid "Your selection? (1,2) "
 msgstr ""
 
-#: g10/keygen.c:334
+#: g10/keygen.c:336
 msgid "Sorry; DSA is not yet supported.\n"
 msgstr ""
 
-#: g10/keygen.c:347
+#: g10/keygen.c:349
 msgid ""
 "About to generate a new %s keypair.\n"
 "              minimum keysize is  768 bits\n"
@@ -449,39 +503,39 @@
 "    highest suggested keysize is 2048 bits\n"
 msgstr ""
 
-#: g10/keygen.c:355
+#: g10/keygen.c:357
 msgid "What keysize do you want? (1024) "
 msgstr ""
 
-#: g10/keygen.c:361
+#: g10/keygen.c:363
 msgid "DSA does only allow keysizes from 512 to 1024\n"
 msgstr ""
 
-#: g10/keygen.c:363
+#: g10/keygen.c:365
 msgid "keysize too small; 768 is smallest value allowed.\n"
 msgstr ""
 
-#: g10/keygen.c:365
+#: g10/keygen.c:367
 msgid "Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n"
 msgstr ""
 
-#: g10/keygen.c:367
+#: g10/keygen.c:369
 msgid "Are you sure, that you want this keysize? "
 msgstr ""
 
-#: g10/keygen.c:371
+#: g10/keygen.c:373
 msgid "Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n"
 msgstr ""
 
-#: g10/keygen.c:381
+#: g10/keygen.c:383
 msgid "Requested keysize is %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:384 g10/keygen.c:388
+#: g10/keygen.c:386 g10/keygen.c:390
 msgid "rounded up to %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:395
+#: g10/keygen.c:397
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
@@ -490,57 +544,56 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:407
+#: g10/keygen.c:409
 msgid "Real name: "
 msgstr ""
 
-#: g10/keygen.c:411
+#: g10/keygen.c:413
 msgid "Invalid character in name\n"
 msgstr ""
 
-#: g10/keygen.c:413
+#: g10/keygen.c:415
 msgid "Name may not start with a digit\n"
 msgstr ""
 
-#: g10/keygen.c:415
+#: g10/keygen.c:417
 msgid "Name must be at least 5 characters long\n"
 msgstr ""
 
-#: g10/keygen.c:423
+#: g10/keygen.c:425
 msgid "Email address: "
 msgstr ""
 
-#: g10/keygen.c:435
+#: g10/keygen.c:437
 msgid "Not a valid email address\n"
 msgstr ""
 
-#: g10/keygen.c:443
+#: g10/keygen.c:445
 msgid "Comment: "
 msgstr ""
 
-#. no comment is okay
-#: g10/keygen.c:449
+#: g10/keygen.c:451
 msgid "Invalid character in comment\n"
 msgstr ""
 
-#: g10/keygen.c:469
+#: g10/keygen.c:471
 msgid ""
 "You selected this USER-ID:\n"
 "    \"%s\"\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:471
+#: g10/keygen.c:473
 msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
 msgstr ""
 
-#: g10/keygen.c:503
+#: g10/keygen.c:505
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:514
+#: g10/keygen.c:516
 msgid ""
 "You don't what a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at anytime,\n"
@@ -548,19 +601,19 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:520
+#: g10/keygen.c:522
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr ""
 
-#: g10/keygen.c:537
+#: g10/keygen.c:539
 msgid "writing public certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:538
+#: g10/keygen.c:540
 msgid "writing secret certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:550
+#: g10/keygen.c:552
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -568,10 +621,10 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:625
+#: g10/keygen.c:627
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:636
+#: g10/keygen.c:638
 msgid "Key generation failed: %s\n"
 msgstr ""
diff -urN gnupg-0.2.11/tools/Makefile.in gnupg-0.2.12/tools/Makefile.in
--- gnupg-0.2.11/tools/Makefile.in	Mon Mar  2 22:47:53 1998
+++ gnupg-0.2.12/tools/Makefile.in	Sat Mar  7 12:57:56 1998
@@ -228,6 +228,17 @@
 	  || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
 	  || cp -p $$d/$$file $(distdir)/$$file; \
 	done
+bftest.o: bftest.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/blowfish.h ../include/../cipher/elgamal.h \
+	../include/../cipher/random.h ../include/i18n.h
+clean-sat.o: clean-sat.c
+mpicalc.o: mpicalc.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/i18n.h
 
 info:
 dvi:
diff -urN gnupg-0.2.11/util/ChangeLog gnupg-0.2.12/util/ChangeLog
--- gnupg-0.2.11/util/ChangeLog	Fri Feb 27 10:37:07 1998
+++ gnupg-0.2.12/util/ChangeLog	Sat Mar  7 11:55:02 1998
@@ -1,3 +1,16 @@
+Sat Mar  7 11:54:35 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* miscutil.c (print_string): New arg delim; changed all callers.
+
+Thu Mar  5 12:19:30 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* errors.c: New strings.
+
+Thu Mar  5 12:06:31 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* iobuf.c (iobuf_open): A name of "-" now opens stdin.
+	* fileutil.c (print_fname_stdout, print_fname_stdin): New.
+
 Fri Feb 27 10:20:03 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* memory.c (m_is_secure): Removed.
diff -urN gnupg-0.2.11/util/errors.c gnupg-0.2.12/util/errors.c
--- gnupg-0.2.11/util/errors.c	Mon Feb 23 13:11:24 1998
+++ gnupg-0.2.12/util/errors.c	Thu Mar  5 12:20:38 1998
@@ -64,9 +64,13 @@
       X(NI_PUBKEY      ,"Unimplemented pubkey algorithm")
       X(NI_CIPHER      ,"Unimplemented cipher algorithm")
       X(SIG_CLASS      ,"Unknown signature class")
-      X(TRUSTDB        ,"TrustDB error")
+      X(TRUSTDB        ,"Trust database error")
       X(BAD_CERT       ,"Bad certificate")
-      X(INV_USER_ID    ,"malformed user id")
+      X(INV_USER_ID    ,"Malformed user id")
+      X(CLOSE_FILE     ,"File close error")
+      X(RENAME_FILE    ,"File rename error")
+      X(DELETE_FILE    ,"File delete error")
+      X(UNEXPECTED     ,"Unexpected data")
 
       default: p = buf; sprintf(buf, "g10err=%d", err); break;
     }
diff -urN gnupg-0.2.11/util/fileutil.c gnupg-0.2.12/util/fileutil.c
--- gnupg-0.2.11/util/fileutil.c	Mon Feb 23 13:11:24 1998
+++ gnupg-0.2.12/util/fileutil.c	Thu Mar  5 12:05:09 1998
@@ -64,3 +64,26 @@
     return name;
 }
 
+
+/****************
+ * A simple function to decide, wether the filename ist stdout
+ * or a real filename.
+ */
+const char *
+print_fname_stdout( const char *s )
+{
+    if( !s || (*s == '-' && !s[1]) )
+	return "[stdout]";
+    return s;
+}
+
+
+const char *
+print_fname_stdin( const char *s )
+{
+    if( !s || (*s == '-' && !s[1]) )
+	return "[stdin]";
+    return s;
+}
+
+
diff -urN gnupg-0.2.11/util/iobuf.c gnupg-0.2.12/util/iobuf.c
--- gnupg-0.2.11/util/iobuf.c	Mon Feb 23 13:11:24 1998
+++ gnupg-0.2.12/util/iobuf.c	Thu Mar  5 12:06:30 1998
@@ -371,7 +371,7 @@
     file_filter_ctx_t *fcx;
     size_t len;
 
-    if( !fname ) {
+    if( !fname || (*fname=='-' && !fname[1])  ) {
 	fp = stdin; /* fixme: set binary mode for msdoze */
 	fname = "[stdin]";
     }
diff -urN gnupg-0.2.11/util/miscutil.c gnupg-0.2.12/util/miscutil.c
--- gnupg-0.2.11/util/miscutil.c	Mon Feb 23 13:11:24 1998
+++ gnupg-0.2.12/util/miscutil.c	Sat Mar  7 11:54:32 1998
@@ -37,13 +37,21 @@
  * Print a string to FP, but filter all control characters out.
  */
 void
-print_string( FILE *fp, byte *p, size_t n )
+print_string( FILE *fp, byte *p, size_t n, int delim )
 {
     for( ; n; n--, p++ )
-	if( iscntrl( *p ) ) {
+	if( iscntrl( *p ) || *p == delim ) {
 	    putc('\\', fp);
 	    if( *p == '\n' )
 		putc('n', fp);
+	    else if( *p == '\r' )
+		putc('r', fp);
+	    else if( *p == '\f' )
+		putc('f', fp);
+	    else if( *p == '\v' )
+		putc('v', fp);
+	    else if( *p == '\b' )
+		putc('b', fp);
 	    else if( !*p )
 		putc('0', fp);
 	    else
